#!/usr/bin/perl -w
# -*- Mode: cperl -*-
# Check restart on fortran 90 and C.
# Should be alright for fortran 77, despite not efficient.
# Prepare rebuild of index using previous index file.
# Split this file.
# Separate OS dependant files.
#|########################################################################
# ftagshtml: transforms fortran 90 or below and C source code
#            into HTML or PostScript or PDF building calls indexes.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
# \section{Start}
#|########################################################################
BEGIN {
  unless (exists $ENV{'FTAGSHTML_DIR'} && -d "$ENV{FTAGSHTML_DIR}") {
    # Sets the default shared location for ftagshtml:
    $ENV{'FTAGSHTML_DIR'} = '/usr/share/ftagshtml' ;
    unless (-d "$ENV{FTAGSHTML_DIR}") {
      die "Environment variable FTAGSHTML_DIR unknown or $ENV{FTAGSHTML_DIR} not a directory" ;
    }
  }
  (@INC)=("$ENV{FTAGSHTML_DIR}/lib/perl", @INC) ;
}
use lib "$ENV{FTAGSHTML_DIR}/lib/perl";
#use lib "$ENV{FTAGSHTML_DIR}/lib/perl/ftagshtml";
#|########################################################################
use Getopt::Long;
use File::Copy ;
&GetOptions("cgi=s", "code=s", "conf=s", "debug","f90","getin_format=s", "help","hevea","I:s","labels:s","l2h","latex","latexindex","nocolor","nofile","nojava","nolinenum","nostyle","numperindex=i","php", "t=s","u","v=i","version","w=s","www=s");
$fontify::HR = '<IMG SRC="color.gif" WIDTH=100%><BR>' unless $opt_u ;
$fontify::HR = '<HR>' if $opt_u ;
$debug = 0;
$debug = $opt_debug if $opt_debug ;
$cgi = $opt_cgi if $opt_cgi ;
$php = $opt_php if $opt_php ;
if ($opt_nojava) {
  $java = 0 ;
}
unless ($opt_nojava) {
  $java = 1 ;
}
$version = 0.513;
# 0.506: with input and hevea capabilities, bugs unfree.
# 0.5061: with an experimental javascript file browser.
# 0.507: modularisation of the restart, experimental browser is accepted, you may need
#        power.
#        This is the first release on http://www.sourceforge.net the VA-Linux site.
# 0.508: added stylesheets and fragmentation of the biggest indexes.
#        DONE=Tue Jan 30 02:04:36 CET 2001.
#        Default behaviour of ftagshtml becomes: java browser, colors, stylesheets,
#        line numbers.
#########################################################
# 0.509: bug fixes around C-fortran communication. (3 weeks): DONE
#   0.520: bug fixes with the input files usage. (6 weeks): DONE
#   0.521: some better restart, especially when involving includes. (6 weeks): CHECK
#        CURRENT=Thursday Feb 8 00:14:00 CET 2001.
# New release is set to 0.510
# This release is considered to be fully functional.
# New functionalities will be added only on requests by end users.
# Release 0.510 is OK for restart on fortran and C. There is no much
# warantee it works well on fortran 90 since I do not have examples to test
# on. I know array realuses for instance will be wrong.
# If you touch all the dependencies of all the files you modify, it should be OK.
# New release is set to 0.511:
# Same as 0.510 plus few bugs correction, newer main routine index.
# Adding rpm file for Linux installation.
# Adding cgi option for installation on a Web server.
#    CGI option project:
#    A search feature based on getin: getin will find the files to look for
#    and present the result in the "index" frame. Target will be rached clicking
#    on the link that will call another CGI script, capable of viewing an HTML
#    file nicely doing a search on its non HTML source.
#    Presentation will be headed.
#    So, from an ftagshtml file, call getin.pl then call view.pl.
#    All these features should be available on both http and file systems.
#    Announcement: april 2001.
# Trying to make this option compatible with php option that will be equivalent to cgi.
#########################################################
# New release is set to 0.512:
# Improved CGI features.
#########################################################
# 1.000: a better written application, making this file no longer enormous. (4 weeks)
# 1.001: some comments introduced: should become a shared development project. (4 weeks)
# 1.002: graphic run interface. (6 weeks)
# 1.003: javascript browsing features. (4 weeks)
# 1.004: CGI features added using PHP and Perl on Apache Web Server. (6 weeks)
#        This will give place to developping getin software, the one that makes
#        clever searches in fortran and C.
$requireversion = 0.510;
$currentversion = $version ;
require 5.003;
if ($opt_version) {
  print "ftagshtml version $version\n";
  exit();
}
unless ($opt_version) {
  print STDOUT "\tVersion $version\n";
}
$opt_v = 0 unless $opt_v ;
if ($opt_help) {
  use ftagshtml::defaults ;
  &defaults::ftagshtml_help ;
}
unless ($opt_help) {
  print STDOUT "\tHelp available using -help command line option\n";
}
$t0=time;
$tn=$t0 ;
$| = 1;				# flush stdout with every print -- gives better feedback during
				# long computations
#|#######################################################
print STDOUT "0) Initializing.\n";
die "Environment variable FTAGSHTML_DIR unknown" unless $ENV{FTAGSHTML_DIR};
if ($opt_I) {
  @TAGSHTML_PATH = (split ( /:/, $opt_I)) ;
  print "\tInclude PATH is @TAGSHTML_PATH.\n";
} else {
  @TAGSHTML_PATH = () ;
}
if ($opt_labels) {
  (@LABELS) = (split ( /:/, $opt_labels)) ;
  $nosave = 1 ;
  foreach $label (@LABELS) {
    if ($label =~ /(.*)\//) {
      if ($opt_www) {
	$URL = $opt_www . '/' . $1 ;
      } else {
	$URL = "../../$1" ;
      }
    } else {
      if ($opt_www) {
	$URL = $opt_www ;
      } else {
	$URL = "../.." ;
      }
    }
    require("$label") if (-e "$label") ;
  }
}
#################################
@listoflatexhtml = ("bol", "eol", "bul", "eul", "br", "li",  "chapter", "sepline", "DeclareNolabel", "DeclareLabel", "DeclareRef", "liste", "iliste", "Private_Called", "Private_Calls", "Private_Defines", "Private_Used", "Private_Uses", "Private_Includes", "Private_Included", "Private_Inputs", "Private_Inputed", "IncludeLabel", "IncludeRef", "IncludeNolabel", "InputNolabel", "InputLabel","scomment","ecomment") ;
foreach $fonction (@listoflatexhtml) {
  $delegue{"$fonction"} = "$fonction" ;
}
sub TalkInLaTeXOrHtml {
  local($lang,%fonctions)=@_ ;
  local(%affiche)=();
  while (($cle,$valeur) = each %fonctions) {
    $affiche{$cle} = "${lang}::$valeur";
  }
  return(%affiche);
}    
use ftagshtml::html;
use ftagshtml::LaTeX;
#use ftagshtml::latex;
use ftagshtml::searchfc ;
use ftagshtml::fichiers ;
use ftagshtml::index ;
use ftagshtml::javanavig ;
use ftagshtml::restart ;
$lang="html";
(%affiche)=(&TalkInLaTeXOrHtml($lang,%delegue));
print STDOUT "Using library $ENV{FTAGSHTML_DIR}/lib/perl\n" ;
&LaTeX::chapter("toto") ;
#################################"
unless (@ARGV) {
  use ftagshtml::defaults ;
  &defaults::ftagshtml_help ;
}
#|#######################################################
# \section{Initialisation}
# L'criture par dfaut sous entend que le pwd local est
# identique au pwd distant... Si ce n'est pas le cas,
# utilisez l'option -w.
#|#######################################################
#%########################################################    
$osname = "$^O";
$unix{"linux"} = 1 ;
$unix{"solaris"} = 1 ;
$unix{"sunos"} = 1 ;
$unix{"hpux"} = 1 ;
$unix{"aix"} = 1 ;
$unix{"irix"} = 1 ;
$unix{"unicos"} = 1 ;
$unix{"darwin"} = 1 ;
$linux = 0 ;
if (($osname =~ /x/i) || (exists $unix{$osname})) {
  print "\tI guess $osname is a flavour of Unix\n";
  $unix{$osname} = 1 ;
} else {
  warn "\tYour system is not Unix like :'$osname' is not known as Unix.\n";
  warn "\tUpgrade to Unix or Linux to get better performance.\n";
}
unless (exists $unix{$osname}) {
  if ($osname =~ /win/i) {
    die "The OS $osname is not Unix compatible.\n";
  }
  if ($osname =~ /mac/i) {
    die "The OS $osname is not implemented yet.\n";
  }
}
$linux = 1 if $unix{$osname} ;
use Cwd ;
$DIRW = cwd ;
if ($unix{$osname}) {
  chop ($HOST=`hostname`);
} else {
  $HOST = "localhost.localdomain";
}
$RepCodeSource = &fichiers::basename($DIRW) ;
$RepCodeSource = $opt_code if $opt_code ;
$Myname = &fichiers::basename($0) ;
if ($Myname =~ /(.*)\./) {
  $Myname = $1 ;
}
$USER = (getpwuid ($<))[0] ;
#|#######################################################
use ftagshtml::fontify ;
&fontify::ftagshtml_color ;
if ($opt_nostyle) {
  print STDOUT "\tNo Style sheets used.";
}
;
if (!$java) {
  print STDOUT "\tJavascript index from Marcelino Alves Martins (martins\@hks.com) December '97.\n";
  print STDOUT "\tScript found in 'http://www.geocities.com/Paris/LeftBank/2178/'.\n";
} elsif ($opt_v >= 1) {
  print STDOUT "\tNo Javascript index from Marcelino Alves Martins.\n";
}
if ($java) {
  use ftagshtml::javaindex ;
}
if ($opt_l2h) {
  print STDOUT "\tLaTeX2HTML: Construction of the database.\n";
} elsif ($opt_v >= 1) {
  print STDOUT "\tLaTeX2HTML: No construction of the database.\n";
}
if ($opt_f90) {
  print STDOUT "\tFortran .f extension is considered to be in fortran 90\n";
} else {
  print STDOUT "\tFortran .f extension is considered to be in fortran 77\n";
}
$Full_Html = 0 ;
if ($opt_latex) {
  print STDOUT "\tComments under free format\n";
  $Full_Html = 1 ;
}
if (!$opt_nolinenum) {
  print STDOUT "\tLine numbers printed out in output files.\n";
  $num_affiche=10;
}
if (!$opt_nofile) {
  print STDOUT "\tRoutine names printed out in output files.\n";
  $num_affiche=10;
}
unless (!$opt_nolinenum) {
  print STDOUT "\tYou can print line numbers using option  -n.\n";
}
unless (!$opt_nofile) {
  print STDOUT "\tYou can print routine names using option -file.\n";
}
&fontify::InitCodeComments("any") ;
if (!$opt_nocolor) {
  print STDOUT "\tFortran shall be fontified.\n";
} else {
  print STDOUT "\tPourquoi n'utilisez-vous pas l'option -C de fontification ?\n";
} 
print STDOUT "\tCode $RepCodeSource on $HOST:\n";
print STDOUT "\t\t$DIRW.\n";
$DIRE="$DIRW/HTML/$Myname" ;
$DIRC="$DIRW" ;
#|#######################################################
if ($opt_t) {
  $DIRC=$opt_t ;
}
if ($opt_w) {
  $DIRE=$opt_w ;
}
$DIRE = &fichiers::CheminAbsoluDeAaB($DIRC,$DIRE);
print STDOUT "\tReading root is\n\t '$DIRC'.\n";
print STDOUT "\tWriting root is\n\t '$DIRE'.\n";
#|#######################################################
$reuse = 0 ;
if (open(INFO,"<$DIRE/ftagshtml.info")) {
  close(INFO) ;
  $reuse = 1 ;
} elsif (opendir MONDIRECTOIRE, "$DIRE") {
  print STDOUT "** Writing onto an existing directory is forbidden. **\n";
  print STDOUT "** Please destroy $DIRE yourself**\n";
  exit 1;
} else {
  print STDOUT "\tCreating directory\n\t\t$DIRE.\n"; 
  &fichiers::RecursiveMkdir($DIRE) ;
  &fichiers::UnixCopy("$ENV{'FTAGSHTML_DIR'}/doc/img/color.gif","$DIRE/color.gif") ;
  &fichiers::UnixCopy("$ENV{'FTAGSHTML_DIR'}/doc/img/ftagshtml.jpg","$DIRE/ftagshtml.jpg") ;
  &fontify::writesheet ;
  &CGI_conf if $opt_conf ;
}
if (opendir MONDIRECTOIRE, "$DIRE") {
  closedir MONDIRECTOIRE;
} else {
  die " ** Write access denied on $DIRE **";
}
unless ($opt_latexindex) {
  print STDOUT "\tNo creation of LaTeX index.\n";
}
if ($opt_hevea) {
  print STDOUT "\tUse of the hevea translator:\n\t Congratulations for being a literate programmer.\n";
}
unless ($opt_hevea) {
  print STDOUT "\tUse of the incorporated poor LaTeX translator.\n";
}

#|#######################################################
# \section{Initialisation}
sub InitTypes {
  @listec = () ;
  @listef77 = () ;
  @listef90 = () ;
  @listehf77 = () ;
  @listehf90 = () ;
  @listehc = () ;
}
%label = () ;
@listetex = () ;
@Appellees = ();
@Appelants = ();
%liste_exclu = () ;
@File_Of_Rout = () ;
%realcalled = () ;
%realcalls = () ;
%father = () ;

$nbarg=0;
#|#######################################################
# \section{Lecture du fortran}
print STDOUT "1) Definitions detection.\n";
&StageDefinition(@ARGV) ;
#|#######################################################
print STDOUT "2) Calls and includes detection.\n";
&StageCallInclude ;
#|#######################################################
print STDOUT "3) Writing HTML output files.\n";
&StageHtml ;
#|#######################################################
print STDOUT "4) Creating index.\n";
&StageIndex ;
#|#######################################################
$t1=time;
print STDOUT "5) Programme over within ",$t1-$t0," seconds.\n";
if ($opt_www) {
  if ($opt_conf) {
    print STDOUT "You must update Apache Path\n\t$cgi/../lib/perl/getin/conf/$opt_conf.pm,\nprobably $ENV{FTAGSHTML_DIR}/lib/perl/getin/conf/$opt_conf.pm\n" ;
  }
  print STDOUT "netscape -remote 'openURL($opt_www)' \&\n";
} else {
  print STDOUT "netscape -remote 'openURL(file:$DIRE/progindex.html)' \&\n";
}
#|#######################################################
sub StageDefinition {
  &InitTypes ;
  if ($reuse) {
    print STDOUT "\t1) Reusing info file ftagshtml.info.\n";
    require "$DIRE/ftagshtml.info";
    if ($debug) {
      if (open(INFO,">$DIRE/ftagshtml.debug")) {
	print STDOUT "\t1) Debug info in ftagshtml.debug\n" ;
	*INFO_Definition = INFO ;
	*INFO_Definition = INFO ;
	&restart::StageRestartDefinition ;
      } else {
	die "Impossible to create the new info file tagsnew" ;
      }
    } else {
      &restart::StageRestartDefinition ;
    }
  } else {
    if ($debug) {
      if (open(INFO,">$DIRE/ftagshtml.debug")) {
	print STDOUT "\t1) Debug info in ftagshtml.debug\n" ;
      } else {
	*INFO_Definition = INFO ;
	*INFO = STDOUT ;
      }
    }
    &Determine_Types(@ARGV);
  }
  if (@listef77) {
    print"\t1) Tags are read for f77.\n";
    &Lecture_Tags("fortran", @listef77) ;
    print"\t\t[OK] in ".&duree." seconds.\n";
  }
  if (@listec) {
    print"\t1) Tags are read for C.\n";
    &Lecture_Tags("C", @listec) ;
    print"\t\t[OK] in ".&duree." seconds.\n";
  }
  if (@listef90) {
    print"\t1) Tags are read for f90.\n";
    &GetTags_F90(@listef90) ;
    print"\t\t[OK] in ".&duree." seconds.\n";
  }
}
#|#######################################################
sub StageCallInclude {
  print"\t2) Source files are analyzed for includes:\n";
  &GetFilesAndInclude_F77(@listef77) if (@listef77);
  &GetFilesAndInclude_C(@listec) if (@listec);
  &GetFilesAndInclude_F90(@listef90) if (@listef90);
  print"\t\t(".&duree."s).\n";
  if ($reuse) {
    &InitTypes ;
    if ($debug) {
      open(INFOTWO,">$DIRE/ftagshtml.info2") or die "Impossible to create debug file" ;
      &restart::TagsInfo(INFOTWO) ;
      &restart::CallsInfo(INFOTWO) ;
      close(INFOTWO) ;
      *INFO_Include = INFO ;
      *INFO_Include = INFO ;
    }
    &restart::StageRestartCallInclude ;
  }
  if ($reuse) {
    if ((@listehf77)||(@listehf90)||(@listehc)) {
      print"\t2) Include files are analyzed for includes:\n";
      &GetFilesAndInclude_F77(@listehf77) if (@listehf77);
      &GetFilesAndInclude_C(@listehc) if (@listehc);
      &GetFilesAndInclude_F90(@listehf90) if (@listehf90);
      print"\t\t(".&duree."s).\n";
    }
  }
  if (@listetex) {
    print STDOUT "\t2) Detection of the input labels.\n" ;
    if ($reuse) {
      &restart::GetTexRefresh ;
    }
    &GetTexLabel(@listetex) ;
  }
  print "\t2) Reports:\n";
  if (%liste_exclu) {
    print "\t\tInclude files not found: ".(keys %liste_exclu)."\n";
  }
  if (%input_exclu) {
    print "\t\tInput files not found: ".(keys %input_exclu)."\n";
  }
  if (($opt_v >= 1) && ($opt_v >= 2)) {
    $nbinf=$#listehf77+1;
    print STDOUT "\t\tincludes fortran 77:$nbinf.\n";
    $nbinf=$#listehf90+1;
    print STDOUT "\t\tincludes fortran 90:$nbinf.\n";
    $nbinc=$#listehc+1;
    print STDOUT "\t\tincludes C:$nbinc.\n";
    if ($opt_v > 5) {
      foreach $file (@listehc) {
	print "$file\n";
      }
    }
    $nbarg=$#listehf77+$#listehf90+$#listehc+$#listetex+$#ARGV+1;
    print STDOUT "\t\tLe nombre de fichiers  traiter est de $nbarg.\n" ;
  }
  $t1=time;
  print STDOUT "\t\tTime used: ",$t1-$t0," seconds.\n" ;
}
#|#######################################################
sub StageHtml {
  if ($reuse) {
    *INFO_Html = INFO ;
    *INFO_Html = INFO ;
    &restart::UpdateCallers ;
    &restart::RemoveObsoleteInStar ;
    &restart::AddSourcesToRehtml ;
  }
  if (($debug) && ($reuse)) {
    open(INFOTHREE,">$DIRE/ftagshtml.info3") or die "Impossible to create debug file" ;
  } else {
    open(INFOTHREE,">$DIRE/ftagshtml.info") or die "Impossible to create debug file" ;
  } 
  &restart::TagsInfo(INFOTHREE) ;
  &restart::CallsInfo(INFOTHREE) ;
  print INFOTHREE "# Generated by $0\n";
  print INFOTHREE "\(\@INCLUDES_PATH\) = \(";
  foreach $a (@TAGSHTML_PATH) {
    print INFOTHREE "'$a', ";
  }
  print INFOTHREE "\)\;\n";
  print INFOTHREE "1;\n";
  close(INFOTHREE) ;
  &javaindex::WriteSystem if $java ;
  %indice = () ;
  if (@listef77) {
    print STDOUT "\t3) Setting up fortran 77 source code.\n\t";
    &Fontification_Html_Du_F77("code",@listef77) ;
    $t1=time;
    print STDOUT "\t(",&duree," seconds).\n" ;
  }
  if (@listehf77) {
    print STDOUT "\t3) Setting up fortran 77 include files.\n\t";
    &Fontification_Html_Du_F77("include",@listehf77) ;
    $t1=time;
    print STDOUT "\t(",&duree," seconds).\n" ;
  }
  if (@listef90) {
    print STDOUT "\t3) Setting up fortran 90 source code.\n\t";
    &Fontification_Html_Du_F90("code",@listef90);
    $t1=time;
    print STDOUT "\t(",&duree," seconds).\n" ;
  }
  if (@listehf90) {
    print STDOUT "\t3) Setting up fortran 90 include files.\n\t";
    &Fontification_Html_Du_F90("include",@listehf90);
    $t1=time;
    print STDOUT "\t(",&duree," seconds).\n" ;
  }
  if (@listec) {
    print STDOUT "\t3) Setting up C source code.\n\t";
    &Fontification_Html_Du_C("code",@listec) ;
    $t1=time;
    print STDOUT "\t(",&duree," seconds).\n" ;
  }
  if (@listehc) {
    print STDOUT "\t3) Setting up C include files.\n\t";
    &Fontification_Html_Du_C("include",@listehc) ;
    $t1=time;
    print STDOUT "\t(",&duree," seconds).\n" ;
  }
  if (%{latexinputed}) {
    print STDOUT "\t3) Setting up tex documentation.\n";
    print STDOUT "\t\t";
    # restarttex lists the complete points were tex files have been updated.
    if ($reuse) {
      &index::Fontification_Html_Du_Tex(@restarttex) ;
    } else {
      &index::Fontification_Html_Du_Tex(@listetex) ;
    }
    $t1=time;
    print STDOUT "\t(",&duree," seconds).\n" ;
  }
  $t1=time;
  print STDOUT "\t3) Time used: ",$t1-$t0," seconds.\n" ;
}
#|#######################################################
sub StageIndex {
  #|#########################
  # \chapter{Ecriture des index}
  #|#########################
  print STDOUT "\tMain:      ";
  &index::Index_Principal ;
  print STDOUT "\t[OK] (".&duree." s).\n";
  print STDOUT "\tFiles:     ";
  &index::Index_Fichiers(\@ARGV) ;
  print STDOUT "\t[OK] (".&duree." s).\n";
  print STDOUT "\tRoutines:  ";
  &index::Index_Routines ;
  print STDOUT "\t[OK] (".&duree." s).\n";
  print STDOUT "\tFunctions: ";
  &index::Index_Fonctions ;
  print STDOUT "\t[OK] (".&duree." s).\n";
  print STDOUT "\tIncludes:  ";
  &index::Index_Include ;
  print STDOUT "\t[OK] (".&duree." s).\n";
  print STDOUT "\tModules:   ";
  &index::Index_Modules ;
  print STDOUT "\t[OK] (".&duree." s).\n";
  print STDOUT "\tJava:      ";
  &javanavig::javanavig;
  print STDOUT "\t[OK] (".&duree." s).\n";
  # Pour les fichiers en input on suppose qu'ils sont entirement en {\LaTeX}:
  if (%{latexinputed}) {
    $Full_Html=1;
    print STDOUT "\tInput:     ";
    &index::Index_Input ;
    print STDOUT "\t[OK] (".&duree." s).\n";
  }
  if ($opt_l2h) {
    print STDOUT "\tLaTeX2HTML:";
    &index::latex2html ;
    print STDOUT "\t[OK] (".&duree." s).\n";
  }
  $t1=time;
  print STDOUT "\n\tOver in ",$t1-$t0," seconds.\n" ;
  if ($opt_latexindex) {
    print STDOUT "\tCreating the LaTeX index...";
    &index::Index_T_Latex ;
    print STDOUT "\t[ok]\n";
    print STDOUT "\tOn $DIRE,\n\tTex index file index.tex created.\n";
    print STDOUT "\t\tMaster documents are Sindex and Lindex.\n";
    if ( $opt_v >= 1 ) {
      print STDOUT "\t\tLaTeX Compilation:\n" ;
      print STDOUT "cd $DIRE; latex Sindex; latex Sindex\n";
      print STDOUT "dvips -f Sindex.dvi>Sindex.ps\n" ;
      print STDOUT "\t\tor:\n" ;
      print STDOUT "cd $DIRE; latex Lindex; latex Lindex\n";
      print STDOUT "dvips -f Lindex.dvi>Lindex.ps\n" ;
      print STDOUT "\t\tPDF creation: (assumes you installed pdflatex)\n" ;
      print STDOUT "pdflatex Lindex\n" ;
    }
  }
  if ($debug) {
    close(INFO) ;
  }
}
#|#######################################################
sub duree {
  $tp=$tn ;
  $tn=time;
  return($tn-$tp) ;
}
#|#######################################################
sub LatexBuiltinProcess {
  local($ligne)=@_;
  $ligne=RefDeclare($ligne);
  $ligne=LatexProcess($ligne);
  return($ligne);
}
#|#######################################################
sub First_Line_Analysis {
  my($ligne)=@_;
  my($is_Full_Html)=0;
  if ($ligne =~ /(.*?)\%(.*)/) {
    $ligne = $2 ;
    if ($ligne =~ /\bHTML\b/) {
      $is_Full_Html = 1;
    }
  }
  if ($is_Full_Html != $Full_Html) {
    &fontify::InitCodeComments("void") ;
  }
  return($is_Full_Html);
}
#|#######################################################
sub LatexProcess {
  local($ligne)=@_;
  if ($ligne =~ /(.*?)\%/) {	# A ce niveau la ligne peut contenir des tags...
    local($r)=$1;
    if ($ligne =~ /(.*?)\%.*?\<(.*)/) {
      $ligne = $1.'<'.$2 ;
    } else {
      $ligne = $r unless ($r =~ /\\/);
    }
  }
  if ($ligne =~ /\\[`'^"]/) {
    $ligne =~ s/\\\^([aeiouAEIOU])/&${1}circ;/g ;
    $ligne =~ s/\\\'([aeiouAEIOU])/&${1}acute;/g ;
    $ligne =~ s/\\\`([aeiouAEIOU])/&${1}grave;/g ;
    $ligne =~ s/\\\"([aeiouAEIOU])/&${1}uml;/g ;
    $ligne =~ s/\\\~([aeiouAEIOU])/&${1}tilde;/g ;
  }
  if ($ligne =~ /verbatim/) {
    if ($ligne =~ /(.*?)\\end\{verbatim\}(.*)/) {
      if ($Full_Html) {
	$ligne = "$1".&fontify::end_verbatim."</PRE>".&fontify::start_comment."$2" ;
      } else {
	$ligne = "$1".&fontify::end_verbatim."$2" ;
      }
      $Verbatim_Style = 0;
    }
    if ($ligne =~ /(.*?)\\begin\{verbatim\}(.*)/) {
      if ($Full_Html) {
	#NAJ: possible bug due to brutal FONT tag instead of fontify::end_type...
	$ligne = $1."</FONT><PRE>".&fontify::start_verbatim."$2" ;
      } else {
	$ligne = "$1".&fontify::start_verbatim."$2" ;
      }
      $Verbatim_Style = 1;
    }
  }
  return ($ligne) if $Verbatim_Style ;
  if ($ligne =~ /\\end\{\w+\}/) {
    if ($ligne =~ /(.*?)\\end\{enumerate\}(.*)/) {
      $ligne = $1."</ol>".$2 ;
    }
    if ($ligne =~ /(.*?)\\end\{itemize\}(.*)/) {
      $ligne = $1."</ul>".$2 ;
    }
    if ($ligne =~ /(.*?)\\end\{description\}(.*)/) {
      $ligne = $1."</ul>".$2 ;
    }
    if ($ligne =~ /(.*?)\\end\{(definition|remark|modif|proof)\}(.*)/) {
      if (exists $indice{$2}) {
	$ligne = "$1"."<BR>End of $2 (".$indice{$2}.") &curren;&curren;&curren;</I>\n<BR>"."$3" ;
      } else {
	print "End is INKNOWN='$ligne'.\n";
	print "file=$file,l=$., on =$2\n" ;
	$ligne = "$1<BR>End is UNKNOWN &curren;&curren;&curren;</I>\n<BR>$3" ;
      }
    }
  }
  if ($ligne =~ /\\begin\{\w+\}/) {
    if ($ligne =~ /(.*?)\\begin\{enumerate\}(.*)/) {
      $ligne = $1."<ol>".$2 ;
    } elsif ($ligne =~ /(.*?)\\begin\{itemize\}(.*)/) {
      $ligne = $1."<ul>".$2 ;
    } elsif ($ligne =~ /(.*?)\\begin\{description\}(.*)/) {
      $ligne = $1."<ul>".$2 ;
    } elsif ($ligne =~ /(.*?)\\begin\{definition\}\[(.*?)\](.*)/) {
      $indice{'definition'}++;
      $ligne = $1."<H4>Definition ($indice{'definition'}) $2</H4><I>".$3 ;
    } elsif ($ligne =~ /(.*?)\\begin\{remark\}\[(.*?)\](.*)/) {
      $indice{'remark'}++;
      $ligne = $1."<H4>Remark ($indice{'remark'}) $2</H4><I>".$3 ;
    } elsif ($ligne =~ /(.*?)\\begin\{modif\}\[(.*?)\](.*)/) {
      $indice{'modif'}++;
      $ligne = $1."<H4>Modification ($indice{'modif'}) de source $2</H4><I>".$3 ;
    } elsif ($ligne =~ /(.*?)\\begin\{proof\}\[(.*?)\](.*)/) {
      $indice{'proof'}++;
      $ligne = $1."<H4>Proof ($indice{'remark'}) $2</H4><I>".$3 ;
    } elsif ($ligne =~ /(.*?)\\begin\{(definition|remark|modif|proof)\}(.*)/) {
      $indice{"$2"}++;
      $ligne = "$1"."<H4>$2 (".$indice{"$2"}.")</H4><I>"."$3" ;
    }
  }
  if ($ligne =~ /(.*)\\item\[(.*?)\](.*)/) {
    $ligne = $1."<li><u><FONT COLOR=$fontify::Couleur_Item>$2</FONT></u>".$3 ;
  } elsif ($ligne =~ /(.*)\\item(.*)/) {
    $ligne = $1."<li>".$2 ;
  }
  if ($ligne =~ /(.*?)\\verb(.)(.*?)\2(.*)/) {
    local($r)=$ligne;
    $ligne ="";
    while ($r =~ /(.*?)\\verb(.)(.*?)\2(.*)/) {
      $ligne .= $1."<CODE>".&fontify::start_verbatim."$3".&fontify::end_verbatim."</CODE>" ;
      if ($4) {
	$r = $4;
      } else {
	$r = "" ; last ;
      }
      ;
    }
    $ligne .= $r ;
  }
  if ($ligne =~ /(section|chapter)\{/) {
    if ($ligne =~ /(.*?)\\chapter\{(.*?)\}(.*)/) {
      $ligne = $1."<H1>$2</H1>".$3 ;
    }
    if ($ligne =~ /(.*?)\\section\{(.*?)\}(.*)/) {
      $ligne = $1."<H2>$2</H2>".$3 ;
    }
    if ($ligne =~ /(.*?)\\subsection\{(.*?)\}(.*)/) {
      $ligne = $1."<H3>$2</H3>".$3 ;
    }
    if ($ligne =~ /(.*?)\\subsubsection\{(.*?)\}(.*)/) {
      $ligne = $1."<H4>$2</H4>".$3 ;
    }
  }
  return($ligne);
}
#|#######################################################
sub LabelDeclare {
  my($file,$ligne)=@_;
  my($cible) = "";
  while ($ligne) {
    if ($ligne =~ /.*?\\label\{([\w\:\.]+)\}(.*)/) {
      my($type) = &Say_Type($file) ;
      if ($type eq "tex") {
	$cible = &fichiers::InputFileOfWrite($file) ;
      } elsif ($type eq "inc") {
	$cible = &fichiers::IncludeFileOfWrite($file) ;
      } else {
	$cible = $file ;
      }
      $label{$1}="${cible}#$1";
      push(@{$revlab{$file}},"$1") ;
      $ligne = $3 ;
    } else {
      $ligne = 0 ;
    }	    
  }
}
#|#######################################################
sub RefDeclare {
  local($ligne)=@_;
  local($commentaire,$loc,$loclab)=("","","");
  while ($ligne) {
    if (($ligne =~ /ref|label/) &&
	($ligne =~ /(.*?)\\(ref|label)\{([\w\:\.]+)\}(.*)/)) {
      $loc=$3 ;
      if ($2 eq "ref") {
	if ($label{$loc}) {
	  $commentaire .= $1 ;
	  ($loclab,$tag) = split (/\#/,$label{$loc});
	  $loclab .= "_c.html" ;
	  $loclab .= "#$tag" if $tag ;
	  $commentaire .= "<A HREF=\"$loclab\" TARGET=\"source\">$loc</A>";
	} else {
	  $commentaire .= $1."<FONT COLOR=RED>$loc</FONT>";
	}
      } elsif ($2 eq "label") {
	if ($label{$loc}) {
	  local($fic,$ref)=split(/\#/,$label{$loc});
	  $commentaire .= $1."<A NAME=$ref><u><blink>$ref</blink></u>:</A>";
	} else {
	  warn "loc=$loc, label=$label{$loc}, ligne=$., file=$file";
	}
      }
      $ligne = $4 ;
    } else {
      $commentaire .= $ligne ;
      $ligne = 0 ;
    }	    
  }
  return ($commentaire);
}
#|#######################################################
sub GetTexLabel {
  local(@liste)=@_;
  foreach $totalFile (@liste) {
    ($a,$file,$b) = &GetInfoRoutineCasei($totalFile) ;
    unless ($file_ref=&fichiers::find_input($file)) {
      $file_ref = $file ;
    }
    $file_ref = &fichiers::InputFileOfWrite ($file_ref) ;
    if (open (INPUT, "<$file")) {
      while (defined($LIGNEINP=<INPUT>)) {
	if (($LIGNEINP) && ($LIGNEINP =~ /label/)) {
	  &LabelDeclare($file_ref,$LIGNEINP) ;
	}
	;
      }
      close(INPUT);
    }
  }
}
#|#######################################################
sub Determine_Includes {
  my (@sourcefiles) = (@_) ;
  my (@includes) = () ;
  my (%hash) = () ;
  my ($include,$cleb) = ("","");
  my ($cle,$val) = ("","");
  my($localRoutine,$localFile,$localNum,$localInclude) = ("","","","");
  foreach $localFile (@sourcefiles) {
    $hash{$localFile} = 1 ;
    #|	print "Determine_Includes localFile=$localFile\n";
  }
  # We analyse the source files.
  while (($include,$cleb) = each %f90included) {
    #|	print "On $include, cleb=$cleb\n";
    if (%{$cleb}) {
      foreach $cle (keys %{$cleb}) {
	last ;
      }				# Uncomprehensible bug...
      ($cle,$val) = (each %{$cleb}) ;
      #|	    print "Include($cle) for $include on $f90included{$include}\n";
      ($localRoutine,$localFile,$localNum) = GetInfoRoutine($cle) if $cle ;
      if (($localFile) && ($hash{$localFile})) {
	($a,$localInclude,$localNum) = GetInfoRoutine($include) ;
	#|		print "Include ok for $localFile=$include\n";
	push(@includes,$localInclude) if $localInclude ;
      }
    }
  }
  return (@includes) ;
}
#|#######################################################
sub Say_Type {
  my($file) = @_ ;
  my($type) = "" ;
  if ( $file =~ /\.(f77|ff|s)$/i ) {
    $type = "f77" ;
  } elsif ( $file =~ /\.(c|cc)$/i ) {
    $type = "C" ;
  } elsif ( $file =~ /\.(f90)$/i ) {
    $type = "f90" ;
  } elsif ( $file =~ /\.(tex|latex|plt)$/i ) {
    $type = "tex" ;
  } elsif ( $file =~ /\.(f)$/i ) {
    if ($opt_f90) {
      $type = "f90" ;
    } else {
      $type = "f77" ;
    }
  } elsif ( $file =~ /\.(fh|ch|h)$/i ) {
    $type = "inc" ;
  }
  return($type) ;
}
#|#######################################################
sub Determine_Types {
  foreach $file (@_) {
    next unless $file ;
    $nbarg++ ; 
    unless (open(FILE,$file)) {
      warn "Error: Source File $file cannot be found" ;
      next ;
    }
    close(FILE) ;
    if ( $file =~ /\.(f77|ff|s)$/i ) {
      push(@listef77,$file);
    } elsif ( $file =~ /\.(c|cc)$/i ) {
      push(@listec,$file);
    } elsif ( $file =~ /\.(f90)$/i ) {
      push(@listef90,$file);
    } elsif ( $file =~ /\.(f)$/i ) {
      if ($opt_f90) {
	push(@listef90,$file);
      } else {
	push(@listef77,$file);
      }
    } else {
      warn "Type is unknown for $file";
    }
  }
}
#|#######################################################
sub GetFilesAndInclude_F77 {
  (@listerest)=(@_);
  while (@listerest) {
    @listebis=();
    print "\t|" ;
    $Compteur_local=0;
    foreach $file (@listerest) {
      $Compteur_local=Etat_Avancement($Compteur_local,$#listerest);
      open(FILE,$file) ;
      print INFO "\t\tprocess 2 $file\n" if $debug ;
      (@listebis)=(@listebis,Get_Include_F77($file)) ;
      $NBL{$file}=$.;
      close(FILE) ;
    }
    (@listerest)=(@listebis);
    foreach $file (@listebis) {
      $R_Include{$file} = "f77" ;
    }
    (@listehf77)=(@listehf77,@listebis);
    print "\n" ;
  }
}
#|#######################################################
sub GetFilesAndInclude_F90 {
  (@listerest)=(@_);
  while (@listerest) {
    @listebis=();
    print "\t|" ;
    $Compteur_local=0;
    foreach $file (@listerest) {
      $Compteur_local=Etat_Avancement($Compteur_local,$#listerest);
      open(FILE,$file) ;
      print INFO "\t\tprocess 2 $file\n" if $debug ;
      &Get_Include_F90($file) ;
      $NBL{$file}=$.;
      close(FILE) ;
    }
    #	&Get_Include_F90(@listerest) ;
    (@listerest)=(@listebis);
    foreach $file (@listebis) {
      $R_Include{$file} = "f90" ;
    }
    (@listehf90)=(@listehf90,@listebis);
    print "\n" ;
  }
}
#|#######################################################
sub GetFilesAndInclude_C {
  (@listerest)=(@_);
  while (@listerest) {
    @listebis=();
    print "\t|";
    $Compteur_local=0;
    foreach $file (@listerest) {
      $Compteur_local=Etat_Avancement($Compteur_local,$#listerest);
      open(FILE,$file) ;
      (@listebis)=(@listebis,Get_Include_C($file)) ;
      $NBL{$file}=$.;
      close(FILE) ;
    }
    (@listerest)=(@listebis);
    foreach $file (@listebis) {
      $R_Include{$file} = "C" ;
    }
    (@listehc)=(@listehc,@listebis);
    print "\n" ;
  }
}

#|#######################################################
sub Get_Include_F77{
  local(@listebis)=();
  local($Routine) = "$file";
  local($RoutEncour) = GetAlias($file);
  $RoutineCasei = GetLowerCase($Routine);
  if (exists $Include_Unique{$file}) {
    $file_ref = $File_Of_Rout{$Include_Unique{$file}};
    $totalRoutine=&GetTotalInclude($file);
  } else {
    $file_ref = $File_Of_Rout{$file};
    $totalRoutine=&GetTotalRoutine($file);
  }
  &fichiers::GetIncludeCibleOfWrite($file_ref);
  while (<FILE>) {
    if (searchfc::Fortran_Comment($_)) {
      if ( /.*\\input\s+([\w_\.\/]+)/i) {
	&Input_Detect($file,$totalRoutine,$.,$1);
      }
      &LabelDeclare("$file","$_") if (/label/) ;
      next ;
    }
    if ( /(subroutine|function|program)/i) {
      if ( /\s+(subroutine|function|program)\s+([\w_]+)/i) {
	$Routine=$2;
	$RoutEncour=&GetAlias($Routine);
	$RoutineCasei = &GetLowerCase($Routine);
	$totalRoutine=&GetTotalRoutine($RoutineCasei);
	&LabelDeclare("${file_ref}","\\label{R_$RoutineCasei}") ;
      }
    } elsif ( /\b(end|include)\b/i) {
      if (/^......\s*\bend\b\s*(.*)/i) {
	if ($1) {
	  ($RoutEncour)=&Fortran_End_Detect($1,$RoutEncour);
	} else {
	  $RoutEncour=$file;
	}
      } elsif ( /^\s+include\s+[\'\"]([\w_\.\/]+)/i) { # "appels de include
	&Include_F90_Detect($file,$totalRoutine,$.,$1);

      }
    } elsif ( $RoutEncour ) {
      ($string,$_,$commentaire) = searchfc::Fortran90_String_Comment("",$_);
      ($Called_local,$Reference,$arg,$Red)=&Call_Detect($_) ;
      while ($Reference) {
	# Fortran cases are meaningless...
	$Called_Minus = &GetAlias($Called_local);
	&AddCallTree($.,$file,$Called_Minus,$totalRoutine,$Reference);
	$Reference = &GetTotalRoutineF($Called_Minus);
	${realcalls{$totalRoutine}}{$Called_Minus} = "$Reference" ;
	${realcalled{$Reference}}{$totalRoutine} = $Called_Minus ;
	($Called_local,$Reference,$arg,$Red)=&Call_Detect($arg) ;
      }
    }
  }
  return(@listebis);
}

#|#######################################################
sub Get_Include_C {
  local(@listebis)=();
  local($Ligne_Next)=0;
  local($Ligne_Actu)=0;
  local($Routine) = "$file";
  if (exists $Include_Unique{$file}) {
    $file_ref = $File_Of_Rout{$Include_Unique{$file}};
    $totalRoutine=&GetTotalInclude($file);
  } else {
    $file_ref = $File_Of_Rout{$file};
    $totalRoutine=&GetTotalRoutine($file);
    #	&GetIncludeCibleOfWrite($file_ref);
  }
  if (exists $lfichiers{$file}) {
    (@list_rout) = (@{$lfichiers{$file}}) ;
    $nextRoutine = shift @list_rout;
    ($NextRoutine,$nextFile,$Ligne_Next) = &GetInfoRoutine($nextRoutine) ;
    $Ligne_Actu=0;
  } else {
    $Ligne_Next = -1 ;
  }
  local($comm) = 0 ;
  local($acco) = 0 ;
  while (<FILE>) {
    $commentaire="";
    $instruction="";
    ($comm,$ligne)=searchfc::C_Instruction_Commentaire($comm,$_);
    if ($commentaire) {
      if ( /.*\\input\s+([\w_\.\/]+)/i) {
	$num = $. ;
	&Input_Detect($file,$totalRoutine,$num,$1);
      }
      &LabelDeclare("$file",$commentaire) if (/label/) ;
    }
    next unless ($instruction);
    if ($. == $Ligne_Next ) {
      $acco = 0 ;
      $Routine = $NextRoutine ;
      $totalRoutine=GetTotalRoutine($Routine);
      $Ligne_Actu=$Ligne_Next;
      &LabelDeclare("${file_ref}","\\label{R_$nextRoutine}") ;
      if ($nextRoutine = shift @list_rout) {
	($NextRoutine,$nextFile,$Ligne_Next) = &GetInfoRoutine($nextRoutine) ;
      }
    }
    ($acco,$accomoved)=&searchfc::C_Accolade($acco,$instruction);
    if ($accomoved) {
      if ($acco == 0) {
	$Routine = "$file" ;
	if (exists $Include_Unique{$file}) {
	  $totalRoutine=&GetTotalInclude($file);
	} else {
	  $totalRoutine=&GetTotalRoutine($Routine);
	}
      }
    }
    if ( $instruction =~ /(include)/i) {
      if ( $instruction =~ /^\#include\s*[\'\"]([\w_\.]*)[\"\']/i) { #"
	&Include_F90_Detect($file,$totalRoutine,$.,$1);
      }
    }
    if (( $Routine ) && ($. != $Ligne_Actu)) {
      ($Called_local,$Reference,$arg,$Red)=Call_Detect($_) ;
      while ($Reference) {
	&AddCallTreeC1($.,$file,$Called_local,$totalRoutine,$Reference);
	($Reference,$Called_local) = &GetTotalRoutineC($Called_local);
	&AddCallTreeC2($.,$file,$Called_local,$totalRoutine,$Reference);
	${realcalls{$totalRoutine}}{$Called_local} = "$Reference" ;
	${realcalled{$Reference}}{$totalRoutine} = $Called_local ;
	($Called_local,$Reference,$arg,$Red)=&Call_Detect($arg) ;
      }
    }
  }
  return(@listebis);
}

#|#######################################################
sub Include_F90_Detect {
  local($file,$Routine,$num,$fichier)=@_;
  local($totalFichier) = "" ;
  if ($include=&fichiers::find_include($fichier)) {
    #	print "Recherche du chemin absolu de $DIRC  $include\n";
    # $include is a unique file name since it is absolute.
    # Any included file that finds its unique name in $include
    # is the same.
    $include = &fichiers::CheminAbsoluDeAaB("$DIRC",$include) ;
    unless ($R_Include{"$include"}) {
      push(@listebis,$include); # This is a new file to add
      $R_Include{"$include"} = 1 ;
    }
    if (exists $Include_Unique{"$include"}) {
      $Include_Alias{$fichier} = $include ;
      $fichier = $Include_Unique{"$include"} ;
    } else {
      $Include_Unique{"$include"} = $fichier ;
      $File_Of_Rout{$fichier} = $include ;
      $File_Of_Rout{$include} = $include ;
      #	    print "Recherche du chemin relatif de $DIRE  $include\n";
      local($fic) = &fichiers::CheminRelatifDeAaB("$DIRE",&fichiers::dirname($include)) ;
      if ($fic) {
	$fic .= '/'.&fichiers::basename($include) ;
      } else {
	$fic = &fichiers::basename($include) ;
      }
      $Include_Alias{$fichier} = $include ;
      #	    print "\t\t$fichier donne $File_Of_Rout{$fichier}\n";
    }
    $totalFichier = "$fichier:$include:0";
  } else {
    $totalFichier = "$fichier:0:0";
    $liste_exclu{$fichier} = 1 ;
    #	print "exclude $fichier\n";
  }
  push(@{${$f90included{$totalFichier}}{$Routine}},$num) ;
  push(@{${$f90includes{$Routine}}{$totalFichier}},$num) ;
}

#|#######################################################
sub GetAlias {
  local($nom)=@_;
  $nom =~ tr/A-Z/a-z/;
  return ($nom);
}

#|#######################################################
sub Call_Detect {
  local($ligne)=@_;
  local($Called_local,$Reference,$nextligne,$Red)=(0,0,0,0);
  $ducon=0;
  if ($ligne =~ /\(/) {
    while ($ligne =~ /.*?\((.*)/) {
      $nextligne = 0 ;
      if ($ligne =~ /([\w_]+)\s*\((.*)/) { # Appel de fonction
	$Called_local = $1 ;
	if ($2) {
	  $nextligne = $2 ;
	}
	;
	$Called_Minus = GetAlias($Called_local);
	if (exists $R_Declar{$Called_local}) {
	  $Reference=$R_Declar{$Called_local}  ;
	} else {
	  $Reference=$R_Declar{$Called_Minus} ;
	}
	if ((!$Reference) && ($ligne =~ /call\s+$Called_local/i)) {
	  $Reference=$Called_Minus ;
	  $Red =1 ;
	}
      }
      if ((!$Reference)&&($nextligne)) {
	$ligne = $nextligne ;
      } else {
	last ;
      }
      if ($ducon++ >= 20) {
	warn "Error: Looping file '$file' line $.: Reference=$Reference, nextligne='$nextligne'";
	return(0,0,0,0);
      }
    }
  }
  if ((!$Reference) && ($ligne =~ /call/i)) {
    if ($ligne =~ /call\s+([\w_]+)/i) { # Appel de fonction
      $Called_local = $1 ;
      $Called_Minus = &GetAlias($1);
      $Reference=$R_Declar{$Called_Minus} ;
      if (!$Reference) {
	$Reference=$Called_Minus ;
	$Red =1 ;
      }
      $nextligne = -1;
    }
  }
  return($Called_local,$Reference,$nextligne,$Red);
}
#|#######################################################
sub AddCallTree {
  # Yeah, let's build hash tables pointing to hash tables !
  local($num,$file,$Called_local,$Routine,$Reference)=@_;
  if (${$Appellees{$Routine}}{$Called_local}) {
    ${$Appellees{$Routine}}{$Called_local} .= " $num" ;
  } else {
    ${$Appellees{$Routine}}{$Called_local} = "$num" ;
  }
  if ( ${$Appelants{$Reference}}{$Routine} ) {
    ${$Appelants{$Reference}}{$Routine} .=" $num" ;
  } else {
    ${$Appelants{$Reference}}{$Routine} = "$num" ;
  }
}
#|#######################################################
sub AddCallTreeC2 {
  # Yeah, let's build hash tables pointing to hash tables !
  local($num,$file,$Called_local,$Routine,$Reference)=@_;
  if (${$Appellees{$Routine}}{$Called_local}) {
    ${$Appellees{$Routine}}{$Called_local} .= " $num" ;
  } else {
    ${$Appellees{$Routine}}{$Called_local} = "$num" ;
  }
}
#|#######################################################
sub AddCallTreeC1 {
  # Yeah, let's build hash tables pointing to hash tables !
  local($num,$file,$Called_local,$Routine,$Reference)=@_;
  if ( ${$Appelants{$Reference}}{$Routine} ) {
    ${$Appelants{$Reference}}{$Routine} .=" $num" ;
  } else {
    ${$Appelants{$Reference}}{$Routine} = "$num" ;
  }
}
#|#######################################################
sub Fortran_End_Detect {
  local($stop,$RoutEncour)=@_;
  if ($stop) {
    if ( $stop =~ /^!/g ) {
      $RoutEncour = "0" ;
    }
  } else {
    $RoutEncour = "0" ;
  }
  return ($RoutEncour);
}
#|#######################################################
sub F90_html_declare {
  local($ligne,$Routine,$LocalName,$index)=@_;
  local($localRoutine,$localFile,$localNum)=&main::GetInfoRoutine($Routine) ;
  local($cref,$lien) = ("R_$localRoutine","") ;
  #
  if (0) {
    if (($father{$Routine}) && (${$sons{$father{$Routine}}}{$localRoutine}) && ("${$sons{$father{$Routine}}}{$localRoutine}" eq "$Routine")) {
      $cref = "R_$localRoutine$." ;
    } elsif ($R_Declar{$localRoutine}) {
      $cref = "R_$localRoutine" ;
    } else {
      warn "Warning: $Routine not known as public or private line $. file $file\n";
      $cref = "R_$localRoutine$." ;
    }
  }
  #
  if (($main::father{$Routine}) && ("$main::father{$Routine}" ne "$localFile:$localFile:0")) {
    $cref = "R_$localRoutine$localNum" ;
  }
  if ( $TypeUp eq "include" ) {
    $localFile = &fichiers::IncludeFileOfWrite($file) ;
  }

  if ($index) {
    $lien = "<A NAME=\"$cref\"></A><A Href=\"".CodeName($localFile,"$index").".html#$cref\" ".Target("$index").">$LocalName</A>";
  } else {
    $lien = "<A NAME=\"$cref\"></A><A Href=\"".CodeName($localFile,"index").".html#$cref\" ".Target("index").">$LocalName</A>";
  }
  $ligne =~ s/$LocalName/$lien/;
  return($ligne) ;
}
#|#######################################################
sub F90_html_reference {
  local($ligne,$Routine,$LocalName)=@_;
  local($LocalNamecasei)=GetLowerCase($LocalName);
  local($cref) = "" ;
  local($localReference,$fichier,$numcall) = ("","$file","") ;
  if (($father{$Routine}) && (${$sons{$father{$Routine}}}{$LocalNamecasei}) && ("${$sons{$father{$Routine}}}{$LocalNamecasei}" eq "$Routine")) {
    ($localReference,$fichier,$numcall)=&GetInfoRoutine($Routine);
    $cref = "R_$LocalNamecasei$numcall" ;
  } elsif ($R_Declar{$LocalNamecasei}) {
    $cref = "R_$LocalNamecasei" ;
  } elsif (${$sons{$Routine}}{$LocalNamecasei}) {
    ($localReference,$fichier,$numcall)=&GetInfoRoutine(${$sons{$Routine}}{$LocalNamecasei});
    $cref = "R_$LocalNamecasei$numcall" ;
  } else {
    print "Error $Routine doesnt offer $LocalName as son";
  }
  if ($cref) {
    local($lien) = "<A Href=\"".&CodeName($fichier,"source").".html#$cref\" ".Target("source").">$LocalName</A>";
    $ligne =~ s/$LocalName/$lien/;
  }
  return($ligne)
}
#|#######################################################
sub F90_html_Call {
  local($ligne,$Routine,$localCall)=@_;
  local($localCallcasei)=GetLowerCase($localCall);
  local($cref) = "" ;
  # local($localRoutine,$file,$num)=GetInfoRoutine($Routine);
  # $Reference = ${$available{$Routine}}{$suspectcasei}
  # local($localReference,$fichier,$numcall)=GetInfoRoutine($Reference);
  # $Reference = $main::R_Declar{$suspectcasei}
  if ($Reference = ${$available{$Routine}}{$localCallcasei}) {
    local($localReference,$fichier,$numcall)=&GetInfoRoutine($Reference);
    $cref = "R_$LocalNamecasei$." ;
  } elsif ($R_Declar{$LocalNamecasei}) {
    $cref = "R_$LocalNamecasei" ;
  }
  if ($cref) {
    local($lien) = "<A NAME=\"$cref\"></A><A Href=\"".CodeName($file,"source").".html#$cref\" ".Target("source").">$LocalName</A>";
    $ligne =~ s/$LocalName/$lien/;
  }
  return($ligne)
}

#|#######################################################
sub GetTags_F90 {
  # Anlysis of the program's definitions with their father and their sons.
  # It is not clear where to put the include's analysis: at this current
  # level or below as for fortran 77 and C...
  # Will have to be fixed.
  local(@listerest)=(@_);
  foreach $file (@listerest) {
    $File_Of_Rout{$file} = $file ;
  }
  foreach $file (@listerest) {
    $Routine = "$file:$file:0";
    unless (open(FILE,"<$file")) {
      warn "Error: Impossible to read $file" ;
      next ;
    }
    local($string) = "";
    local($instruction,$commentaire) = ("","");
    $father{$Routine} = $Routine ;
    local($interface) = 0 ;
    local($contains) = 0 ;
    local($use) = "" ;
    while ($ligne = <FILE>) {
      chop($ligne);
      ($string,$instruction,$commentaire) = searchfc::Fortran90_String_Comment($string,$ligne);
      if (($instruction) &&("$instruction" ne "")) {
	$instruction = GetLowerCase($instruction) ;
	if ($instruction =~ /end\s+(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
	  unless ($interface) {
	    $Routine = "$father{$Routine}" ;
	  }
	} elsif ($instruction =~ /\s*(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
	  $Type = $1 ;
	  $LocalName = $2 ;
	  $LocalNameCasei = GetLowerCase($LocalName) ;
	  unless ($interface) {
	    $father{"$LocalNameCasei:$file:$."} = "$Routine" ;
	    $Routine = "$LocalNameCasei:$file:$." ;
	    if (!IsFatherNotTop($father{"$Routine"})) {
	      # On construit des table d'index pour les donnes globales:
	      # modules, subroutines, programs et functions accessibles pour tous
	      $L_Declar{$LocalNameCasei}=$. ;
	      $R_Declar{$LocalNameCasei}=$LocalNameCasei ;
	      $File_Of_Rout{$LocalNameCasei} = "$file" ;
	      &Set_Detect($Type,$Routine,$file);
	      #			    &LabelDeclare("${file}","\\label{R_$LocalNameCasei}") ;
	    } else {
	      # Le point de dfinition est a priori priv: on dfinit
	      # la liste des fils du pre comme un tableau.
	      $pere = $father{"$Routine"} ;
	      ($localname,$localFile,$localNum) = GetInfoRoutine($Routine);
	      ${$sons{"$pere"}}{$localname} = "$Routine" ;
	      #			    &LabelDeclare("${file}","\\label{R_$localname$localnum}") ;
	    }
	  }
	}
      }
      if ($instruction =~ /end\s+(interface)/i) {
	$interface = $interface - 1 ;
	print "interface level downgrades to $interface line $.\n" if ($opt_v > 5);
      } elsif ($instruction =~ /^\s*(interface)(.*)/i) {
	$interface = $interface + 1 ;
	print "interface level upgrades to $interface line $. \n" if ($opt_v > 5);
	$instruction = $2 ;
	if (($instruction) && ($instruction =~ /^\s+([\w_\.\/]+)/)) {
	  $localinterface = $1 ;
	  unless ($localinterface =~ /\b(subroutine|function)\b/i) {
	    # Ceci dfinit une nouvelle interface que l'on peut considrer comme
	    # une routine appelable directement.
	    # Tout ce qui suivra cette dfinition d'interface sera considr comme
	    # un appel.
	    # Attention, ceci ne sera pas le cas lorque l'interface n'aura pas de nom.
	    if ($interface == 1) {
	      $father{"$localinterface:$file:$."} = $Routine ;
	      #				push(@{$sons{"$Routine"}},"$localinterface:$file:$.") ;
	      ${$sons{"$Routine"}}{$localinterface} = "$localinterface:$file:$." ;
	      print "interface($Routine){$localinterface}=$localinterface:$file:$.\n" if ($opt_v > 5);
	    }
	  }		    
	}
      }
      if ($instruction =~ /^\s*(contains)/i) {
	$contains = $contains + 1 ;
	print "contains level upgrades to $contains line $.\n" if ($opt_v > 5);
      }
      if ($instruction =~ /^\s*use\s+([\w_\.\/]+)(.*)/i) {
	$use = $1 ;
	$instruction = $2 ;
	$onlymodule = 0 ;
	# Ce niveau est vital en phase d'analyse des appels.
	# Il faudra tenir compte des fils du package $use avec leurs
	# ventuels alias et restrictions comme faisant partie des
	# appels possibles de $Routine.
      }
      if ($use) {
	$use=Use_Analysis($use,$instruction) ;
      }
    }
    $NBL{$file}=$.;
    close(FILE) ;
  }
}
#|#######################################################
sub Get_Include_F90 {
  # Anlysis of the program's definitions with their father and their sons.
  if (exists $Include_Unique{$file}) {
    $file_ref = $File_Of_Rout{$Include_Unique{$file}};
    $Routine=GetTotalInclude($file);
  } else {
    $file_ref = $File_Of_Rout{$file};
    $Routine=GetTotalRoutine($file);
  }
  local($string) = "";
  local($instruction,$commentaire) = ("","");
  $father{$Routine} = $Routine ;
  local($interface) = 0 ;
  local($contains) = 0 ;
  local($use) = "" ;
  while ($ligne = <FILE>) {
    chop($ligne) ;
    ($string,$instruction,$commentaire) = searchfc::Fortran90_String_Comment($string,$ligne);
    # I believe we already analyzed the comment segment of the line
    # through updating hash %input_link and %label
    if ($commentaire) {
      if ($commentaire =~ /.*\\input\s+([\w_\.\/]+)/) {
	&Input_Detect($file,$Routine,$.,$1);
      }
      &LabelDeclare("$file",$commentaire)  if ($commentaire =~ /label/);
    }
    if (($instruction) && ("$instruction" ne "")) {
      if ($instruction =~ /include\s+([\w_\.\/]+)/i) {
	# Add the include's interfaces to the possible call list of $Routine
	if ($instruction =~ /include\s+([\w_\.\/]+)/i) {
	  &Include_F90_Detect($file,$Routine,$.,$1);
	}
      }
      $instruction = GetLowerCase($instruction) ;
      #
      if ($instruction =~ /^\s*use\s+([\w_\.\/]+)(.*)/i) {
	$use = $1 ;
	$instruction = $2 ;
	$onlymodule = 0 ;
	$lineuse = $. ;
      } elsif ($instruction =~ /end\s+(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
	unless ($interface) {
	  $Routine = "$father{$Routine}" ;
	}
      } elsif ($instruction =~ /\s*(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
	$LocalName = $2 ;
	$Type = GetLowerCase($1) ;
	&LabelDeclare("${file_ref}","\\label{R_$LocalName}") ;
	unless ($interface) {
	  $father{"$LocalName:$file:$."} = "$Routine" ;
	  $Routine = "$LocalName:$file:$." ;
	  # We assume declarations starth here.
	  # We initialize our routine's available calls.
	  %{$available{$Routine}} = () ;
	  # We add the sons of routines to its possible calls.
	  foreach $son (keys %{$sons{$Routine}}) {
	    #			    print "Adding $son to $Routine\n";
	    ${$available{$Routine}}{$son} = ${$sons{$Routine}}{$son} ;
	  }
	  #
	}
	# CC
      } elsif ($instruction =~ /end\s+(interface)/i) {
	$interface = $interface - 1 ;
      } elsif ($instruction =~ /^\s*(interface)(.*)/i) {
	$interface = $interface + 1 ;
	$instruction = $2 ;
	if (($instruction) && ($instruction =~ /^\s+([\w_\.\/]+)/)) {
	  $localinterface = $1 ;
	  unless ($localinterface =~ /\b(subroutine|function)\b/i) {
	    # Ceci dfinit une nouvelle interface que l'on peut considrer comme
	    # une routine appelable directement.
	    # Tout ce qui suivra cette dfinition d'interface sera considr comme
	    # un appel.
	    # Attention, ceci ne sera pas le cas lorque l'interface n'aura pas de nom.
	    # Add the interface to the possible call list of $Routine
	    if ($interface == 1) {
	      # Well, we shall not analyse routines accrording to their
	      # protocoles, we prefer to analyse them at their specific declaration.
	      # Maybe I missed a point of fortran 90...
	      $father{"$localinterface:$file:$."} = $Routine ;
	      # Seems to me the possible interfaces are known at that level
	      #				${$available{$Routine}}{$localinterface} = "$localinterface:$file:$." ;
	    }
	  }
	}
      } elsif ($instruction =~ /^\s*(contains)/i) {
	$contains = $contains + 1 ;
      } elsif (!$interface) {
	#		    print "i($file:$.)=$instruction\n";
	&Call_F90_Detect($Routine,$instruction) ;
      }
      if ($use) {
	$enduse=Use_Analysis($use,$instruction) ;
	if ((!$enduse)&&($File_Of_Rout{"$use"})) {
	  # It's time to update the list of available functions, routines and interfaces
	  # to routine $Routine
	  $globaluse = "$use:".$File_Of_Rout{"$use"}.":".$L_Declar{"$use"};
	  push(@{${realuses{$Routine}}{$globaluse}},$lineuse) ;
	  push(@{${realused{$globaluse}}{$Routine}},$lineuse) ;
	  if ($onlymodule) {
	    # Il faut analyser le pointeur rename
	    #			    print "ONLY: module $use called by $Routine line $. file $file\n";
	    # We add a pointer to the list of use'rs...

	    foreach $realson (keys %{$rename{$Routine}}) {
	      $son = ${$rename{$Routine}}{$realson} ;
	      ${$available{$Routine}}{$son} = ${$sons{$globaluse}}{$realson} ;
	      #				print "Mod1 $use: Adding alias $son to $globaluse, making $realson avail to $Routine line $. file $file\n";
	    }
	  } else {
	    # Let'us review all the modules level one routines, taking care they could be renamed.
	    foreach $realson (keys %{$sons{$globaluse}}) {
	      $son = $realson ;
	      $son = ${$rename{$Routine}}{$realson} if ${$rename{$Routine}}{$realson} ;
	      #				print "Mod0 $use: Adding alias $son or real $realson to $globaluse, making $realson avail to $Routine line $. file $file\n";
	      ${$available{$Routine}}{$son} = ${$sons{$globaluse}}{$realson} ;
	    }
	  }			
	  $use="";
	}
      }
    }
  }
}
#|#######################################################
sub GetLowerCase {
  local($nom)=@_;
  $nom =~ tr/A-Z/a-z/;
  return ($nom);
}

#|#######################################################
sub GetInfoRoutineCasei {
  my($Routine)=@_;
  my($R,$F,$n) = ("","","") ;
  ($R,$F,$n) = split (/:/, $Routine) ;
  unless (defined($n)) {
    print "Error on init $Routine";
  }
  return("$R","$F","$n") ;
}
#|#######################################################
sub GetInfoRoutine {
  my($Routine)=@_;
  my($R,$F,$n) = ("","","") ;
  ($R,$F,$n) = split (/:/, $Routine) ;
  $Rcasei = GetLowerCase($R) ;
  # Hum... not very efficient manner of correcting an architecture bug.
  # All this is due to the improper mix of C and Fortran, assuming
  # case does not matter...
  if (exists $R_Include{$F}) {
    return("$R","$F","$n") ;
  }
  if ((exists $R_Declar{$Rcasei}) && ($R_Declar{$Rcasei} ne $Rcasei)) {
    $Rcasei = $R_Declar{$Rcasei} ;
  } elsif (exists $lfichiers{$R}) {
    $Rcasei = $R;
  }
  return("$Rcasei","$F","$n") ;
}
#|#######################################################
sub IsFatherNotTop {
  local($Rcasei,$F,$n)=GetInfoRoutine($_[0]) ;
  return($n) ;
}

#|#######################################################
sub CheckF90Routine {
  local($lR,$Routine)=@_;
  local($R,$F,$n) = split (/:/, $Routine) ;
  $Rcasei = GetLowerCase($R) ;
  $lRcasei = GetLowerCase($lR) ;
  if ("$Rcasei" ne "$lRcasei") {
    warn "Warning: incoherence line $. file $file for $lRcasei not $Rcasei($Routine)";
    return(1);
  }
  return(0);
}

#|#######################################################
sub MakeF90Definition {
  local($ligne,$objet,$RoutineCasei,$Routine) = @_ ;
  local($lien,$lien_top) = ("","") ;
  if ($ligne =~ /(program|function|subroutine|module|interface)/i) {
    if ("$1" =~ /program/i) {
      $lien = "<A HREF=\"${objet}_i.html#R_$RoutineCasei\" TARGET=\"index\">$Routine</A>";
      $lien_top = &index::OnJava("$objet","$RoutineCasei","$java")."$Routine</A>";
    } elsif ($1 =~ /function/i) {
      $lien = "<A HREF=\"${objet}_i.html#R_$RoutineCasei\" TARGET=\"index\">$Routine</A>";
      $lien_top = &index::OnJava("$objet","$RoutineCasei","$java")."$Routine</A>";
    } elsif ($1 =~ /subroutine/i) {
      $lien = "<A HREF=\"${objet}_i.html#R_$RoutineCasei\" TARGET=\"index\">$Routine</A>";
      $lien_top = &index::OnJava("$objet","$RoutineCasei","$java")."$Routine</A>";
    } elsif ($1 =~ /module/i) {
      $lien = "<A HREF=\"${objet}_i.html#R_$RoutineCasei\" TARGET=\"index\">$Routine</A>";
      $lien_top = &index::OnJava("$objet","$RoutineCasei","$java")."$Routine</A>";
    } elsif ($1 =~ /interface/i) {
      $lien = "<A HREF=\"${objet}_i.html#R_$RoutineCasei\" TARGET=\"index\">$Routine</A>";
      $lien_top = &index::OnJava("$objet","$RoutineCasei","$java")."$Routine</A>";
    }
  } else {
    warn "Severe Error(3-01) $1-$ligne-$file-$."; 
  }
  return($lien,$lien_top)
}

#|#######################################################
sub Call_F90_Detect {
  # Routine is the name of the current Routine,
  # available is the hash table of the available calls at Routine,
  # ligne is the instruction line.
  local($Routine,$ligne)=(@_);
  # Let us transform the instruction line into a set of
  # elementary instructions.
  local(@instructions) = split (/\;/, $ligne) ;
  local($instruction) = "";
  foreach $instruction (@instructions) {
    local($Red) = 0 ;
    local($suspect,$suspectcasei,$Reference) = ("","","") ;
    if ($instruction =~ /call\s+([\w_]+)/i) {
      $suspect = $1 ;
    } elsif ($instruction =~ /\b([\w_]+)\s*\(/) {
      $suspect = $1 ;
    }
    if ($suspect) {
      $suspectcasei = GetLowerCase($suspect) ;
      # Let un directly search for routines inside the same package:
      # A brother to a private (available lists the private functions) function
      # is available to self.
      # This is much faster than defining a bigger "available" table with the
      # brothers through a double loop at end of level 1 or during level 2
      # during the calls analysis.
      if (($Reference = ${$available{$Routine}}{$suspectcasei})||($Reference = ${$available{$father{$Routine}}}{$suspectcasei})) {
	#	    if ($Reference = ${$available{$Routine}}{$suspectcasei}) {
	# The called procedure, function or interface is a private one
	#		print "\nIn $file at line $.:\n\tavailable{$suspectcasei}=$Reference\n";
	local($localRoutine,$file,$num)=GetInfoRoutine($Routine);
	# This would be another stupid way of programming, like I used to do it:
	#		push(@{${$Private_Appellees{$Routine}}{$suspectcasei}},"$.");
	#	        push(@{${$Private_Appelants{$Reference}}{$localRoutine}},"$.");
	# Let us only build a local list of a hash table of the called programs, the
	# list collecting the line numbers of the call... I Hope It's clear to you as
	# well.
	push(@{${effectcalled{$Routine}}{$suspectcasei}},"$.") ;
	# Let us build a global table to indicate that $suspectcasei is
	# called by $Routine and is defined line $Reference.
	# We use a very clever trick that consists in saying that if
	# a calls b then b does not call a: so we reverse the hash to allow
	# one hash table to contain the two laws: a calls b and b is calles by a.
	${realcalls{$Routine}}{$suspectcasei} = $Reference ;
	${realcalled{$Reference}}{$Routine} = $suspectcasei ;
	#		print "Adding line $. to $Routine for suspect $suspectcasei\n";
	#		print "@{${effectcalled{$Routine}}{$suspectcasei}}\n";
      } elsif ($Reference = $main::R_Declar{$suspectcasei}) {
	# The called procedure, function or interface is a global one
	# Let us construct the casual indexes with blmody info.
	local($localRoutine,$file,$num)=GetInfoRoutine($Routine) ;
	#		&main::AddCallTree($.,$file,$suspect,$localRoutine,$Reference);
	&main::AddCallTree($.,$file,$suspect,$Routine,$Reference);
	$Reference = GetTotalRoutine($Reference);
	${realcalls{$Routine}}{$suspectcasei} = "$Reference" ;
	${realcalled{$Reference}}{$Routine} = $suspectcasei ;
	# Whatever public or private it is, we don't bother.
	#		push(@{${effectcalled{$Routine}}{$suspectcasei}},"$.") ;
      } else {
	# We can say we have no idea of that suspect's definition
	$Red = 1 ;
      }
    }
  }
  #    return($Called_local,$Reference,$nextligne,$Red);
}

#|#######################################################
sub Call_F90_Html {
  # Routine is the name of the current Routine,
  # available is the hash table of the available calls at Routine,
  # ligne is the instruction line.
  local($Routine,$ligne,$htmlligne)=(@_);
  # Let us transform the instruction line into a set of
  # elementary instructions.
  local(@instructions) = split (/\;/, $ligne) ;
  local($instruction) = "";
  foreach $instruction (@instructions) {
    local($Red) = 0 ;
    local($suspect,$suspectcasei,$Reference) = ("","","") ;
    if ($instruction =~ /call\s+([\w_]+)/i) {
      $suspect = $1 ;
    } elsif ($instruction =~ /\b([\w_]+)\s*\(/) {
      $suspect = $1 ;
    }
    if ($suspect) {
      $suspectcasei = GetLowerCase($suspect) ;
      if (defined(@{${$effectcalled{$Routine}}{$suspectcasei}})) {
	# The called procedure, function or interface is a private one
	local(@numlist) =(@{${$effectcalled{$Routine}}{$suspectcasei}}) ;
	#		print "\nIn $file at line $.:\n\tavailable{$suspectcasei}=@numlist\n";
	foreach $num (@numlist) {
	  if ($num == $.) {
	    $mynum = $num ;
	    last ;
	  }
	}
	if ($mynum == $.) {
	  print "Real line call $. for $Routine on $suspectcasei\n" if ($opt_v > 4);
	} else {
	  print "Wrong $mynum line call $. for $Routine on $suspectcasei\n";
	  print "numlist=@numlist\n";
	}
	local($localRoutine,$file,$num)=GetInfoRoutine($Routine);
	$Reference = ${realcalls{$Routine}}{$suspectcasei} ;
	#	        $Reference = ${$available{$Routine}}{$suspectcasei} ;
	local($localReference,$fichier,$numcall)=GetInfoRoutine($Reference);
	#		push(@{${effectcalled{$Routine}}{$suspectcasei}},"$.") ;
	$cref = "" . CodeName($fichier,"source") . ".html#R_$localReference$numcall" ;
	$lien = "<A Name=\"C_$localRoutine$.\"></A>";
	$lien .= "<A HREF=\"$cref\" ".Target("source").">$suspect</A>";
	$htmlligne =~ s/$suspect/$lien/;
      } elsif ($Reference = $main::R_Declar{$suspectcasei}) {
	# The called procedure, function or interface is a global one
	# Let us construct the casual indexes with blmody info.
	local($localRoutine,$file,$num)=split (/:/, $Routine) ;
	#		&main::AddCallTree($.,$file,$suspect,$localRoutine,$Reference);
	# Whatever public or private it is, we don't bother.
	#		push(@{${effectcalled{$Routine}}{$suspectcasei}},"$.") ;
	# Attention le lien porte sur le suspectcasei
	print "Dealing suspect $suspectcasei line $. file $file\n" if ($opt_v > 5) ;
	$cref = "" . CodeName($File_Of_Rout{$Reference},"source") . ".html#R_$Reference" ;
	$lien = "<A Name=\"C_$localRoutine$.\"></A>";
	$lien .= "<A HREF=\"$cref\" ".Target("source").">$suspect</A>";
	$htmlligne =~ s/$suspect/$lien/;
	#		die "$htmlligne";
      } else {
	# We can say we have no idea of that suspect's definition
	$Red = 1 ;
      }
    }
  }
  return($htmlligne) ;
  #    return($Called_local,$Reference,$nextligne,$Red);
}

#|#######################################################
sub Use_Analysis {
  local($use,$instruction) = @_ ;
  local(@liste) = () ;
  if ($instruction =~ /\b(only)\s*\:(.*)/i) {
    $instruction = $2 ;
    $onlymodule = 1 ;
  }
  (@liste) = split (/\,/, $instruction) ;
  foreach $toto (@liste) {
    next if ($toto =~ /^\s*$/) ;
    if ($toto =~ /([\w_]+)\s*\=\>\s*([\w_]+)/) {
      # A droite le nom susceptible d'tre appel,  gauche le nom dans le module.
      ${$rename{$Routine}}{$1} = $2 ;
    } elsif (($onlymodule) && ($toto =~ /([\w_]+)/)) {
      ${$rename{$Routine}}{$1} = $1 ;
    }   
  }
  unless ($instruction=~ /\&\s*$/) {
    $use = "" ;
  }
  return($use) ;
}
#|#######################################################
sub Use_Html_Analysis {
  local($use,$instruction,$ligne,$globaluse) = @_ ;
  local(@liste) = () ;
  if ($instruction =~ /\b(only)\s*\:(.*)/i) {
    $instruction = $2 ;
    $onlymodule = 1 ;
  }
  if ($globaluse) {
    (@liste) = split (/\,/, $instruction) ;
    foreach $toto (@liste) {
      if ($toto =~ /([\w_]+)\s*\=....\s*([\w_]+)/) {
	#	    ${$rename{$Routine}}{$2} = $1 ;
	my($dec,$ref) = ($1,$2);
	#	    $ligne=F90_html_declare($ligne,$Routine,$ref);
	$ligne=F90_html_reference($ligne,$globaluse,$dec);
      } elsif (($onlymodule) && ($toto =~ /([\w_]+)/)) {
	#	    ${$rename{$Routine}}{$2} = $1 ;
	#	    $ligne=F90_html_declare($ligne,$Routine,$1);
      }   
    }
  }
  unless ($instruction=~ /\&\s*$/) {
    $use = "" ;
  }
  return($use,$ligne) ;
}
#|#######################################################
sub Fontification_Html_Du_F90 {
  local($TypeUp,@liste)=@_;
  $Compteur_local = 0 ;
  %special=( "<" => "&lt;" , ">" => "&gt;" );	    
  ##    undef($href);
  $file_bis = "" ;
  &fontify::InitCodeComments("f90") ;
  foreach $file (@liste) {
    $process{$file} = 1 ;
    $Full_Html=0;
    if ($opt_latex) {
      $Full_Html=1;
    }
    $Compteur_local=Etat_Avancement($Compteur_local,$#liste);
    unless (open(SOURCE,"<$file")) {
      warn "Severe Error(3-f1) $file";
      next ;
    }
    if (exists $Include_Unique{$file}) {
      $Routine=GetTotalInclude($file);
    } else {
      $Routine=GetTotalRoutine($file);
    }
    $RoutEncour = GetAlias($file);
    if ( $TypeUp eq "include" ) { # Fichier include
      if ($Routine =~ /^\//) {
	$Routine = &main::IncludeFileOfWrite($Routine) ;
	&fichiers::GetIncludeCibleOfWrite($Routine) ;
      }
      $objet = &fichiers::IncludeFileOfWrite($file) ;
      &fichiers::GetIncludeCibleOfWrite($objet) ;
      unless (open(OBJET,">$DIRE/${objet}_c.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(LEFTINDEX,">$DIRE/${objet}_i.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(MAINFRAME,">$DIRE/${objet}.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      $ligne=En_Tete_Inclu($file,"source");
      print OBJET "$ligne" ;
      $ligne=En_Tete_Inclu($file,"index");
      $file_bis=index::FileName($file) ;
      #	    &GetIncludeCibleOfWrite($file_bis) ;
      local($thisRoutine)="$Include_Unique{$file}:$file:0";
      $ligne .= &{$affiche{"br"}} ;
      $ligne .= &{$affiche{"Private_Includes"}}($thisRoutine,"source") ;
      $ligne .= &{$affiche{"br"}} ;
      $ligne .= &{$affiche{"Private_Included"}}($thisRoutine,"source") ;
      $ligne .= &{$affiche{"br"}} ;
      print LEFTINDEX "$ligne" ;
      print MAINFRAME '<html>
<head>
   <title>'.$objet.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${objet}.'_i.html" NAME="index">
  <frame SRC="'.$objet.'_c.html" NAME="source">
</frameset>
</html>' ;
      close (MAINFRAME) ;
    } else {
      $objet = $file ;
      &fichiers::GetIncludeCibleOfWrite($objet) ;
      unless (open(OBJET,">$DIRE/${objet}_c.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(LEFTINDEX,">$DIRE/${objet}_i.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(MAINFRAME,">$DIRE/${objet}.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      print MAINFRAME '<html>
<head>
   <title>'.$objet.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${objet}.'_i.html" NAME="index">
  <frame SRC="'.$objet.'_c.html" NAME="source">
</frameset>
</html>' ;
      close (MAINFRAME) ;
      $ligne=En_Tete_F90($file,"source") ; # Mise en place du titre classique
      print OBJET "$ligne" ;
      $ligne=En_Tete_F90($file,"index") ; # Mise en place du titre classique
      print LEFTINDEX "$ligne" ;
      # Mise en place de l'index JavaScript.
      &javaindex::SmallJavaNavigator($file) if $java;
    }
    $comm = 0 ;
    $paren=0;
    local($interface) = 0 ;
    local($contains) = 0 ;
    $local_ligne=0 ;
    local($string) = "";
    local($instruction,$commentaire) = ("","");
    $Routine = "$file:$file:0" ;
    $father{$Routine} = $Routine ;
    while (defined($ligne=<SOURCE>)) {
      chomp $ligne;
      if ($ligne =~ /[<>]/) {
	foreach $char (keys %special) {
	  $ligne =~ s/$char/$special{$char}/g ;
	}
      }
      ($local_ligne,$ligne,$affligne)=Affiche_F90_Num($local_ligne,$ligne);
      if ($affligne) {
	print OBJET $affligne ;
      }
      ($string,$comm,$instruction,$commentaire,$ligne) = searchfc::HTML_90_String_Comment($string,$comm,$ligne);
      if (($commentaire) &&( $commentaire =~ /\\input\s+([\w_\.\/]+)/)) {
	$input=$1;
	$ligne = &Input_Html($input,$ligne,"source",$totalRoutine);
      }
      if (($instruction) && ("$instruction" ne "")) {
	if ($paren) {
	  ($paren,$bef_paren,$end_paren)=searchfc::Find_Html_Parenthesis($paren,$instruction);
	  unless ($paren) {
	    # This is not an absolute bugs free substitute, but it is statistically OK
	    $ligne =~ s/\)/\)<\/FONT>/;
	  }
	}
	if ($instruction =~ /include\s+([\w_\.\/]+)/i) {
	  # Add the include's interfaces to the possible call list of $Routine
	  $include=$1 ;
	  $ligne=&Include_F90_Html($include,$ligne,"source",$Routine);
	} elsif ($instruction =~ /^\s*use\s+([\w_\.\/]+)(.*)/i) {
	  $use = $1 ;
	  $instruction = "$2" ;
	  $onlymodule = 0 ;
	  $smalluse = GetLowerCase($use) ;
	  if ($localReference = $R_Declar{$smalluse}) {
	    $fichier = $File_Of_Rout{$smalluse} ;
	    $numcall = $L_Declar{$smalluse} ;
	    #		push(@{${effectcalled{$Routine}}{$suspectcasei}},"$.") ;
	    $cref = "" . CodeName($fichier,"source") . ".html#R_$localReference" ;
	    $lien = "<A Name=\"C_$localRoutine$.\"></A>";
	    $lien .= "<A HREF=\"$cref\" ".Target("source").">$use</A>";
	    $ligne =~ s/$use/$lien/;
	  }
	} elsif ($instruction =~ /^\s*(interface)(.*)/i) {
	  $interface = $interface + 1 ;
	  $instruction = $2 ;
	  if (($instruction) && ($instruction =~ /^\s+([\w_\.\/]+)/)) {
	    $localinterface = $1 ;
	    unless ($localinterface =~ /\b(subroutine|function)\b/i) {
	      # Ceci dfinit une nouvelle interface que l'on peut considrer comme
	      # une routine appelable directement.
	      # Tout ce qui suivra cette dfinition d'interface sera considr comme
	      # un appel.
	      # Attention, ceci ne sera pas le cas lorque l'interface n'aura pas de nom.
	      # Add the interface to the possible call list of $Routine
	      if ($interface == 1) {
		# Well, we shall not analyse routines accrording to their
		# protocoles, we prefer to analyse them at their specific declaration.
		# Maybe I missed a point of fortran 90...
		$Interface = GetLowerCase($localinterface).":$file:$." ;
		$ligne = F90_html_declare($ligne,$Interface,$localinterface);

		$father{$Interface} = $Routine ;
		# Seems to me the possible interfaces are known at that level
	      }
			    
	    }
	  }
	  if ($instruction =~ /end\s+(interface)/i) {
	    $interface = $interface - 1 ;
	  }
	} elsif ($instruction =~ /end\s+(interface)/i) {
	  $interface = $interface - 1 ;
	} elsif ($instruction =~ /end\s+(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
	  $localRoutine = $2 ;
	  unless ($interface) {
	    if (&CheckF90Routine($localRoutine,$Routine)) {
	      warn "Warning: incoherence line $. file $file for $localRoutine($Routine)";
	    }
	    $ligne = F90_html_reference($ligne,$Routine,$localRoutine);
	    $Routine = "$father{$Routine}" ;
	  }
	} elsif ($instruction =~ /\s*(function|subroutine|program|module)\s+([\w_\.\/]+)(.*)/i) {
	  $LocalName = $2 ;
	  $Type = GetLowerCase($1) ;
	  if ($ligne =~ /(.*$LocalName\s*)(.*)/) {
	    $start = $1 ;
	    $end   = $2;
	  }
	  unless ($interface) {
	    $localRoutine = GetLowerCase($LocalName) ;
	    $father{"$localRoutine:$file:$."} = "$Routine" ;
	    $Routine = "$localRoutine:$file:$." ;
	    if (IsFatherNotTop($father{"$Routine"})) {
	      # We can build the index as usual
	      # The definition point is a public one
	      ($lien,$lien_top)=MakeF90Definition($ligne,$objet,$localRoutine,$LocalName);
	    } else {
	      ($lien,$lien_top)=MakeF90Definition($ligne,$objet,"$localRoutine$.",$LocalName);
	    }
	    $start_top = F90_html_declare($start,$Routine,$LocalName,"source");
	    $start = F90_html_declare($start,$Routine,$LocalName,"index");
	    $start =~ s/$Routine/$lien/;
	    $start_top =~ s/$Routine/$lien_top/;
	    $ligne = $start;
	    $ligne_top = $start_top;
	    $ligne_add = $fontify::ligne_ini ;
	    if ("$Type" eq "module") {
	      $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Used"}}($Routine,"source") ;
	      $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Uses"}}($Routine,"source") ;
	      $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Defines"}}($Routine,"source") ;
	    } else {
	      $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Called"}}($Routine,"source") ;
	      $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Calls"}}($Routine,"source") ;
	      $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Uses"}}($Routine,"source") ;
	    }
	    $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Includes"}}($Routine,"source") ;
	    $ligne_add .= &{$affiche{"br"}} ;
	    if ($ligne_add ne $fontify::ligne_ini) {
	      $ligne .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	      $ligne_top .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	    }
	    if ($end =~ /^\s*\((.*)/) {
	      $end_paren = $1 ;
	      $ligne .= &fontify::start_header."(" ;
	      $paren = 1 ;
	      ($paren,$bef_paren,$end_paren)=searchfc::Find_Html_Parenthesis($paren,$end_paren);
	      if ($paren) {
		$ligne .= "$bef_paren$end_paren";
	      } else {
		$ligne .= "$bef_paren</FONT>$end_paren";
	      }
	    } else {
	      $ligne .= $end ;
	    }
	    print LEFTINDEX "<P>$ligne_top\n";
	  }
	} elsif ("$instruction" =~ /^\s*\b(contains)\b/i) {
	  $contains = $contains + 1 ;
	} elsif (!$interface) {
	  $ligne=Call_F90_Html($Routine,$instruction,$ligne) ;
	}
	# This remains to be corrected rightfully
	if ($smalluse) {
	  if (($File_Of_Rout{$smalluse}) && ($L_Declar{$smalluse})) {
	    $globaluse = "$smalluse:".$File_Of_Rout{$smalluse}.":".$L_Declar{$smalluse};
	  } else {
	    $globaluse = "";
	  }
	  ($smalluse,$ligne)=Use_Html_Analysis($smalluse,$instruction,$ligne,$globaluse) ;
	}
      }
      print OBJET "$ligne\n";
    }
    print OBJET "$fontify::HR</BODY></HTML>\n";
    close(OBJET);
    close (LEFTINDEX) ;
    close(SOURCE);
  }
}
#|#######################################################
sub Lecture_Tags {
  local($language, @etags) = (@_);
  local($file) = "0" ;
  local($Type,$Routine,$RoutEncour,$num) = ();
  if ($language eq 'fortran') {
    system "etags --regex='/[ \s]*program[ \s]*[ \t]+[^ \t]+/\1/' --ignore-indentation --no-defines --no-globals -o $DIRE/ftagshtml.TAGS @etags" ;
  } else {
    system "etags --ignore-indentation --no-defines --no-globals -o $DIRE/ftagshtml.TAGS @etags" ;
  }
  open(TAGS,"<$DIRE/ftagshtml.TAGS") or die "Error(01) TAGS table creation failed.";
  while (<TAGS>) {
    if (//) {
      $file = "0" ;
      next ;
    }
    unless ($file) {
      if (/^([\w\-\._\/]+),\d+$/) {
	$file = &fichiers::GetFileCurrent($1) ;
	$File_Of_Rout{$file} = $file ;
	if ($file =~ /\.(f|f77)$/i) {
	  $language = "fortran";
	} elsif ($file =~ /\.(c|cc|cpp|C|CC)$/) {
	  $language = "C";
	}
	next ;
      }
    }
    if ( $language eq "fortran" ) {
      ($Type,$Routine,$RoutEncour,$num)=Fortran_Tags($_);
      $RoutineCasei = GetLowerCase($Routine) if $Routine ;
    } elsif ( $language eq "C" ) {
      ($Type,$Routine,$RoutEncour,$num)=C_Tags($_);
      $RoutineCasei = $Routine ;
    }
    if ($Routine) {
      $L_Declar{$RoutineCasei}=$num ;
      $R_Declar{$RoutEncour}=$RoutineCasei ;
      $File_Of_Rout{$RoutineCasei} = "$file" ;
      $totalRoutine = GetTotalRoutine($RoutineCasei);
      &Set_Detect($Type,$totalRoutine,$file);
      $father{$totalRoutine}="$File_Of_Rout{$RoutineCasei}:$File_Of_Rout{$RoutineCasei}:0";
    }
  }
  close(TAGS);
}
#|#######################################################
sub Set_Detect {
  # Input: \$Routine,\$file,
  # Output: %R_Declar, %File_Of_Rout, %L_Declar, %fichier_to_Routine
  # Selon cas @routines, @functions, @programmes.
  local($type_of_program,$Routine,$file) = @_ ;
  #    local($info)="$Routine:$file:$file.html#R_$Routine";
  local($info)="$Routine";
  # Globales:
  push(@{$lfichiers{$file}},$Routine);
  #    if ($fichier_to_Routine{$file}) {
  #	$fichier_to_Routine{$file} .= ":$Routine";
  #    } else {
  #	$fichier_to_Routine{$file} = $Routine;
  #    }
  if ($type_of_program =~ /subroutine/i) {
    $routines{$info} = $file ;
  } elsif ($type_of_program =~ /function/i) {
    $functions{$info} = $file ;
  } elsif ($type_of_program =~ /program/i) {
    $programmes{$info} = $file ;
  } elsif ($type_of_program =~ /module/i) {
    $module{$info} = $file ;
  } elsif ($type_of_program =~ /main/i) {
    $programmes{$info} = $file ;
  } else {
    warn "Severe Error(02) Detect level 0:$type_of_program";
  }
}
#|#######################################################
sub Fortran_Tags {
  local($ligne) = (@_);
  if ($ligne =~ /(subroutine|program|function)\s+([\w_]+).+?(\d+),\d+$/i) {
    local($Type) =$1 ;
    local($Routine) =$2 ;
    local($Numero)=$3 ;
    local($RoutEncour)=GetAlias($Routine) ;
    return ($Type,$Routine,$RoutEncour,$Numero) ;
  } else {
    chomp($ligne);
    warn "Erreur(1-01F) TAGS ligne($.)=$ligne\n";
  }
  return (0);
}
#|#######################################################
sub C_Tags {
  local($ligne) = (@_);
  if ($ligne =~ /^([\w_]+)[\s\(]+(\d+),\d+$/) {
    local($Routine)=$1 ;
    local($Numero)=$2 ;
    local($RoutEncour)=GetAlias($Routine) ;
    print "Routine=$Routine-$Numero\n" if $debug ;
    unless ($Routine =~ /\bstructdef\b/i) {
      if ($Routine eq "main") {
	return ("main",$Routine,$RoutEncour,$Numero) ;
      } else {
	return ("function",$Routine,$RoutEncour,$Numero) ;
      }
    }
  } elsif ($ligne =~ /^([\w_]*)\s*.*?\s*([\w_]+)[\s\(\=]+(\d+),\d+$/) {
    local($Type)=$1 ;
    local($Routine)=$2 ;
    local($Numero)=$3 ;
    print "C_Tag $Type-$Routine-$Numero\n" if ($opt_v > 4) ;
    #	unless ($Type =~ /\bstatic\b/i) {
    local($RoutEncour)=GetAlias($Routine) ;
    if ($Routine eq "main") {
      return ("main",$Routine,$RoutEncour,$Numero) ;
    } else {
      return ("function",$Routine,$RoutEncour,$Numero) ;
    }
    #	}
  }
  return (0,0,0,0);
}


#|#######################################################
sub En_Tete_Inclu {
  local($file,$source)=@_;
  local($ligne)="";
  $Verbatim_Style = 0;
  #    $file_bis = $file ;
  # Adaptation de ftagshtml
  $file_bis = $Include_Unique{$file} ;
  #    print "file=$file, file_bis=$file_bis\n";
  &fichiers::GetIncludeCibleOfWrite($file_bis) ;
  $enteteloc=En_Tete_All($file_bis,"include",$source);
  # en-tete du fichier
  #-------------------
  $file_loc=&fichiers::GetIncludeSource($file);
  $file_ter=&fichiers::IncludeFileOfWrite($file) ;
  &fichiers::GetIncludeCibleOfWrite($file_ter) ;
  $ligne = "<HTML>
<HEAD>
<TITLE>$file_bis $RepCodeSource</TITLE>
</HEAD>\n";
  unless ($main::opt_nostyle) {
    $ligne .= &fontify::stylesheet ;
  }
  $ligne .= "<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H3 align=center>$file_bis ($RepCodeSource)</H3>".&last_modified($file)."
$enteteloc
<P> <A HREF=\"$file_loc\" TARGET=\"source\">View source file.</A>\n";
  if ($cgi) {
    $ligne .= &CGI_Print($file_loc) ;
  }
  if (($source) && ("$source" eq "source")) {
    $ligne .= "<P> List of files using <A HREF=\"${file_ter}_i.html#R_$file_bis\" TARGET=\"index\">$file_bis</A>.";
  } else {
    $ligne .= "<P> List of files using <A HREF=\"inclindex_c.html#R_$file_bis\" TARGET=\"source\"> $file_bis</A>.";
  }
  if (($source) && ("$source" eq "source")) {
    $ligne .= "<A NAME=R_${file_bis}></A>
$fontify::HR
$fontify::INIT_CODE\n".&fontify::start_code."\n";
  } else {
    $ligne .= "<A NAME=R_${file_bis}></A>
$fontify::HR
";
  }
  return($ligne);
}
;
#|#######################################################
sub CGI_conf {
  if (open(CONF,">$DIRE/$opt_conf.pm")) {
    print CONF "# Generated by $0\n";
    print CONF "\$opt_dir = \"$DIRW\" \;\n";
    print CONF "\$opt_html = \"$DIRE\" \;\n";
    print CONF "\$opt_www = \"$opt_www\" \;\n" if $opt_www;
    print CONF "\(\@INCLUDES_PATH\) = \(";
    foreach $a (@TAGSHTML_PATH) {
      print CONF "'$a', ";
    }
    print CONF "\)\;\n";
    print CONF "\$opt_getin_format = \"$getin_format\" \;\n" if $opt_getin_format ;
    print CONF "1 \;\n";
    print STDOUT "\tManually copy\n\t'$DIRE/$opt_conf.pm'\n\t to \n\t'$cgi/../lib/perl/getin/conf/$opt_conf.pm'\n\tprobably $ENV{FTAGSHTML_DIR}/lib/perl/getin/conf/$opt_conf.pm\n";
    close(CONF) ;
  }
}
#|#######################################################
sub CGI_Print {
  my($cible) = @_ ;
  my($ligne) = "" ;
  $cible =~ s#\.\./#dotdotslash#g ;
  if ($opt_conf) {
    $ligne .= "<BR>
<FORM METHOD=\"POST\" ACTION=\"$cgi/getin.pl\" ENCTYPE=\"application/x-www-form-urlencoded\" TARGET=\"source\">
<INPUT TYPE=\"hidden\" NAME=\"conf\" VALUE=\"$opt_conf\">
<INPUT TYPE=\"hidden\" NAME=\"fichier\" VALUE=\"$file\">
<INPUT TYPE=\"text\" NAME=\"ARGV\"  SIZE=20 MAXLENGTH=500>
<INPUT TYPE=\"submit\" NAME=\"Search\" VALUE=\"Search\">
</FORM>
<BR><A HREF=\"$cgi/getin.pl?conf=$opt_conf\" TARGET=\"source\">Extended getin search</A>\n"
      ;
    return ($ligne) ;
  } else {
    return ("<BR>
<FORM METHOD=\"POST\" ACTION=\"$cgi/getin.pl\" ENCTYPE=\"application/x-www-form-urlencoded\" TARGET=\"source\">
<INPUT TYPE=\"hidden\" NAME=\"dir\" VALUE=\"$DIRW\">
<INPUT TYPE=\"hidden\" NAME=\"html\" VALUE=\"$DIRE\">
<INPUT TYPE=\"hidden\" NAME=\"www\" VALUE=\"$opt_www\">
<INPUT TYPE=\"hidden\" NAME=\"I\" VALUE=\"$opt_I\">
<INPUT TYPE=\"hidden\" NAME=\"getin_format\" VALUE=\"$opt_getin_format\">
<INPUT TYPE=\"hidden\" NAME=\"fichier\" VALUE=\"$file\">
<INPUT TYPE=\"text\" NAME=\"ARGV\"  SIZE=20 MAXLENGTH=500>
<INPUT TYPE=\"submit\" NAME=\"Search\" VALUE=\"Search\">
</FORM>
<BR><A HREF=\"$cgi/getin.pl?dir=$DIRW&html=$DIRE\" TARGET=\"source\">Extended getin search</A>\n"
	   );
  }
}
#|#######################################################
sub En_Tete_F {
  local($target,$source)=@_;
  local($ligne)="";
  $Verbatim_Style = 0;
  $enteteloc=&En_Tete_All($file,"fortran",$source);
  $file_loc=&fichiers::GetLocFile($file);
  # en-tete du fichier
  #-------------------
  $ligne= &index::OpenSource("$file $RepCodeSource","$file","$target",$java) ;
  $ligne .= "$enteteloc
<P> <A HREF=\"$file_loc\" TARGET=\"source\">View source file.</A>\n";
  if ($cgi) {
    $ligne .= &CGI_Print($file_loc) ;
  }
  $ligne .= "$fontify::HR$fontify::INIT_CODE\n".&fontify::start_code."\n";
  return($ligne);
}
;

#|#######################################################
sub En_Tete_F90 {
  local($target,$source)=@_;
  local($ligne)="";
  $Verbatim_Style = 0;
  $enteteloc=&En_Tete_All($file,"fortran",$source);
  $file_loc=&fichiers::GetLocFile($file);
  # en-tete du fichier
  #-------------------
  $ligne = &index::OpenSource("$file $RepCodeSource","$file","$target",$java) ;
  $ligne .="
$enteteloc
<P> <A HREF=\"$file_loc\" TARGET=\"source\">View source file.</A>\n";
  if ($cgi) {
    $ligne .= &CGI_Print($file_loc) ;
  }
  $ligne .= "$fontify::HR$fontify::INIT_CODE\n".&fontify::start_code."\n";
  return($ligne);
}
;

#|#######################################################
sub En_Tete_C {
  local($target,$source)=@_;
  local($ligne)="";
  $Verbatim_Style = 0;
  $enteteloc=&En_Tete_All($file,"C",$source);
  $file_loc=&fichiers::GetLocFile($file);
  # en-tete du fichier
  #-------------------
  $ligne = &index::OpenSource("$file $RepCodeSource","$file","$target",$java) ;
  $ligne .="
$enteteloc
<P> <A HREF=\"$file_loc\" TARGET=\"source\">View source file.</A>\n";
  if ($cgi) {
    $ligne .= &CGI_Print($file_loc) ;
  }
  $ligne .= "$fontify::HR$fontify::INIT_CODE\n".&fontify::start_code."\n";
  return($ligne);
}
;
#|#######################################################
sub last_modified {
  my($file) = @_ ;
  my(@mx) = stat $file ;
  my($lastmodified) = $mx[9] ;
  my(@lt) = localtime($lastmodified);
  my($d,$m,$y) = @lt[3,4,5];
  $y += 1900 ; $m++ ;
  return("<H3 align=center>Last modified $d /$m /$y.</H3>\n");
}
#|#######################################################
sub En_Tete_All {
  local($file,$type,$source)=@_;
  if ($file) {
    $file = "#R_$file";
  }
  local(%tab)=();
  %tab = (Fichiers => 'Files',
	  Programmes => 'Programmes',
	  Routines => 'Routines',
	  Fonctions => 'Functions',
	  Includes => 'Includes',
	  Search => 'Search',
	 );
  (@module)=(keys %main::module);
  if (@module) {
    $tab{"Modules"} = 'Modules';
  }
  if (%{latexinputed}) {
    $tab{"Input"} = '\\input';
  }
  if (($source) && ("$source" eq "index")) {
    %tab = (Fichiers => 'F',
	    Programmes => 'p',
	    Routines => 'r',
	    Fonctions => 'f',
	    Includes => 'I',
	    Search => 'S',
	   );
    if (@module) {
      $tab{"Modules"} = 'M';
    }
    if (%{latexinputed}) {
      $tab{"Input"} = '\\I';
    }
  }
  local($enteteloc)="<CENTER><TABLE BORDER=2 WIDTH=100% CELLPADDING=7 BGCOLOR=\"#AAFFC0\"><TR>\n";
  $enteteloc .= "<TH><A HREF=\"fileindex_c.html$file\" TARGET=\"source\"".&index::onMouseOver("$tab{Fichiers}").">$tab{'Fichiers'}</A></TH>\n";
  $enteteloc .= "<TH><A HREF=\"progindex_c.html\" TARGET=\"source\"".&index::onMouseOver("$tab{Programmes}").">$tab{'Programmes'}</A></TH>\n";
  $enteteloc .= "<TH><A HREF=\"routindex_c.html\" TARGET=\"source\"".&index::onMouseOver("$tab{Routines}").">$tab{'Routines'}</A></TH>\n";
  $enteteloc .= "<TH><A HREF=\"foncindex_c.html\" TARGET=\"source\"".&index::onMouseOver("$tab{Fonctions}").">$tab{'Fonctions'}</A></TH>\n";
  if ("$type" eq "include") {
    $enteteloc .= "<TH><A HREF=\"inclindex_c.html$file\" TARGET=\"source\"".&index::onMouseOver("$tab{Includes}").">$tab{'Includes'}</A></TH>\n";
  } else {
    $enteteloc .= "<TH><A HREF=\"inclindex_c.html\" TARGET=\"source\"".&index::onMouseOver("$tab{Includes}").">$tab{'Includes'}</A></TH>\n";
  }
  if (%{latexinputed}) {
    if ("$type" eq "input") {
      $enteteloc .= "<TH><A HREF=\"inpuindex_c.html$file\" TARGET=\"source\"".&index::onMouseOver("$tab{Input}").">$tab{'Input'}</A></TH>\n";
    } else {
      $enteteloc .= "<TH><A HREF=\"inpuindex_c.html\" TARGET=\"source\"".&index::onMouseOver("$tab{Input}").">$tab{'Input'}</A></TH>\n";
    }
  }
  $enteteloc .= "<TH><A HREF=\"javanavig_c.html\" TARGET=\"source\"".&index::onMouseOver("$tab{Search}").">$tab{'Search'}</A></TH>\n";
  if (@module) {
    $enteteloc .= "<TH><A HREF=\"moduleindex_c.html\" TARGET=\"source\"".&index::onMouseOver("$tab{Modules}").">$tab{'Modules'}</A></TH>\n";
  }
  $enteteloc .= "</TR></TABLE></CENTER>\n";
  return($enteteloc);
}
#%###################################################
sub numerique { $a <=> $b; }
#%###################################################
sub Index_Private_Called {
  local($Routine,$source,$index)=@_;
  local($localRoutine,$fichier,$numDef)=GetInfoRoutine($Routine);
  &fichiers::GetIncludeCibleOfWrite($fichier);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne,$uphtmlligne)=("","");

  local($num)=0;
  local($ref)="";

  local(@liste_appels_complet)=();
  if (exists $realcalled{"$Routine"}) {
    # Define a table on the calling routines of $nom
    $uphtmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " is called by\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$realcalled{$Routine}};
    foreach $Reference (@liste_appels_complet) {
      # The following should equal to first part of $Routine... unless
      # it is an alias on it (with the local redeclaration on module use)
      local($suspectcasei) = ${realcalled{$Routine}}{$Reference} ;
      local($localReference,$file,$num)=GetInfoRoutine($Reference);
      @numlist=();
      if (!IsFatherNotTop("$father{$Routine}")) {
	# Means the procedure that is called is a global one
	if ((defined(%{$Appelants{$localRoutine}})) && (${$Appelants{$localRoutine}}{$Reference})) {
	  (@numlist)=(sort numerique split(/ /, ${$Appelants{$localRoutine}}{$Reference})) ;
	}
      } elsif (!IsFatherNotTop("$father{$Reference}")) {
	# Means the procedure that is called is a global one
	(@numlist)=(@{${$effectcalled{$Reference}}{$suspectcasei}}) ;
      } else {
	# Means the procedure that is called is a private one
	#		print "Private $localRoutine($fichier,$numDef) called by $Reference\n";
	(@numlist)=(@{${$effectcalled{$Reference}}{$suspectcasei}}) ;
      }
      if (@numlist) {
	$htmlligne .= &{$affiche{"li"}};
	$htmlligne .= &{$affiche{"DeclareRef"}}($source,$index,$localReference,$Reference,$localReference,$file) ;
	$htmlligne .= &{$affiche{"iliste"}}($source,$index,$Reference,@numlist) ;
	#                ($lochtmlligne,$loclatexligne) = (MakeCalledF90Html($source,$index,$tag,"C_$localReference")) ;
	#                $htmlligne .= $lochtmlligne ; $latexligne .= $loclatexligne ;
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " is not called.\n";
  }
  return($htmlligne);
}
;

#|#######################################################
sub Index_Private_Defines {
  local($totalRoutine,$source,$index)=@_;
  local($localRoutine,$file,$numdef)=GetInfoRoutine($totalRoutine);
  $RoutineCasei = main::GetLowerCase($localRoutine) ;
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne,$uphtmlligne)=("","");
  local($num)="";

  local(@sons) =();

  if ((exists $main::sons{"$totalRoutine"}) && (defined(%{$main::sons{$totalRoutine}}))) {
    (@sons) = (keys %{$main::sons{$totalRoutine}}) ;
  }
  if (@sons) {
    $uphtmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$RoutineCasei,$totalRoutine,$RoutineCasei) ;
    $uphtmlligne .= " defines private routines\n" ;
    $uphtmlligne .= &{$affiche{"bul"}}."\n" ;
    foreach $son (keys %{$main::sons{$totalRoutine}}) {
      local($privateRoutine) = ${$main::sons{$totalRoutine}}{$son} ;
      local($localPrivate,$a,$b) = main::GetInfoRoutine($privateRoutine) ;
      $htmlligne .= &{$affiche{"li"}} ;
      $htmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localPrivate,$privateRoutine,$localPrivate) ;
      $htmlligne .= "\n";
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$RoutineCasei,$totalRoutine,$RoutineCasei) ;
    $htmlligne .= " declares nothing.\n";
  }
  return($htmlligne);
}
;

#|#######################################################
sub Index_Private_Calls {
  local($Routine,$source,$index)=@_;
  local($localRoutine,$file,$numdef)=GetInfoRoutine($Routine);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne,$uphtmlligne)=("","");
  local($num)="";

  local(@liste_appels_complet)=();

  if (defined(%{$realcalls{$Routine}})) {
    # Define a table on the routines called by $Routine
    $uphtmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " calls\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$realcalls{$Routine}};
    foreach $suspectcasei (@liste_appels_complet) {
      $Reference = ${realcalls{$Routine}}{$suspectcasei} ;
      # Obviously, $localReference equals $suspectcasei...
      local($localReference,$fichier,$num)=GetInfoRoutine($Reference);
      @numlist=();
      #	print "Routine $Routine calls lc $suspectcasei in Appellees=$localReference.\n";
      if (!IsFatherNotTop("$father{$Routine}")) {
	# Means the procedure that is called is a global one
	if ((defined(%{$Appellees{$Routine}})) && (${$Appellees{$Routine}}{$suspectcasei})) {
	  (@numlist)=(sort numerique split(/ /, ${$Appellees{$Routine}}{$suspectcasei})) ;
	  if (@numlist) {
	    $htmlligne .= &{$affiche{"li"}};
	    $htmlligne .= &{$affiche{"DeclareRef"}}($source,$index,$suspectcasei,$Reference,$suspectcasei,$fichier) ;
	    $htmlligne .= &{$affiche{"liste"}}($source,$index,$Routine,@numlist) ;
	  }
	}
      }
      if (defined(@{${$effectcalled{$Routine}}{$suspectcasei}})) {
	(@numlist)=(@{${$effectcalled{$Routine}}{$suspectcasei}}) ;
	if (@numlist) {
	  $htmlligne .= &{$affiche{"li"}};
	  $htmlligne .= &{$affiche{"DeclareRef"}}($source,$index,$localReference,$Reference,$localReference,$fichier) ;
	  $htmlligne .= &{$affiche{"liste"}}($source,$index,$Routine,@numlist) ;
	}
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " does not call anything.\n";
  }
  return($htmlligne);
}
;

#|#######################################################
sub Index_Private_Uses {
  local($Routine,$source,$index)=@_;
  local($localRoutine,$file,$numdef)=GetInfoRoutine($Routine);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne,$uphtmlligne)=("","");
  local($num)="";

  local(@liste_appels_complet)=();
  if (defined(%{$realuses{$Routine}})) {
    # Define a table on the routines called by $Routine
    $uphtmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " uses\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$realuses{$Routine}};
    foreach $Reference (@liste_appels_complet) {
      # Obviously, $localReference equals $suspectcasei...
      local($localReference,$fichier,$num)=GetInfoRoutine($Reference);
      #	    print "$localRoutine calls $localReference and is defined at $Routine\n";
      local(@numlist)=();
      $htmlligne .= &{$affiche{"li"}};
      $htmlligne .= &{$affiche{"DeclareRef"}}($source,$index,$localReference,$Reference,$localReference,$fichier) ;
      #            $tag = "R_$localReference";
      if (defined(@{${$realuses{$Routine}}{$Reference}})) {
	(@numlist)=(@{${$realuses{$Routine}}{$Reference}}) ;
	if (@numlist) {
	  # NAJ: Elucider cette affaiire
	  $htmlligne .= &{$affiche{"liste"}}($source,$index,$Routine,@numlist) ;
	  #                  ($lochtmlligne,$loclatexligne) = (MakeCallsF90Html($source,$index,$tag,"C_$localRoutine"));
	  #                  $htmlligne .= $lochtmlligne ; $latexligne .= $loclatexligne ;
	}
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " does not use anything.\n";
  }
  return($htmlligne);
}
;

#%###################################################
sub Index_Private_Used {
  local($Routine,$source,$index)=@_;
  local($localRoutine,$fichier,$numDef)=GetInfoRoutine($Routine);
  &fichiers::GetIncludeCibleOfWrite($fichier);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne)="";
  local($num)=0;
  local($ref)="";
  local($uphtmlligne) = ("","");

  local(@liste_appels_complet)=();
  if (exists $realused{"$Routine"}) {
    # Define a table on the calling routines of $nom
    $uphtmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " is used by\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$realused{$Routine}};
    foreach $Reference (@liste_appels_complet) {
      # The following should equal to first part of $Routine... unless
      # it is an alias on it (with the local redeclaration on module use)
      local($localReference,$file,$num)=GetInfoRoutine($Reference);
      local(@numlist)=();
      (@numlist)=(@{${$realused{$Routine}}{$Reference}}) ;
      $htmlligne .= &{$affiche{"li"}}."\n";
      $htmlligne .= &{$affiche{"DeclareRef"}}($source,$index,$localReference,$Reference,$localReference,$file) ;
      if (@numlist) {
	$htmlligne .= &{$affiche{"liste"}}($source,$index,$Reference,@numlist) ;
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " is not used.\n";
  }
  return($htmlligne);
}

#%###################################################
sub Index_Private_Included {
  local($Routine,$source,$index)=@_;
  local($localRoutine,$fichier,$numDef)=GetInfoRoutineCasei($Routine);
  &fichiers::GetIncludeCibleOfWrite($fichier);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne)="";
  local($num)=0;
  local($ref)="";
  local($uphtmlligne) = ("","");

  local(@liste_appels_complet)=();
  if (exists $f90included{"$Routine"}) {
    # Define a table on the calling routines of $nom
    $uphtmlligne .= &{$affiche{"IncludeNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " is included by\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$f90included{$Routine}};
    foreach $Reference (@liste_appels_complet) {
      # The following should equal to first part of $Routine... unless
      # it is an alias on it (with the local redeclaration on module use)
      local($localReference,$fichier,$num)=GetInfoRoutine($Reference);
      local(@numlist)=();
      (@numlist)=(@{${$f90included{$Routine}}{$Reference}}) ;
      $htmlligne .= &{$affiche{"li"}}."\n";
      $htmlligne .= &{$affiche{"DeclareRef"}}($source,$index,$localReference,$Reference,$localReference,$fichier) ;
      if (@numlist) {
	$htmlligne .= &{$affiche{"iliste"}}($source,$index,$Reference,@numlist) ;
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"IncludeNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " is not included.\n";
  }
  return($htmlligne);
}
#|#######################################################
sub Index_Private_Includes {
  local($Routine,$source,$index)=@_;
  local($localRoutine,$file,$numdef)=GetInfoRoutineCasei($Routine);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne,$uphtmlligne)=("","");
  local($num)="";

  local(@liste_appels_complet)=();
  if (defined(%{$f90includes{$Routine}})) {
    # Define a table on the routines called by $Routine
    $uphtmlligne .= &{$affiche{"IncludeNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " includes\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$f90includes{$Routine}};
    foreach $Reference (@liste_appels_complet) {
      ##	    print "OC: Includes $Routine of $Reference\n";
      # Obviously, $localReference equals $suspectcasei...
      local($localReference,$fichier,$num)=GetInfoRoutineCasei($Reference);
      #	    print "$localRoutine calls $localReference and is defined at $Routine\n";
      local(@numlist)=();
      $htmlligne .= &{$affiche{"li"}};
      $htmlligne .= &{$affiche{"IncludeNolabel"}}($source,$index,$localReference,$Reference,$localReference) ;
      #            $tag = "R_$localReference";
      if (defined(@{${$f90includes{$Routine}}{$Reference}})) {
	(@numlist)=(@{${$f90includes{$Routine}}{$Reference}}) ;
	if (@numlist) {
	  # NAJ: Elucider cette affaiire
	  $htmlligne .= &{$affiche{"iliste"}}($source,$index,$Routine,@numlist) ;
	  #                  ($lochtmlligne,$loclatexligne) = (MakeCallsF90Html($source,$index,$tag,"C_$localRoutine"));
	  #                  $htmlligne .= $lochtmlligne ; $latexligne .= $loclatexligne ;
	}
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"IncludeNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " does not include anything.\n";
  }
  return($htmlligne);
}
;

#%###################################################
sub Index_Private_Inputed {
  local($Routine,$source,$index)=@_;
  #    print "OC: a Inputed Routine=$Routine\n";
  local($localRoutine,$fichier,$numDef)=GetInfoRoutineCasei($Routine);
  #    print "OC: b Inputed Routine=$localRoutine,$file,$numdef\n";
  &fichiers::GetInputCibleOfWrite($fichier);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne)="";
  local($num)=0;
  local($ref)="";
  local($uphtmlligne) = ("","");

  local(@liste_appels_complet)=();
  if (exists $latexinputed{"$Routine"}) {
    # Define a table on the calling routines of $nom
    $uphtmlligne .= &{$affiche{"InputNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " is inputed by\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$latexinputed{$Routine}};
    foreach $Reference (@liste_appels_complet) {
      # The following should equal to first part of $Routine... unless
      # it is an alias on it (with the local redeclaration on module use)
      local($localReference,$fichier,$num)=GetInfoRoutine($Reference);
      local(@numlist)=();
      (@numlist)=(@{${latexinputed{$Routine}}{$Reference}}) ;
      $htmlligne .= &{$affiche{"li"}}."\n";
      $htmlligne .= &{$affiche{"DeclareRef"}}($source,$index,$localReference,$Reference,$localReference,$fichier) ;
      if (@numlist) {
	$htmlligne .= &{$affiche{"iliste"}}($source,$index,$Reference,@numlist) ;
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"InputNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " is not inputed.\n";
  }
  return($htmlligne);
}
#|#######################################################
sub Index_Private_Inputs {
  local($Routine,$source,$index)=@_;
  local($localRoutine,$file,$numdef)=GetInfoRoutineCasei($Routine);
  $index = "" unless ($index);
  $source = "" unless $source ;
  local($htmlligne,$uphtmlligne)=("","");
  local($num)="";

  local(@liste_appels_complet)=();
  if (defined(%{$latexinputs{$Routine}})) {
    # Define a table on the routines called by $Routine
    $uphtmlligne .= &{$affiche{"InputNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $uphtmlligne .= " inputs\n";
    $uphtmlligne .= &{$affiche{"bul"}}."\n";
    # Do note that a private routine cannot be called outside its scope !
    @liste_appels_complet = sort keys %{$latexinputs{$Routine}};
    foreach $Reference (@liste_appels_complet) {
      # Obviously, $localReference equals $suspectcasei...
      local($localReference,$fichier,$num)=GetInfoRoutine($Reference);
      #	    print "$localRoutine calls $localReference and is defined at $Routine\n";
      local(@numlist)=();
      $htmlligne .= &{$affiche{"li"}};
      $htmlligne .= &{$affiche{"InputNolabel"}}($source,$index,$localReference,$Reference,$localReference) ;
      #            $tag = "R_$localReference";
      if (defined(@{${$latexinputs{$Routine}}{$Reference}})) {
	(@numlist)=(@{${$latexinputs{$Routine}}{$Reference}}) ;
	if (@numlist) {
	  # NAJ: Elucider cette affaiire
	  $htmlligne .= &{$affiche{"iliste"}}($source,$index,$Routine,@numlist) ;
	  #                  ($lochtmlligne,$loclatexligne) = (MakeCallsF90Html($source,$index,$tag,"C_$localRoutine"));
	  #                  $htmlligne .= $lochtmlligne ; $latexligne .= $loclatexligne ;
	}
      }
    }
  }
  if ("$htmlligne" ne "") {
    $htmlligne .= &{$affiche{"eul"}}."\n";
    $htmlligne = $uphtmlligne.$htmlligne ;
  } else {
    $htmlligne .= &{$affiche{"InputNolabel"}}($source,$index,$localRoutine,$Routine,$localRoutine) ;
    $htmlligne .= " does not input anything.\n";
  }
  return($htmlligne);
}
;


#|#######################################################
sub Printf_Commentaire_CC {
  # on enleve le terme en printf, mais on fait attention a ne pas eliminer
  # les \#include !!!
  unless ( $instruction =~ /^#include\s/ ) {  # 
    while ( $instruction =~ /(.*)\".*\"(.*)/ ) { # recherche " 
      $instruction = $1.$2 ;
    }
    while ( $instruction =~ /(.*)\'.*\'(.*)/ ) { # recherche '
      $instruction = $1.$2 ;
    }
  }
}
;

#|#######################################################
sub Remp_Special {
  local($ligne)=@_;
  if ($ligne =~ /[<>]/) {
    while (@special) {
      $char = shift @special;
      $remp = shift @special;
      $ligne =~ s/$char/$remp/g ;
    }
  }
}

#|#######################################################
sub Fin_Anormale {
  print "Fichier $file, ligne $.\n" ;
  exit 1 ;
}
;
#|#######################################################
sub Input_Detect {
  local($file,$Routine,$num,$fichier)=@_;
  local($totalFichier) = "" ;
  if ($input=&fichiers::find_input($fichier)) {
    #	print "Recherche du chemin absolu de $DIRC  $input\n";
    $input = &fichiers::CheminAbsoluDeAaB("$DIRC",$input) ;
    #	print "\t\t$input\n";
    if (exists $Input_Unique{"$input"}) {
      $Input_Alias{$fichier} = $input ;
      $fichier = $Input_Unique{"$input"} ; # FIFO: a way to make fichier unique as well.
    } else {
      $Input_Unique{"$input"} = $fichier ;
      push(@listetex,"$fichier:$input:0"); # This is a new file to add
      $File_Of_Rout{$input} = $input ;
      #	    print "Recherche du chemin relatif de $DIRE  $include\n";
      local($fic) = &fichiers::CheminRelatifDeAaB("$DIRE",&fichiers::dirname($input)) ;
      if ($fic) {
	$fic .= '/'.&fichiers::basename($input) ;
      } else {
	$fic = &fichiers::basename($input) ;
      }
      $Input_Alias{$fichier} = $input ;
    }
    $totalFichier = "$fichier:$input:0";
  } else {
    $totalFichier = "$fichier:0:0";
    $input_exclu{$fichier} = 1 ;
    #	print "exclude $fichier\n";
  }
  push(@{${$latexinputed{$totalFichier}}{$Routine}},$num) ;
  push(@{${$latexinputs{$Routine}}{$totalFichier}},$num) ;
}
#|#######################################################
sub Etat_Avancement {
  local($Compteur_local,$Maxi) = @_;
  if ($Maxi > 100) {
    $Maxi = 10 ;
  } elsif ($Maxi > 20) {
    $Maxi = 4 ;
  } else {
    $Maxi = 0 ;
  }
  if ($Compteur_local >= $Maxi) {
    $Compteur_local=0 ;
    print STDOUT "." ;
  } else {
    $Compteur_local++ ;
  }
  return ($Compteur_local);
}

#|#######################################################
sub Affiche_Num {
  local($local_ligne,$ligne)=@_;
  if ((!$opt_nolinenum)||(!$opt_nofile)) {
    $local_ligne++ ;
    if ($local_ligne >= $num_affiche) {
      print OBJET "<DIV ALIGN=\"right\"><FONT CLASS=\"info\">";
      if (!$opt_nofile) {
	if ($file_bis) {
	  print OBJET "$file_bis" ;
	} else {
	  print OBJET "$file-\&gt;$Routine" ;
	}
      }
      print OBJET "-\&gt;$." if (!$opt_nolinenum) ;
      print OBJET "</FONT></DIV>\n";
      $local_ligne = 0 ;
    }
  }
  print OBJET "<!LINE=$.>" ;
  return ($local_ligne,$ligne) ;
}

#|#######################################################
sub Affiche_F90_Num {
  local($local_ligne,$ligne)=@_;
  local($affligne)="";
  if ((!$opt_nolinenum)||(!$opt_nofile)) {
    $local_ligne++ ;
    if ($local_ligne >= $num_affiche) {
      $affligne .= "<BR><DIV ALIGN=\"right\"><FONT CLASS=\"info\">";
      if (!$opt_nofile) {
	if ($file_bis) {
	  $affligne .= "$file_bis" ;
	} else {
	  $affligne .= "$file-\&gt;$localRoutine" ;
	}
      }
      $affligne .= "-\&gt;$." if (!$opt_nolinenum) ;
      $affligne .= "</FONT></DIV>\n";
      $local_ligne = 0 ;
    }
  }
  print OBJET "<!LINE=$.>" ;
  return ($local_ligne,$ligne,$affligne) ;
}

#|#######################################################
sub Fontification_Html_Du_C {
  local($TypeUp,@liste)=@_;
  $Compteur_local = 0 ;
  %special=( "<" => "&lt;" , ">" => "&gt;" );
  $file_bis = "" ;
  &fontify::InitCodeComments("C") ;
  foreach $file (@liste) {
    $process{$file} = 1 ;
    $Full_Html=0;
    if ($opt_latex) {
      $Full_Html=1;
    }
    #	&MyCodeAndComments ;
    $Compteur_local=Etat_Avancement($Compteur_local,$#liste);
    unless (open(SOURCE,"<$file")) {
      warn "Error: Impossible to read C $file" ;
      next ;
    }
    $Ligne_Next = 0 ;
    $Ligne_Actu = 0 ;
    $Routine = "$file" ;
    if (exists $Include_Unique{$file}) {
      $totalRoutine=GetTotalInclude($file);
    } else {
      $totalRoutine=GetTotalRoutine($file);
    }
    if ( $TypeUp eq "include" ) { # Fichier include
      if ($Routine =~ /^\//) {
	$Routine = &fichiers::IncludeFileOfWrite($Routine) ;
	&fichiers::GetIncludeCibleOfWrite($Routine) ;
      }
      $objet = &fichiers::IncludeFileOfWrite($file) ;
      &fichiers::GetIncludeCibleOfWrite($objet) ;
      $language="h";
      #	    $Routine = "$1.$2" ;
      unless (open(OBJET,">$DIRE/${objet}_c.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(LEFTINDEX,">$DIRE/${objet}_i.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(MAINFRAME,">$DIRE/${objet}.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      $ligne=&En_Tete_Inclu($file,"source");
      print OBJET "$ligne" ;

      $ligne=&En_Tete_Inclu($file,"index");
      $file_bis=&index::FileName($file) ;
      $ligne .= &{$affiche{"Private_Includes"}}($totalRoutine,"source") ;
      $ligne .= &{$affiche{"Private_Included"}}($totalRoutine,"source") ;
      print LEFTINDEX "$ligne" ;
      print MAINFRAME '<html>
<head>
   <title>'.$objet.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${objet}.'_i.html" NAME="index">
  <frame SRC="'.$objet.'_c.html" NAME="source">
</frameset>
</html>' ;
      close (MAINFRAME) ;
    } else {
      $objet = $file ;
      &fichiers::GetIncludeCibleOfWrite($objet) ;
      $language="c";
      unless (open(OBJET,">$DIRE/${objet}_c.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(LEFTINDEX,">$DIRE/${objet}_i.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(MAINFRAME,">$DIRE/${objet}.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      print MAINFRAME '<html>
<head>
   <title>'.$objet.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${objet}.'_i.html" NAME="index">
  <frame SRC="'.$objet.'_c.html" NAME="source">
</frameset>
</html>' ;
      close (MAINFRAME) ;
      $ligne=&En_Tete_C($file,"source") ; # Mise en place du titre classique
      print OBJET "$ligne" ;
      $ligne=&En_Tete_C($file,"index") ; # Mise en place du titre classique
      print LEFTINDEX "$ligne" ;
      &javaindex::SmallJavaNavigator($file) if $java ;
    }
    if (exists $lfichiers{$file}) {
      (@list_rout) = (@{$lfichiers{$file}}) ;
      $nextRoutine = shift @list_rout;
      ($NextRoutine,$nextFile,$Ligne_Next) = GetInfoRoutine($nextRoutine) ;
    }
    $paren = 0 ;
    $comm = 0 ;
    $acco = 0 ;
    $commentaire="";
    $instruction="";
    $local_ligne=0 ;
    while (defined($ligne=<SOURCE>)) {
      chomp($ligne);
      ($local_ligne,$ligne)=Affiche_Num($local_ligne,$ligne);
      if ($ligne =~ /[<>]/) {
	foreach $char (keys %special) {
	  $ligne =~ s/$char/$special{$char}/g ;
	}
      }
      $commentaire="";
      $instruction="";
      ($comm,$ligne)=searchfc::C_Instruction_Commentaire($comm,$ligne);
      if (($commentaire =~ /input/) && 
	  ($commentaire =~ /.*\\input\s+([\w_\.\/]+)/i)) {
	$input=$1;
	$ligne = &Input_Html($input,$ligne,"source",$totalRoutine);
      }
      unless ($instruction) {
	if ($. == 1) {
	  $Full_Html=First_Line_Analysis($commentaire);
	}
	$ligne=&LatexBuiltinProcess($ligne);
	print OBJET "$ligne\n";
	next;
      }
      if ($. == $Ligne_Next) {
	$Routine = $NextRoutine ;
	$totalRoutine = GetTotalRoutine($Routine) ;
	$Ligne_Actu=$Ligne_Next;
	if ($nextRoutine = shift @list_rout) {
	  ($NextRoutine,$nextFile,$Ligne_Next) = GetInfoRoutine($nextRoutine) ;
	}
	$acco = 0 ;
	$paren=1;
	$ligne = "$fontify::HR".$ligne;
      }
      if ($paren) {
	($paren,$parenmoved)=searchfc::Find_Parenthesis($paren,$instruction);
	if (($parenmoved) && ($paren == 1)) {
	  $paren = 0 ;
	  $ligne .= "</FONT>";
	  #		print "file $file line $. terminates color $ligne\n";
	}
      }
      ($acco,$accomoved)=searchfc::C_Accolade($acco,$instruction);
      if ($accomoved) {
	if ($acco == 0) {
	  if ($language ne "h") {
	    $ligne .= &fontify::end_code."<TAB>".&fontify::start_header."End of <A HREF=\"#R_$Routine\" ".Target("source").">$Routine</A>".&fontify::end_header."$fontify::HR".&fontify::start_code ;
	    $Routine = "$file" ;
	    $totalRoutine = GetTotalRoutine($Routine) ;
	  }
	}
      }
      if ( $instruction =~ /(include)/i) {
	if ( $instruction =~ /^\#include\s*[\'\"]([\w_\.]*)[\"\']/i) {
	  $include=$1;
	  $ligne = &Include_F90_Html($include,$ligne,"source",$totalRoutine);
	}
      }
      if ($. == $Ligne_Actu) {
	unless ($Routine) {
	  # Il faudra analyser cette situation un jour...
	  print "Error: $.-$_-$ligne-$file";
	}
	$totalRoutine = GetTotalRoutine($Routine) ;
	if ($Routine eq "main") {
	  $lien = "<A HREF=\"${objet}_i.html#R_$Routine\" TARGET=\"index\">$Routine</A>";
	  $lien_top = &index::OnJava("$objet","$Routine","$java")."$Routine</A>";
	} else {
	  $lien = "<A HREF=\"${objet}_i.html#R_$Routine\" TARGET=\"index\">$Routine</A>";
	  $lien_top = &index::OnJava("$objet","$Routine","$java")."$Routine</A>";
	}
	if ($ligne =~ /(.*$Routine\s*)\((.*)/i) {
	  $start = $1;
	  $end   = $2;
	  $start_top = $start;
	  if ($start =~ /\b($Routine)\b/i) {
	    $a = $1 ;
	    $start =~ s/$a/$lien/;
	    $start_top =~ s/$a/$lien_top/;
	  } else {
	    print "E(D1)[$file-$.]($start-$Routine)\n";
	    $start =~ s/$Routine/$lien/;
	    $start_top =~ s/$Routine/$lien_top/;
	  }
	  $ligne = "<A NAME=R_$Routine></A>".$start ;
	  $ligne_top = "<A NAME=R_$Routine></A>".$start_top;
	  $ligne_add = $fontify::ligne_ini ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Called"}}($totalRoutine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Calls"}}($totalRoutine,"source") ;
	  #		$ligne_add .= Gere_Index_Appelants($Routine,"source") ;
	  #		$ligne_add .= Gere_Index_Appellees($Routine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Includes"}}($totalRoutine,"source") ;
	  #		$ligne_add .= Gere_Index_Includes($file,$Routine,"source") ;
	  if ($ligne_add ne $fontify::ligne_ini) {
	    $ligne .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	    $ligne_top .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	  }
	  $ligne .= &fontify::start_header."(".$end ;
	  print LEFTINDEX "<P>$ligne_top\n";
	} else {
	  print "Routine=$Routine\n" if $debug ; 
	  $ligne_top =  $ligne;
	  $ligne_top =~ s/$Routine/$lien_top/;
	  $ligne =~ s/$Routine/$lien/;
	  $ligne = "<A NAME=R_$Routine></A>".$ligne ;
	  $ligne_top = "<A NAME=R_$Routine></A>".$ligne_top ;
	  $ligne_add = $fontify::ligne_ini ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Called"}}($totalRoutine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Calls"}}($totalRoutine,"source") ;
	  #		$ligne_add .= Gere_Index_Appelants($Routine,"source") ;
	  #		$ligne_add .= Gere_Index_Appellees($Routine,"source") ;
	  #		$ligne_add .= Gere_Index_Includes($file,$Routine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Includes"}}($totalRoutine,"source") ;
	  if ($ligne_add ne $fontify::ligne_ini) {
	    $ligne .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	    $ligne_top .= $ligne_add."</FONT>\n" ;
	  }
	  $paren = 0 ;
	  print LEFTINDEX "<P>$ligne_top\n";
	}
      } elsif ( $Routine ne "0" ) {
	($Called_local,$Reference,$arg,$Red)=Call_Detect($instruction) ;
	while ($Reference) {
	  if (($Reference)&&(!$Red)) {
	    $paren=2;
	    $num=$.;
	    $cref = "" . CodeName($File_Of_Rout{$Reference},"source") . ".html#R_$Reference" ;
	    $lien  = "<A HREF=\"$cref\" ".Target("source").">$Called_local</A>";
	    $lien .= &fontify::start_branchement;
	    ## La parenthse ci-dessous est artificielle.
	    $lien .= '(';
	    $end_paren = 0 ;
	    if ($arg) {
	      ($paren,$parenmoved,$end_paren)=searchfc::Find_Parenthesis($paren,$arg);
	    }
	    if ($paren == 1) {
	      $paren = 0 ;
	      if ($end_paren) {
		local($end_fils) = quotemeta "$end_paren" ;
		$arg =~ s/$end_fils/$end_paren<\/FONT>/;
	      } else {
		$arg .= '</FONT>';
		print "Right Parenthesis file $file line $. for instruction $ligne\n";
	      }
	      $lien .= $arg ;
	      $ligne =~ s/$Called_local\s*\(.*/$lien/;
	    } elsif ($end_paren) {
	      $lien .= $end_paren ;
	      $ligne =~ s/$Called_local\s*\(.*/$lien/;
	    } else {
	      $ligne =~ s/$Called_local\s*\(/$lien/;
	    }
	    $ligne = "<A NAME=C_$Routine$num></A>".$ligne ;
	  }
	  ($Called_local,$Reference,$arg,$Red)=Call_Detect($arg) ;
	}
      }
      print OBJET "$ligne\n";
    }
    if ($comm) {
      print OBJET &fontify::end_comment."\n";
    } else {
      print OBJET &fontify::end_code."\n";
    }
    if ($language eq "h") {
      print OBJET "<TAB>".&fontify::start_header."End of $Routine".&fontify::end_header;
    }
    print OBJET "$fontify::HR</BODY></HTML>\n";
    close(OBJET);
    close(SOURCE);
  }
}

#|#######################################################
sub Target {
  local($target)=@_;
  if ("$target" ne "") {
    return("TARGET=\"$target\"");
  } else {
    return("");
  }
}
#|#######################################################
sub CodeName {
  local($cref,$source)=@_;
  if (defined($source) && ("$source" ne "")) {
    if ("$source" eq "source") {
      warn "Undef cref file $file line $." unless $cref ;
      return("$cref".'_c');
    } elsif ($source eq "index") {
      return("$cref".'_i');
    } else {
      warn "Error: Unexpected source frame $source";
      return("") ;
    }
  } else {
    return("$cref");
  }
}
#|#######################################################
sub Fontification_Html_Du_F77 {
  local($TypeUp,@liste)=@_;
  $Compteur_local = 0 ;
  %special=( "<" => "&lt;" , ">" => "&gt;" );	    
  ##    undef($href);
  $file_bis = "" ;
  &fontify::InitCodeComments("f77") ;
  foreach $file (@liste) {
    print INFO "\t\tprocess 3 $file\n" if $debug ;
    $process{$file} = 1 ;
    $Full_Html=0;
    if ($opt_latex) {
      $Full_Html=1;
    }
    $Compteur_local=Etat_Avancement($Compteur_local,$#liste);
    unless (open(SOURCE,"<$file")) {
      warn "Severe Error(3-f1) $file";
      next ;
    }
    $Ligne_Next=0;
    $Ligne_Actu=0;
    $Routine = "$file";
    $RoutEncour = GetAlias($file);
    if (exists $Include_Unique{$file}) {
      $totalRoutine=GetTotalInclude($file);
    } else {
      $totalRoutine=GetTotalRoutine($file);
    }
    if ( $TypeUp eq "include" ) { # Fichier include
      if ($Routine =~ /^\//) {
	$Routine = &fichiers::IncludeFileOfWrite($Routine) ;
	&fichiers::GetIncludeCibleOfWrite($Routine) ;
      }
      $objet = &fichiers::IncludeFileOfWrite($file) ;
      &fichiers::GetIncludeCibleOfWrite($objet) ;
      #	    print "Creating include $objet from $file\n";
      unless (open(OBJET,">$DIRE/${objet}_c.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(LEFTINDEX,">$DIRE/${objet}_i.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(MAINFRAME,">$DIRE/${objet}.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      $ligne=&En_Tete_Inclu($file,"source");
      print OBJET "$ligne" ;

      $ligne=&En_Tete_Inclu($file,"index");
      $file_bis=&index::FileName($file) ;
      #	    &fichiers::GetIncludeCibleOfWrite($file_bis) ;
      $ligne .= &{$affiche{"Private_Includes"}}($totalRoutine,"source") ;
      $ligne .= &{$affiche{"Private_Included"}}($totalRoutine,"source") ;
      print LEFTINDEX "$ligne" ;
      print MAINFRAME '<html>
<head>
   <title>'.$objet.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${objet}.'_i.html" NAME="index">
  <frame SRC="'.$objet.'_c.html" NAME="source">
</frameset>
</html>' ;
      close (MAINFRAME) ;
    } else {
      $objet = $file ;
      &fichiers::GetIncludeCibleOfWrite($objet) ;
      unless (open(OBJET,">$DIRE/${objet}_c.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(LEFTINDEX,">$DIRE/${objet}_i.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      unless (open(MAINFRAME,">$DIRE/${objet}.html")) {
	warn "Severe Error(3-f2) $objet";
	next ;
      }
      print MAINFRAME '<html>
<head>
   <title>'.$objet.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${objet}.'_i.html" NAME="index">
  <frame SRC="'.$objet.'_c.html" NAME="source">
</frameset>
</html>' ;
      close (MAINFRAME) ;
      $ligne=&En_Tete_F($file,"source") ; # Mise en place du titre classique
      print OBJET "$ligne" ;
      $ligne=&En_Tete_F($file,"index") ; # Mise en place du titre classique
      print LEFTINDEX "$ligne" ;
      &javaindex::SmallJavaNavigator($file) if $java;
    }
    if (exists $lfichiers{$file}) {
      (@list_rout) = (@{$lfichiers{$file}}) ;
      $nextRoutine = shift @list_rout;
      ($NextRoutine,$nextFile,$Ligne_Next) = &GetInfoRoutine($nextRoutine) ;
    } else {
      $Ligne_Next = -1 ;
    }
    $comm = 0 ;
    $paren=0;
    $local_ligne=0 ;
    while (defined($ligne=<SOURCE>)) {
      chomp $ligne;
      ($local_ligne,$ligne)=&Affiche_Num($local_ligne,$ligne);
      if ($ligne =~ /[<>]/) {
	foreach $char (keys %special) {
	  $ligne =~ s/$char/$special{$char}/g ;
	}
      }
      $commentaire=""; $instruction="";
      if (searchfc::Fortran_Comment($ligne)) {
	if ($ligne =~ /^D/) {
	  $ligne =~ s/^./<FONT COLOR=PURPLE>DEBUG<\/FONT>/ ;
	} else {
	  $ligne =~ s/^.// ;
	}
	if ( $ligne =~ /.*\\input\s+([\w_\.\/]+)/i) {
	  $input=$1;
	  $ligne = &Input_Html($input,$ligne,"source",$totalRoutine);
	}
	if ($. == 1) {
	  $Full_Html=First_Line_Analysis($ligne);
	}
	$ligne=&LatexBuiltinProcess($ligne);
	unless ($comm) {
	  $ligne = &fontify::end_code.&fontify::start_comment."$ligne";
	  $comm = 1;
	}
	print OBJET "$ligne\n";
	next ;
      } elsif ($comm) {
	print OBJET &fontify::end_comment.&fontify::start_code;
	$comm = 0;
      }
      unless ($Ligne_Next) {
	warn "err $file qt $. no next line";
      }
      if ($. == $Ligne_Next) {
	#|		print "Ligne $.\n";
	$Routine = $NextRoutine ;
	$RoutEncour = &GetLowerCase($Routine);
	$totalRoutine = &GetTotalRoutine($RoutEncour) ;
	$Ligne_Actu=$Ligne_Next;
	if ($nextRoutine = shift @list_rout) {
	  ($NextRoutine,$nextFile,$Ligne_Next) = &GetInfoRoutine($nextRoutine) ;
	}
	$paren=1;
	$ligne = "$fontify::HR".$ligne;
      }
      if ($paren) {
	($paren,$parenmoved)=&searchfc::Find_Parenthesis($paren,$instruction);
	if (($parenmoved) && ($paren == 1)) {
	  $paren = 0 ;
	  $ligne .= "</FONT>";
	}
      }
      if ( $instruction =~ /include/i) {
	if ( $instruction =~ /include\s*[\'\"]([\w_\.\/]*)/i) {
	  # ' "
	  $include=$1;
	  $ligne = &Include_F90_Html($include,$ligne,"source",$totalRoutine);
	}
      }
      if ($. == $Ligne_Actu) {
	#|		print "Met $ligne\n";
	if ($ligne =~ /\b($Routine)\b/i) {
	  $Routine = $1 ;
	}
	$RoutineCasei = &GetLowerCase($Routine) ;
	$totalRoutine = &GetTotalRoutine($RoutineCasei) ;
	($lien,$lien_top)=&MakeF90Definition($ligne,$objet,$RoutineCasei,$Routine) ;
	if ($ligne =~ /(.*$Routine\s*)\((.*)/i) {
	  $start = $1;
	  $end   = $2;
	  $start_top = $start;
	  $start =~ s/$Routine/$lien/;
	  $start_top =~ s/$Routine/$lien_top/;
	  $ligne = "<A NAME=R_$RoutineCasei></A>".$start;
	  $ligne_top = "<A NAME=R_$RoutineCasei></A>".$start_top;
	  $ligne_add = $fontify::ligne_ini ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Called"}}($totalRoutine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Calls"}}($totalRoutine,"source") ;
	  #		    $ligne_add .= Gere_Index_Appelants($Routine,"source") ;
	  #		    $ligne_add .= Gere_Index_Appellees($Routine,"source") ;
	  #		    $ligne_add .= Gere_Index_Includes($file,$Routine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Includes"}}($totalRoutine,"source") ;
	  if ($ligne_add ne $fontify::ligne_ini) {
	    $ligne .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	    $ligne_top .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	  }
	  $ligne .= &fontify::start_header."(".$end ;
	  print LEFTINDEX "<P>$ligne_top\n";
	} else {
	  $ligne_top =  $ligne;
	  $ligne_top =~ s/$Routine/$lien_top/;
	  $ligne =~ s/$Routine/$lien/;
	  $ligne = "<A NAME=R_$RoutineCasei></A>".$ligne ;
	  $ligne_top = "<A NAME=R_$RoutineCasei></A>".$ligne_top ;
	  $ligne_add = $fontify::ligne_ini ;		
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Called"}}($totalRoutine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Calls"}}($totalRoutine,"source") ;
	  #		    $ligne_add .= Gere_Index_Appelants($Routine,"source") ;
	  #		    $ligne_add .= Gere_Index_Appellees($Routine,"source") ;
	  #		    $ligne_add .= Gere_Index_Includes($file,$Routine,"source") ;
	  $ligne_add .= &{$affiche{"br"}}.&{$affiche{"Private_Includes"}}($totalRoutine,"source") ;
	  if ($ligne_add ne $fontify::ligne_ini) {
	    $ligne .= $ligne_add."</FONT>".&fontify::start_code."\n" ;
	    $ligne_top .= $ligne_add."</FONT>\n" ;
	  }
	  $paren = 0 ;
	  print LEFTINDEX "<P>$ligne_top\n";
	}
      } elsif ( $Routine ne "0" ) {
	($string,$instruction,$commentaire) = &searchfc::Fortran90_String_Comment("",$instruction);
	($Called_local,$Reference,$arg,$Red)=&Call_Detect($instruction) ;
	if ($Reference) {
	  $paren=2;
	  $num=$.;
	  if ($Red) {
	    $lien = "<FONT COLOR=RED>$Called_local</FONT>";
	  } else {
	    $cref = "" . CodeName($File_Of_Rout{$Reference},"source") . ".html#R_$Reference" ;
	    $lien = "<A HREF=\"$cref\" ".Target("source").">$Called_local</A>";
	  }
	  $end_paren=0;
	  if ($arg) {
	    ($paren,$parenmoved,$end_paren)=&searchfc::Find_Parenthesis($paren,$arg);
	  }
	  if (($paren == 1)||($arg eq "-1")) {
	    $paren = 0 ;
	    local($arg_special)=$arg;
	    if ($end_paren) {
	      local($end_fils) = quotemeta "$end_paren" ;
	      $arg_special =~ s/$end_fils/$end_paren<\/FONT>/;
	      #|		    } else {
	      #|			$arg_special =~ s/\)/\)<\/FONT>/;
	      #|			print "Unexpected $file $. $ligne\n";
	    }
	    if ($arg_special ne $arg) { # cas -1 trait
	      $lien .= &fontify::start_branchement;
	      $lien .= '('.$arg_special ;
	      $ligne =~ s/$Called_local(\s*\().*/$lien/;
	    } else {
	      $ligne =~ s/$Called_local/$lien/;
	    }
	  } else {
	    $lien .= &fontify::start_branchement;
	    $ligne =~ s/$Called_local/$lien/;
	  }
	  $ligne = "<A NAME=C_$RoutineCasei$num></A>".$ligne ;
	}
      }
      if (($ligne =~ /end/i) && ($ligne =~ /^[\d\s]{5}.\s*\bend\b\s*(.*)/i)) {
	#|		print "End of $RoutEncour at $. $ligne\n";
	if ($1) {
	  unless ($RoutEncour) {
	    warn "Error(3-EF) $file-$.-$_";
	  }
	  ($RoutEncour)=Fortran_End_Detect($1,$RoutEncour);
	} else {
	  $RoutEncour="0";
	}
	if ($RoutEncour eq "0") {
	  $paren=0;
	  $ligne .= "$fontify::END_CODE<TAB>".&fontify::start_header."End of <A HREF=\"#R_$RoutineCasei\" ".Target("source").">$Routine</A>".&fontify::end_header."$fontify::HR".&fontify::start_code ;
	  $Routine="0";
	}
      }
      if (!$opt_nocolor) {
	$ligne=&fontify::Fortran_Fontify($ligne);
      }
      if ($ligne =~ /(.*?)\!(.*)/) {
	$ligne = $1.'<I>!'.$2.'</I>';
      }
      print OBJET "$ligne\n";
    }
    if ($comm) {
      print OBJET "$fontify::END_COMMENT\n";
    } else {
      print OBJET "$fontify::END_CODE\n";
    }
    print OBJET "$fontify::HR</BODY></HTML>\n";
    close(OBJET);
    close (LEFTINDEX) ;
    close(SOURCE);
  }
}
#|#######################################################
sub GetTotalInput {
  my($input) = @_ ;
  my($fichier) = $Input_Unique{"$input"} ;
  return("$fichier:$input:0" ) ;
}
#|#######################################################
sub GetTotalRoutine {
  my($localRoutine) = @_ ;
  my($num) = 0 ;
  my($fic) = "" ;
  my($a) = "" ;
  if ($main::File_Of_Rout{$localRoutine}) {
    $fic = $main::File_Of_Rout{$localRoutine} ;
    if ($main::L_Declar{$localRoutine}) {
      $num = $main::L_Declar{$localRoutine} ;
    }
  } else {
    $a = main::GetLowerCase($localRoutine) ;
    if ($main::File_Of_Rout{$a}) {
      $fic = $main::File_Of_Rout{$a} ;
      $num = $main::L_Declar{$a} if $main::L_Declar{$a} ;
    } elsif ($R_Declar{$a}) {
      if ($main::File_Of_Rout{$R_Declar{$a}}) {
	$fic = $main::File_Of_Rout{$R_Declar{$a}} ;
	$num = $main::L_Declar{$R_Declar{$a}} if $main::L_Declar{$R_Declar{$a}} ;
      }
    }
  }
  $num = 0 if ("$num" eq "") ;
  $localRoutine = "$localRoutine:$fic:$num";
  return($localRoutine) ;
}
#|#######################################################
sub GetTotalRoutineF {
  my($localRoutine) = @_ ;
  my($num) = 0 ;
  my($fic) = "" ;
  my($a) = "" ;
  if ($main::File_Of_Rout{$localRoutine}) {
    $fic = $main::File_Of_Rout{$localRoutine} ;
    if ($main::L_Declar{$localRoutine}) {
      $num = $main::L_Declar{$localRoutine} ;
    }
  } else {
    $a = main::GetLowerCase($localRoutine) ;
    if ($main::File_Of_Rout{$a}) {
      $fic = $main::File_Of_Rout{$a} ;
      $num = $main::L_Declar{$a} if $main::L_Declar{$a} ;
    } elsif ($R_Declar{$a}) {
      if ($main::File_Of_Rout{$R_Declar{$a}}) {
	$fic = $main::File_Of_Rout{$R_Declar{$a}} ;
	$num = $main::L_Declar{$R_Declar{$a}} if $main::L_Declar{$R_Declar{$a}} ;
	# Allow for C calls
	$localRoutine = "$R_Declar{$a}";
      }
    }
  }
  $num = 0 if ("$num" eq "") ;
  $localRoutine = "$localRoutine:$fic:$num";
  return($localRoutine) ;
}
#|#######################################################
sub GetTotalRoutineC {
  my($localRoutine) = @_ ;
  my($num) = 0 ;
  my($fic) = "" ;
  my($a) = "" ;
  if ($main::File_Of_Rout{$localRoutine}) {
    $fic = $main::File_Of_Rout{$localRoutine} ;
    if ($main::L_Declar{$localRoutine}) {
      $num = $main::L_Declar{$localRoutine} ;
    }
  } else {
    $a = main::GetLowerCase($localRoutine) ;
    if ($main::File_Of_Rout{$a}) {
      $fic = $main::File_Of_Rout{$a} ;
      $num = $main::L_Declar{$a} if $main::L_Declar{$a} ;
    } elsif ($R_Declar{$a}) {
      if ($main::File_Of_Rout{$R_Declar{$a}}) {
	$fic = $main::File_Of_Rout{$R_Declar{$a}} ;
	$num = $main::L_Declar{$R_Declar{$a}} if $main::L_Declar{$R_Declar{$a}} ;
      }
    }
    if ($fic) {
      $localRoutine = "$a" ;
    }
  }
  $num = 0 if ("$num" eq "") ;
  return("$localRoutine:$fic:$num","$localRoutine") ;
}
#|#######################################################
sub GetTotalInclude {
  my($fichier) = @_ ;
  my($totalInclude) = "" ;
  if (exists $Include_Unique{$fichier}) {
    $totalInclude = "$Include_Unique{$fichier}:$File_Of_Rout{$Include_Unique{$fichier}}:0" ;
  } else {
    warn "Error: for include $fichier Include_Unique unknown";
    $totalInclude = "$fichier:$File_Of_Rout{$fichier}:0" ;
  }
  return($totalInclude) ;
}
#|#######################################################
sub Build_Index_Chapter {    
  local($source,$index,$Type,$lang,@liste) = @_ ;
  local($latexligne) = "" ;
  (%affiche)=(&main::TalkInLaTeXOrHtml($lang,%main::delegue));
  $latexligne .= &{$affiche{"chapter"}}($Type)."\n" ;
  $latexligne .= &{$affiche{"sepline"}}.&{$affiche{"sepline"}}."\n" ;
  $latexligne .=  "The line number of definition or call is between parenthesis.\n" ;
  $latexligne .=  &{$affiche{"bol"}}."\n" ;
  foreach $totalRoutine (@liste) {
    $latexligne .= &{$affiche{"scomment"}}($totalRoutine) ;
    $latexligne .= &{$affiche{"li"}} ;
    if ("$Type" =~ /Files/) {
      ($localRoutine,$localFile,$numdef) = &main::GetInfoRoutine ($totalRoutine) ;
      if ("$Type" =~ /Source/) {
	$latexligne .= &{$affiche{"DeclareLabel"}}($source,$index,$localRoutine,$totalRoutine,$localRoutine) ;
      } else {
	$latexligne .= &{$affiche{"IncludeLabel"}}($source,$index,$localRoutine,$totalRoutine,$localRoutine) ;
      }
      if (exists $lfichiers{$localFile}) {
	$latexligne .= " declares" ;
	$latexligne .= &{$affiche{"bul"}}."\n" ;
	foreach $Reference (@{$lfichiers{$localFile}}) {
	  local($localReference,$b,$numReference) = &main::GetInfoRoutine($Reference) ;
	  $latexligne .= &{$affiche{"li"}} ;
	  $latexligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$localReference,$Reference,$localReference) ;
	  $latexligne .= " ($numReference)\n" ;
	  $latexligne .= "\n" ;
	}
	$latexligne .= &{$affiche{"eul"}}."\n" ;
      } else {
	$latexligne .= "\n" ;
      }
      $latexligne .= &{$affiche{"ecomment"}}($totalRoutine) ;
      next ;
    }
    if ("$Type" eq "Includes") {
      ($RoutineCasei,$file,$numdef) = &main::GetInfoRoutineCasei ($totalRoutine) ;
      $latexligne .= &{$affiche{"IncludeLabel"}}($source,$index,$RoutineCasei,$totalRoutine,$RoutineCasei) ;
    } elsif ("$Type" eq "Inputs") {
      ($RoutineCasei,$file,$numdef) = &main::GetInfoRoutineCasei ($totalRoutine) ;
      $latexligne .= &{$affiche{"InputLabel"}}($source,$index,$RoutineCasei,$totalRoutine,$RoutineCasei) ;
    } else {
      ($Routine,$file,$href) = &main::GetInfoRoutineCasei($totalRoutine) ;
      $RoutineCasei = &main::GetLowerCase($Routine) ;
      #	    local($totalRoutine)=GetFullDeclare($RoutineCasei) ; is labelled in
      if ($main::L_Declar{$RoutineCasei}) {
	$totalRoutine = "$RoutineCasei:$file:$main::L_Declar{$RoutineCasei}";
      } else {
	$totalRoutine = "$Routine:$file:$href" ;
	($RoutineCasei,$file,$numdef) = &main::GetInfoRoutine ($totalRoutine) ;
      }
      $latexligne .= &{$affiche{"DeclareLabel"}}($source,$index,$RoutineCasei,$totalRoutine,$RoutineCasei) ;
    }
    $latexligne .= "\n";
    $latexligne .= &{$affiche{"bul"}}."\n" ;
    if ("$Type" eq "Includes") {
      $latexligne .= &{$affiche{"li"}} ;
      $latexligne .= &{$affiche{"Private_Included"}}($totalRoutine,"$source","$index") ;
      $latexligne .= &{$affiche{"li"}} ;
      $latexligne .= &{$affiche{"Private_Includes"}}($totalRoutine,"$source","$index") ;
      $latexligne .= &{$affiche{"eul"}}."\n" ;
      $latexligne .= &{$affiche{"ecomment"}}($totalRoutine) ;
      next ;
    }
    if ("$Type" eq "Inputs") {
      $latexligne .= &{$affiche{"li"}} ;
      $latexligne .= &{$affiche{"Private_Inputed"}}($totalRoutine,"$source","$index") ;
      $latexligne .= &{$affiche{"li"}} ;
      $latexligne .= &{$affiche{"Private_Inputs"}}($totalRoutine,"$source","$index") ;
      $latexligne .= &{$affiche{"eul"}}."\n" ;
      $latexligne .= &{$affiche{"ecomment"}}($totalRoutine) ;
      next ;
    }
    if ("$Type" eq "Modules") {
      $latexligne .= &{$affiche{"li"}} ;
      $latexligne .= &{$affiche{"Private_Used"}}($totalRoutine,"$source","$index") ;
    } else {
      if ("$Type" ne "Programmes") {
	$latexligne .= &{$affiche{"li"}} ;
	$latexligne .= &{$affiche{"Private_Called"}}($totalRoutine,"$source","$index") ;
      }
      $latexligne .= &{$affiche{"li"}} ;
      $latexligne .= &{$affiche{"Private_Calls"}}($totalRoutine,"$source","$index") ;
      $latexligne .= &{$affiche{"li"}} ;
      $latexligne .= &{$affiche{"Private_Uses"}}($totalRoutine,"$source","$index") ;
    }
    $latexligne .= &{$affiche{"li"}} ;
    $latexligne .= &{$affiche{"Private_Includes"}}($totalRoutine,"$source","$index") ;
    if ((exists $main::sons{"$totalRoutine"}) && (defined(%{$main::sons{$totalRoutine}}))) {
      local(@sons) = (keys %{$main::sons{$totalRoutine}}) ;
      if (@sons) {
	$latexligne .= &{$affiche{"li"}} ;
	$latexligne .= &{$affiche{"DeclareNolabel"}}($source,$index,$RoutineCasei,$totalRoutine,$RoutineCasei) ;
	$latexligne .= " defines private routines\n" ;
	$latexligne .= &{$affiche{"sepline"}}."\n" ;
	$latexligne .= &{$affiche{"bol"}}."\n" ;
	foreach $son (keys %{$main::sons{$totalRoutine}}) {
	  local($privateRoutine) = ${$main::sons{$totalRoutine}}{$son} ;
	  local($localPrivate,$a,$b) = &main::GetInfoRoutine($privateRoutine) ;
	  $latexligne .= &{$affiche{"li"}} ;
	  $latexligne .= &{$affiche{"DeclareLabel"}}($source,$index,$localPrivate,$privateRoutine,$localPrivate) ;
	  $latexligne .= "\n";
	  $latexligne .= &{$affiche{"bul"}}."\n" ;
	  $latexligne .= &{$affiche{"li"}} ;
	  $latexligne .= &{$affiche{"Private_Called"}}($privateRoutine,"$source","$index") ;
	  $latexligne .= &{$affiche{"li"}} ;
	  $latexligne .= &{$affiche{"Private_Calls"}}($privateRoutine,"$source","$index") ;
	  # Il faut inclure les includes
	  $latexligne .= &{$affiche{"li"}} ;
		
	  $latexligne .= &{$affiche{"Private_Includes"}}($privateRoutine,"$source","$index") ;
	  unless ("$Type" eq "Modules") {
	    $latexligne .= &{$affiche{"li"}} ;
	    $latexligne .= &{$affiche{"Private_Uses"}}($privateRoutine,"$source","$index") ;
	  }
	  $latexligne .= &{$affiche{"eul"}}."\n" ;
	}
	$latexligne .= &{$affiche{"eol"}}."\n" ;
	$latexligne .= &{$affiche{"sepline"}}."\n" ;
      }
    }
    $latexligne .= &{$affiche{"eul"}}."\n" ;
    $latexligne .= &{$affiche{"ecomment"}}($totalRoutine) ;
  }
  $latexligne .= &{$affiche{"eol"}}."\n" ;
  $latexligne .= &{$affiche{"sepline"}}.&{$affiche{"sepline"}}."\n" ;
  return($latexligne) ;
}
#%###################################################
sub Include_F90_Html {
  local($include,$ligne,$source,$Routine)=@_;
  local($localRoutine,$localFile,$localNum) = &GetInfoRoutine($Routine) ;
  if ($include_source=$Include_Alias{$include}) {
    # On obtient le nom du fichier include  crire.
    $include_source = &fichiers::IncludeFileOfWrite($include_source) ;
    &fichiers::GetIncludeCibleOfWrite($include_source) ;
    $subs = "<A HREF=\"${include_source}_c.html\" ".Target("source").">$include<\/A>" ;
    $ligne =~ s/$include/$subs/;
  } else {
    $include_source=$include;
    $ligne =~ s/$include/<I><FONT COLOR=RED>$include<\/FONT><\/I>/ ;
  }
  # Ne pas supprimer ce commentaire, il indique l'ancienne stratgie
  # du programme qui consistait  marquer l'appel du nom de l'appel.
  #    $ligne = "<A NAME=I_${include_source}$.></A>".$ligne ;
  $ligne = "<A NAME=C_$localRoutine$.></A>".$ligne ;
  return($ligne) ;
}
#%###################################################
sub Input_Html {
  local($input,$ligne,$source,$Routine)=@_;
  local($localRoutine,$localFile,$localNum) = &GetInfoRoutine($Routine) ;
  if ($input_source=&fichiers::find_input($input)) {
    # On obtient le nom du fichier input  crire.
    if ($Input_Alias{$input}) {
      $input_source = &fichiers::InputFileOfWrite($Input_Alias{$input}) ;
      &fichiers::GetInputCibleOfWrite($input_source) ;
    } else {
      warn "WARNING: error on input analysis for writing $input from $localFile($localNum)\n";
      &fichiers::GetInputCibleOfWrite($input_source) ;
    }
    $subs = "<A HREF=\"".&CodeName($input_source,"source").".html\" ".&Target("source").">$input<\/A>" ;
    $ligne =~ s/$input/$subs/;
  } else {
    $input_source=$input;
    $ligne =~ s/$input/<I><FONT COLOR=RED>$input<\/FONT><\/I>/ ;
  }
  # Ne pas supprimer ce commentaire, il indique l'ancienne stratgie
  # du programme qui consistait  marquer l'appel du nom de l'appel.
  #    $ligne = "<A NAME=I_${input_source}$.></A>".$ligne ;
  $ligne = "<A NAME=C_$localRoutine$.></A>".$ligne ;
  return($ligne) ;
}
#%###################################################
