#!/bin/ksh
eval 'exec perl -x -S $0 ${1+"$@"}'
              if $running_under_some_shell;
#!/usr/bin/perl -w
# -*- Mode: cperl -*-
#|########################################################################
# To build the rpm:
#   rpm -ba fth.spec
#|########################################################################
# RUN:
#       perl ~/ftagshtml/bin/toto.pl typWriter.f90 tra2tml.f90
# sophie: perl ~/ftagshtml/bin/fth.pl -code=sophie -cvsweb='http://localhost/cgi-bin/cvsweb.cgi/sophie_old/src' -v 1 -show *.f90 *.F90 *.f
# emma:   perl ~/ftagshtml/bin/fth.pl -code=emma -R -show -v 1
# lior:   perl ~/ftagshtml/bin/fth.pl -code=lior -latexindex *.f *.c
# BUGS:
#       * OK: internal call to handle = getHandle(this) from typWriter not understood: make a test with debug.
#       * OK: type(stuff) does not respect alignment
#       * OK: routines definitions with '& ('
#       * OK: comments removed in procedure setWriterFileMesh
#       * OK: in chtml files, definitions ought to bring a link to ihtml files.
#       * OK: fontifying policy not clear.
#       * OK: interface definitions not in blue : add an interface index ?
#       * OK: mere fortran 77 files output is nearly empty, perform basic debugging...
#       * OK: Interface .h file list separated by too many blanks.
#       * OK: dElement line 178 bad call recognized to curdFace and so on:
#            perl ~/ftagshtml/bin/toto.pl -debug Element.f90 dFace.f90 dElement.f90
#            corrected with /^(.*?\W+)(get\w+)\s*\((.*?)([\(\)])(.*)/ in frout
#            but potential error remains...
#       * OK: this%debug = getDebug(stuff): wrong analysis since return type is not known.
#          in vMpi->createfvMpi
#       * OK: if (getDebug(stuff)... : not recognized despite function default return type is unique.
#       * OK: Add a precise list of called by with exact line numbers
#       * OK: mLogic->addmLogicObsc: strange behaviour !!! due to (not reproduced):
#         fmod::setDepends: No implementation for interface getnumber to procedure getnodenumber in module Node
#       * OK: voir TODO:
#       * OK: dans mGeom line 55 call reset failed...
#       * OK, bad sophie programming, NAJ922: In Element.f90 line 922, unable to detect call to getNumber, despite getNode provides a node only:
#         due to not unique interface for getNode.
#       * OK: brackets are wrong in Elemen.f90->call alpnum at line 915 and so forth: this is a rather difficult bug...
#         also met with the function call.
#       * OK: failed to set the correct link for, for instance, in vMpi.F90:
#         curbProc => getbProc(this%surfbProc, pf2e(lpos)-1) as well as [OK?] getDomain when called on two lines.
#       * OK: perl ~/ftagshtml/bin/toto.pl -L ../lior/VARIABLES -latex *.f *.c => muwNod references a tex file that is not met
#       * OK: check the vMpi calls to the cFDTD functions.
#       * OK:  label = getLabel(this%thesDomain, ifdtd)
#       * OK: perl ~/ftagshtml/bin/toto.pl Material.f90 Element.f90
#       * OK: Many bad routines connections remain, see TODO.
#       * OK: On liorhome/prelior: frout::readf77subr: error2 line=16 rout='fsetString' file='affiche.f'
#       * OK :GLOB write at "Writing program files": alpnum.f, defvol.f, invmat.f, prodmat.f, sgemp1d.f90
#       * OK: bad call setName from hex2pyr(number = 57)
#       * OK: vMpi list of "is called by" does not seem to include the main programs !
#         Correction: routines that are not inside modules may refer...
#         the called index is rather chaotic...
#       * OK: modules is called by is fully wrong...
#       * OK: chtml::$value =~ /[\<\>]/ remains to be done line 250
#       * OK: prelior big problems encountered into the main file...
#       * OK: Mulitiple definitions uncorrectly handled for emma, refer to bad call...
#       * OK: SizeOfInteger in common/precision.f90 of unknwon type => GENERALIZE fthmod::1070
#       * KO: Restart policy cannot be achieved !
#       * In tptp: summary of the remaining 212 bad calls...
#       * In tptp2: #5928, #1244(1320s), #513(1135), #442(778), #437(808), #413, #154(976), #156(88), #150(905), #154(1388)
#       * TODO: OK: bad calls index and red fcall links to the bad calls index with proto.
#               Mark with power of 2 for routine quality (as a number of the caller, limited to 20 arguments).
#               OK: In calls, build a real arg list to further internal analyze stuff
#               In restart mode, process all the calls...
#       * call in fortran after if process...
#       * KO: f77 dimension is NOT real, refer to the implicit directive if not folowed by type.
#       * KO: f77 implicit override: build a hash by letter not as a regexp
#       * KO: f77 call toto looks for () on next line, inform the fthrout::readf77subr it must parse $_, not read it:
#             thus define a return status. Must set up a test call toto ; call tata: both must be seen.
#       * KO: bug above Element.f90->880: bad return type analysis if any
#             write(handle,2121) this%label,1,getLabel?geteTypeLabel[this%theetype=type(anetype),pointer  this%label,1,=void]Cause:(fthmod::isSpecific:1072) Tested.(this%theeType),getLabel[this%theproperty=type(aproperty),pointer getlabel=integer]Cause:(fthmod::setCallers:902) Direct.(this%theProperty), &
#|########################################################################
# ftagshtml: transforms fortran 90 or below and C source code
#            into HTML or PostScript or PDF building calls indexes.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
BEGIN {
  unless (exists $ENV{'FTAGSHTML_DIR'} && -d "$ENV{FTAGSHTML_DIR}") {
    # Sets the default shared location for ftagshtml:
    $ENV{'FTAGSHTML_DIR'} = '/usr/share/ftagshtml' ;
    unless (-d "$ENV{FTAGSHTML_DIR}") {
      die "Environment variable FTAGSHTML_DIR unknown or $ENV{FTAGSHTML_DIR} not a directory" ;
    }
  }
  (@INC)=("$ENV{FTAGSHTML_DIR}/lib/perl","$ENV{FTAGSHTML_DIR}/lib/perl/ftagshtml", @INC) ;
}
#use lib "$ENV{FTAGSHTML_DIR}/lib/perl/ftagshtml";
require 5.003;
use Getopt::Long;
use File::Copy ;
use File::Basename ;
use File::Path ;
use Cwd ;
use CGI ;
#use XML::Dumper;
use fthfortran ;
use fthc ;
use fthbc;
use fthext;
use fthlabel ;
#|########################################################################
#use ftagshtml::searchfc ;
#use ftagshtml::fichiers ;
#use ftagshtml::index ;
#use ftagshtml::javanavig ;
#use ftagshtml::restart ;
#use ftagshtml::html;
#use ftagshtml::LaTeX;
use ftagshtml::fthmisc ;
#|########################################################################
# -show is for debugging arguments passing analysis made by this program:
#my $opt_f90 = 0; 
#my $opt_l2h = 0; 
#my $opt_nostyle = 0; 
#my $opt_R = 0; 
#my $opt_oldmm = 0 ;
&GetOptions("cgi=s", "cvsweb=s", "code=s", "conf=s", "debug", "f90", "getin_format=s",
	    "help","hevea", "I:s", "L:s", "labels:s", "l2h", "latex", "latexindex",
	    "nocolor", "nofile", "nojava", "nolinenum", "nostyle", "numperindex=i",
	    "oldmm", "R", "show", "php", "t=s", "u", "v=i", "version", "w=s", "www=s",
	    );
###########################################################################
sub alphabetic {
  lc($a) cmp lc($b) ||  $a cmp $b ;
}
#|########################################################################
sub duree {
  $tp=$tn ;
  $tn=time;
  return($tn-$tp) ;
}
#|########################################################################
# Recursive add files:
sub pushFiles {
  my $dir = shift ;
  my $target = $dir ;
  $target =~ s/^\.\/*// ;
  $target .= '/' if $target ;
  if (opendir(MONDIRECTOIRE,"$dir")) {
    my (@dirs) = grep { $_ if (-d "$dir/$_" && $_ ne '.' && $_ ne '..') } readdir(MONDIRECTOIRE);
    # Open/Close required:
    closedir MONDIRECTOIRE;
    opendir(MONDIRECTOIRE,"$dir") ;
    my (@files) = map { "$target$_" } grep { $_ if (-e "$dir/$_") } grep /\.(f90|f|c|cc|cpp|c\+\+)$/i, readdir(MONDIRECTOIRE);
    print STDOUT "List($dir [@dirs]) is: @files\n" if (@files && $opt_v) ;
    closedir MONDIRECTOIRE;
    push(@ARGV, @files) ;
    foreach my $d (@dirs) {
      #print STDOUT "Adding $dir/$d\n" ;
      &pushFiles("$dir/$d") ;
    }
  }
}
#|#######################################################
sub CGI_conf {
  if (open(CONF,">$DIRE/$opt_conf.pm")) {
    print CONF "# Generated by $0\n";
    print CONF "\$opt_dir = \"$DIRW\" \;\n";
    print CONF "\$opt_html = \"$DIRE\" \;\n";
    print CONF "\$opt_www = \"$opt_www\" \;\n" if $opt_www;
    print CONF "\(\@INCLUDES_PATH\) = \(";
    my @TAGSHTML_PATH = (split ( /:/, $main::opt_I)) ;
    foreach $a (@TAGSHTML_PATH) {
      print CONF "'$a', ";
    }
    print CONF "\)\;\n";
    print CONF "\$opt_getin_format = \"$getin_format\" \;\n" if $opt_getin_format ;
    print CONF "1 \;\n";
    print STDOUT "\tManually copy\n\t'$DIRE/$opt_conf.pm'\n\t to \n\t'$opt_cgi/../lib/perl/getin/conf/$opt_conf.pm'\n\tprobably $ENV{FTAGSHTML_DIR}/lib/perl/getin/conf/$opt_conf.pm\n";
    close(CONF) ;
  }
}
#|########################################################################
$version = 0.520 ;
$requireversion = 0.514;
if ($opt_version) {
  if ($version > 1) {
    print STDOUT sprintf "%6.3f\n", $version;
  } else {
    print STDOUT sprintf "%5.3f\n", $version;
  }
  exit(0);
}
if ($opt_nostyle) {
  print STDOUT "No style is deprecated. Update your browser.\n" ;
}
if ($opt_nostyle || $opt_oldmm || $opt_l2h || $getin_format) {
  $| = 1;
}
#|########################################################################
my $level = 0 ;
# new lines: 
# TB: eliminate Perl warnings 
my $php = 0; 
my $cgi = 0; 
my $getin_format = 0; 
# end of new lines 
$USER = (getpwuid ($<))[0] ;
$t0=time;
$tn=$t0 ;
$| = 1;
#|########################################################################
print STDOUT $level++ . ") Initializing:\n";
$debug = 0;
$debug = $opt_debug if $opt_debug ;
$cgi = $opt_cgi if $opt_cgi ;
$php = $opt_php if $opt_php ;
if ($opt_nojava) {
  $java = 0 ;
}
unless ($opt_nojava) {
  $java = 1 ;
}
if ($opt_debug) {
  &fthfortran::setDebug($opt_debug) ;
  &fthc::setDebug($opt_debug) ;
  &fthmod::setDebug($opt_debug) ;
  &fthtype::setDebug($opt_debug) ;
  &fthrout::setDebug($opt_debug) ;
  &fthcall::setDebug($opt_debug) ;
  &fthinter::setDebug($opt_debug) ;
  &fthobj::setDebug($opt_debug) ;
  &fthbc::setDebug($opt_debug) ;
  &fthext::setDebug($opt_debug) ;
}
$currentversion = $version ;
unless ($opt_version) {
  print STDOUT "\tVersion $version, required version is $requireversion\n";
}
$opt_v = 0 unless $opt_v ;
if ($opt_help) {
  use ftagshtml::defaults ;
  &defaults::ftagshtml_help ;
}
if ($debug) {
  $opt_v = 5 ;
}
unless ($opt_help) {
  print STDOUT "\tHelp available using -help command line option\n";
}
if ($opt_nolinenum) {
  $num_affiche=-1;
} else {
  $num_affiche=10;
}
#|########################################################################
$Myname = basename($0) ;
if ($Myname =~ /(.*)\./) {
  $Myname = $1 ;
}
$DIRW = cwd ;
$DIRE="$DIRW/HTML/$Myname" ;
$DIRC="$DIRW" ;
if ($opt_t) {
  $DIRC=$opt_t ;
}
if ($opt_w) {
  $DIRE=$opt_w ;
}
$RepCodeSource = basename($DIRW) ;
$RepCodeSource = $opt_code if $opt_code ;
#|########################################################################
$DIRE = &fthmisc::CheminAbsoluDeAaB($DIRC,$DIRE);
$DIRSR = &fthmisc::CheminRelatifDeAaB("$DIRE","$DIRW") . '/' ;
#|########################################################################
print STDOUT "\tReading restart on $DIRE\n" ;
$reuse = 0 ;
(%ofiles) = () ;
(%rfiles) = () ;
(@listec) = () ;
# if (0 && -f "$DIRE/ftagshtml.xml.gz") {
#   $reuse = 1 ;
#   $reuse = 0 ;
# }
# if ($reuse) {
#   # Reading data:
#   my $dump = new XML::Dumper;
#   my $perl ;
#   $perl = $dump->xml2pl("$DIRE/ftagshtml.xml.gz");
#   my ($oos, $otypes, $omods, $ointers, $orouts, $ocalls, $oobjs) =  @{$perl} ;
#   (%ofiles) = (%{$oos}) ;
#   &fthtype::shashlist(%{$otypes}) ;
#   &fthmod::shashlist(%{$omods}) ;
#   &fthinter::shashlist(%{$ointers}) ;
#   &fthrout::shashlist(%{$orouts}) ;
#   &fthcall::shashlist(%{$ocalls}) ;
#   &fthobj::shashlist(%{$oobjs}) ;
# }
if (-f "$DIRE/ftagshtml.pm") {
  $reuse = 1 ;
  require("$DIRE/ftagshtml.pm");
} else {
  # Building path:
  mkpath(["$DIRE/inter"],1,0750) ;
}
#|########################################################################
if ($opt_I) {
  @TAGSHTML_PATH = (split ( /:/, $opt_I)) ;
  print "\tInclude PATH is @TAGSHTML_PATH.\n";
} else {
  @TAGSHTML_PATH = () ;
}
$nosave = 0; 
if ($opt_labels) {
  (@LABELS) = (split ( /:/, $opt_labels)) ;
  $nosave = 1 ;
  foreach $label (@LABELS) {
    if ($label =~ /(.*)\//) {
      if ($opt_www) {
	$URL = $opt_www . '/' . $1 ;
      } else {
	$URL = "$DIRSR$1" ;
	#die "DIRSR='$DIRSR', 1='$1'\n" ;
      }
    } else {
      if ($opt_www) {
	$URL = $opt_www ;
      } else {
	$URL = "$DIRSR" ;
      }
    }
    require("$label") if (-e "$label") ;
  }
}
#|########################################################################
if ($opt_R) {
  print STDOUT "\t Recursive directory file lookup.\n";
}
if ($opt_R) {
  # Recursively find the fortran files:
  if (@ARGV) {
    if (opendir(MONDIRECTOIRE,".")) {
      my (@dirs) = grep { $_ if (-d $_ && $_ ne '.' && $_ ne '..') } readdir(MONDIRECTOIRE);
      closedir MONDIRECTOIRE;
      foreach my $d (@dirs) {
	&pushFiles("./$d") ;
      }
    }
  } else {
    &pushFiles(".") ;
  }
}
unless (@ARGV) {
  use ftagshtml::defaults ;
  &defaults::ftagshtml_help ;
}
#|########################################################################
# Read all the files:
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT $level++ . ") Reading declarations for " . ( $#ARGV + 1 ) . " files.\n";
if ($opt_f90) {
  print STDOUT "\t Fortran files are assumed to be f90 style ones.\n";
}
# Loops on the input files respects the user's specified order:
if ($reuse) {
  # Sort list of files as provided by @arglist:
  my(%nhash) = () ;
  my(%ohash) = () ;
  my(@newlist) = () ;
  foreach $file (@ARGV) {
    $nhash{$file} = 1 ;
  }
  foreach $file (@arglist) {
    $ohash{$file} = 1 ;
  }
  foreach $file (@arglist) {
    # Add the previous files if contained in current list:
    if (exists $nhash{$file}) {
      push(@newlist, $file) ;
      # Avoid multiples:
      delete $nhash{$file} ;
    }
  }
  foreach $file (@ARGV) {
    # Add the current files if not in the previous list:
    unless (exists $ohash{$file}) {
      push(@newlist, $file) ;
      # Avoid multiples:
      $ohash{$file} = 1 ;
    }
  }
  # Resetting the list:
  (@ARGV) = (@newlist) ;
}
foreach $file (@ARGV) {
  print STDOUT "." unless $opt_v ;
  print "Read $file\n" if $opt_v;
  $rfile = basename($file) ; 
  next if (exists $rfiles{$file}) ;
  $rfiles{$rfile} = $file ;
  if ($file =~ /\.(f|f77|f90)$/i) {
    $f = new fthfortran(-file => $file, -masfic => $file, -name => $file) ;
    if ($file =~ /\.f90$/i || $opt_f90 && $file =~ /\.f$/i) {
      $f->readf90() ;
    } elsif ($file =~ /\.(f|f77)$/i) {
      $f->readf77() ;
    }
  } elsif ($file =~ /\.(c|cc|cpp|C|CC|ch|h)$/) {
    # files of type h are normally C files only... do not put them
    # on the command line argument for fortran procesing.
    $f = new fthc(-file => $file, -masfic => $file, -name => $file) ;
    if (1 == 0) {
      $f->readc() ;
    }
    push(@listec, "$file") ;
  } else {
    die "KO, file has no known extension" ;
  }
  $ofiles{$file} = $f ;
}
print STDOUT "\n" unless $opt_v ;
#|########################################################################
# Tags reading in bugguy
if (@listec) {
  if (1 == 1) {
    print"\t\t[OK] in ".&duree." seconds.\n";
    print"\t Reading declarations for C on $DIRE, DIRSR=$DIRSR.\n";
    # This calls the readc stuff:
    &fthc::Lecture_Tags("$DIRE", "$DIRSR", @listec) ;
  } else {
  }
}
# print"\t\t[OK] in ".&duree." seconds.\n";
#|########################################################################
# Sets the recursive dependencies:
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT $level++ . ") Building dependencies:\n" ;
print STDOUT "\tSetting the modules recursive dependencies.\n" ;
foreach $f (&fthmod::objectlist()) {
  $f->setDepends() ;
}
#foreach $file (sort alphabetic keys %ofiles) {
foreach $file (@ARGV) {
  $f = $ofiles{$file} ;
  $f->setDepends() ;
}
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT "\tAnalyze interfaces and routines unique return type if any\n" ;
&fthobj::setTypes() ;
# Sets the calling tree:
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT "\tLooking for call dependencies starts\n" ;
# Building a fake chtml for recursive internals
new chtml() ;
#foreach $file (sort alphabetic keys %ofiles) {
foreach $file (@ARGV) {
  # next unless ($file eq 'theTest.f90') ;
  $f = $ofiles{$file} ;
  print STDOUT "." unless $opt_v ;
  print STDOUT "Parsing setcalls for $file:" if $opt_v ;
  $f->setCalls() ;
  print STDOUT "\n" if $opt_v ;
}
print STDOUT "\n" unless $opt_v ;
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT "\tBuilding reverse call tree\n" ;
#foreach $file (sort alphabetic keys %ofiles) {
foreach $file (@ARGV) {
  $f = $ofiles{$file} ;
  print STDOUT "." unless $debug ;
  # Sets the direct compile order list
  $f->setCompiles() ;
  # Inverts the calls:
  print STDOUT "Reversing the calls for file $file in $f\n" if $debug ;
  $f->revCalls() ;
}
print STDOUT "\n" unless $debug ;
#|########################################################################
print"\t\t[OK] in ".&duree." seconds.\n";
if (&fthinp::any()) {
  print STDOUT $level++ . ") Reading the inputs:\n" ;
  foreach $f (&fthinp::objectlist()) {
    print STDOUT "." unless $debug ;
    $f->read() ;
  }
}
print STDOUT "\n" unless $debug ;
#|########################################################################
# Data serializing: printing all objects in a separate routine name for 
# managing data retrieve.
# sub flushdata {
#   my $dump = new XML::Dumper;
#   my(%ftypes) = &fthtype::ghashlist() ;
#   my(%fmods) = &fthmod::ghashlist() ;
#   my(%finters) = &fthinter::ghashlist() ;
#   my(%frouts) = &fthrout::ghashlist() ;
#   my(%fcalls) = &fthcall::ghashlist() ;
#   my(%fobjs) = &fthobj::ghashlist() ;
#   my $perl = [ \%ofiles, \%ftypes, \%fmods, \%finters, \%frouts, \%fcalls, \%fobjs ];
#   $dump->pl2xml( $perl, "$DIRE/ftagshtml.xml.gz" );
# }
#|########################################################################
sub save_hash_in_file {
  my(%fthhash) = (@_) ;
  foreach my $cle (keys %fthhash) {
    my $object = $fthhash{$cle} ;
    $object->save_hash($handle) ;
  }
}
#|########################################################################
sub printdata {
  if (open(INFO,">$DIRE/ftagshtml.pm")) {
    local $handle = \*INFO ;
    $reuse++ ;
    print $handle "# Generated by $0\n";
    print $handle "\$reuse = $reuse ;\n";
    print INFO "\$currentversion = $main::currentversion ;\n" ;
    print INFO "\$currenttime = ". time . ";\n" ;
    print INFO "\# Writing fthtypes\n" ;
    &save_hash_in_file(&fthtype::ghashlist()) ;
    print INFO "\# Writing fthmods\n" ;
    &save_hash_in_file(&fthmod::ghashlist()) ;
    print INFO "\# Writing fthrouts\n" ;
    &save_hash_in_file(&fthrout::ghashlist()) ;
    print INFO "\# Writing fthinters\n" ;
    &save_hash_in_file(&fthinter::ghashlist()) ;
    print INFO "\# Writing fthobjs\n" ;
    &save_hash_in_file(&fthobj::ghashlist()) ;
    if (@adeps) {
      print INFO "\# Writing dependencies:\n" ;
      print INFO '(@arglist) = ();'."\n" ;
      foreach my $file (@adeps) {
	print INFO 'push(@arglist, "'.$file.'");'."\n" ;
      }
    }
    print $handle "1;\n" ;
    close($handle) ;
  }
}
#|########################################################################
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT $level++ . ") Building outputs:\n" ;
print STDOUT "\tWriting common files\n" ;
# Printing the CSS:
&ihtml::print_css("$DIRE") ;
# Copying stuffs:
copy("$ENV{'FTAGSHTML_DIR'}/doc/img/color.gif","$DIRE/color.gif") ;
copy("$ENV{'FTAGSHTML_DIR'}/doc/img/color.gif","$DIRE/inter/color.gif") ;
copy("$ENV{'FTAGSHTML_DIR'}/doc/img/ftagshtml.jpg","$DIRE/ftagshtml.jpg") ;
my(@liste) ;
if ($opt_oldmm) {
  (@liste) = ("ftiens4.js" ,"ftv2lastnode.gif", "ftv2plastnode.gif", "ftv2blank.gif", "ftv2link.gif", "ftv2pnode.gif", "ftv2doc.gif", "ftv2mlastnode.gif", "ftv2vertline.gif", "ftv2folderclosed.gif", "ftv2mnode.gif", "ftv2folderopen.gif", "ftv2node.gif");
} else {
  (@liste) = ("tree_tpl.js" ,"tree.js", "empty.gif", "line.gif", "base.gif", "folder.gif", "folderopen.gif", "page.gif", "joinbottom.gif", "join.gif", "plusbottom.gif", "plus.gif", "minusbottom.gif", "minusbottom.gif");
}
foreach $a (@liste) {
  copy("$ENV{FTAGSHTML_DIR}/lib/perl/javatex/$a","$DIRE/$a") ;
}
&CGI_conf if $opt_conf ;
$listpro = 0 ;
$listsub = 0 ;
$listfun = 0 ;
if (&fthrout::any()) {
  print STDOUT "\tWriting (program,sub,func) indexes\n" ;
  (@pros) = &fthrout::getPros() ;
  if (@pros) {
    $listpro = 1 ;
  }
  (@rous) = &fthrout::getRouts() ;
  if (@rous) {
    $listsub = 1 ;
  }
  (@funs) = &fthrout::getFuncs() ;
  if (@funs) {
    $listfun = 1 ;
  }
}
my $js = &ihtml::open_java("$DIRE","$DIRSR");
my $lat = undef ;
if ($opt_latexindex) {
  $lat = &fthinp::open_latex("$DIRE","$DIRSR");
}
$mainstuff = undef ;
$mainval = 0 ;
print STDOUT "\tAnalyzing top dependencies:\n" ;
$top = new fthfortran() ;
#$top->setCompOrder(sort alphabetic keys %ofiles) ;
$top->setCompOrder(@ARGV) ;
(@adeps) = $top->getCompiles(%ofiles) ;
if (@adeps) {
  print STDOUT "\tAll levels compilation dependencies is @adeps\n" if $main::opt_v ;
}
if ($listpro || $listsub || $listfun) {
  if (@pros) {
    # Converts a list of object into a list by name:
    my(@names) = map { $_->get(-name) } @pros ;
    if ($opt_code && @names) {
      foreach my $name (@names) {
	if (lc($name) eq lc($opt_code)) {
	  $mainstuff = &fthrout::getObject($name) ;
	  $mainval = 3 ;
	  last ;
	} elsif ($name =~ /$opt_code/i) {
	  $mainstuff = &fthrout::getObject($name) ;
	  $mainval = 2 ;
	} elsif ($opt_code =~ /$name/i) {
	  $mainstuff = &fthrout::getObject($name) ;
	  $mainval = 2 ;
	}
      }
    }
    unless ($mainstuff) {
      foreach my $name (@names) {
	if (lc($name) eq 'main') {
	  $mainstuff = &fthrout::getObject($name) ;
	  $mainval = 1 ;
	  last ;
	}
      }
    }
    if (!$mainstuff && @names) {
      $mainstuff = &fthrout::getObject($names[0]) ;
    }
    print STDOUT "\t\tWriting programs=" . ( $#pros + 1 ) ." : @names\n" ;
    # Gets the dependency list fo programs:
    foreach my $pro (@pros) {
      my $file = $pro->get(-file) ;
      my $f = $ofiles{$file} ;
      my (@deps) = $f->getCompiles(%ofiles) ;
      if ($opt_v) {
	print STDOUT "\t\tDependencies for programme ".$pro->get(-name) . " file " . $pro->get(-file) . " is @deps\n" ;
      }
    }
    &ihtml::print_index("$DIRE","$DIRSR","program",@pros) ;
    $js->print_java("$DIRE","$DIRSR","program",@pros) if $js ;
    &ihtml::print_latex($lat,"program",@pros) if $lat;
  }
  if (@rous) {
    print STDOUT "\t\tWriting routines=" . ( $#rous + 1 ) ."\n" ;
    unless ($mainstuff) {
      $mainstuff = $rous[0] ;
    }
    if ($opt_code && $mainval < 2) {
      foreach my $orout (@rous) {
	$name = $orout->get(-name) ;
	if (lc($name) eq lc($opt_code)) {
	  $mainstuff = &fthrout::getObject($name) ;
	  last ;
	} elsif ($name =~ /$opt_code/i) {
	  $mainstuff = &fthrout::getObject($name) ;
	} elsif ($opt_code =~ /$name/i) {
	  $mainstuff = &fthrout::getObject($name) ;
	}
      }
    }
    &ihtml::printr_index("$DIRE","$DIRSR","routine",@rous) ;
    $js->print_java("$DIRE","$DIRSR","routine",@rous) if $js ;
    &ihtml::print_latex($lat,"routine",@rous) if $lat;
  }
  if (@funs) {
    unless ($mainstuff) {
      $mainstuff = $funs[0] ;
    }
    print STDOUT "\t\tWriting functions=" . ( $#funs + 1 ) ."\n" ;
    &ihtml::printr_index("$DIRE","$DIRSR","function",@funs) ;
    $js->print_java("$DIRE","$DIRSR","function",@funs) if $js ;
    &ihtml::print_latex($lat,"function",@funs) if $lat;
  }
}
print STDOUT "\tWriting " . ( $#ARGV + 1 ) . " program files implementations on $DIRE($DIRSR):\n" ;
#foreach $file (sort alphabetic keys %ofiles) {
foreach $file (@ARGV) {
  $f = $ofiles{$file} ;
  print STDOUT "Ready to print $file on $f\n" if $opt_v ;
  print STDOUT "." unless $opt_v ;
  # Make the dependency list:
  $f->getCompiles(%ofiles) ;
  # Prints the file into HTML:
  $f->htmlprint("$DIRE","$DIRSR", ) ;
}
print STDOUT "\n" unless $opt_v ;
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT "\tWriting files index: this is compulsary\n" ;
&ihtml::printf_index("$DIRE","$DIRSR","file", $top, %ofiles) ;
print"\t\t[OK] in ".&duree." seconds.\n";
# Javascript index:
if (&fthmod::any()) {
  # Manage modules:
  my (@mos) = &fthmod::objectlist() ;
  unless ($mainstuff) {
    $mainstuff = $mos[0] ;
  }
  print STDOUT "\tWriting modules index=" . ( $#mos + 1 ) ."\n" ;
  &ihtml::print_index("$DIRE","$DIRSR","module",@mos) ;
  $js->print_java("$DIRE","$DIRSR","module",@mos) if $js ;
  &ihtml::print_latex($lat,"module",@mos) if $lat;
}
if (&fthinc::any()) {
  # Manage includes:
  my(@incs) = &fthinc::objectlist() ;
  print STDOUT "\tWriting include files index and implementations:=" . ( $#incs + 1 ) ."\n" ;
  &ihtml::print_index("$DIRE","$DIRSR","include",@incs) ;
  &ihtml::print_latex($lat,"include",@incs) if $lat;
  foreach $f (@incs) {
    print STDOUT "." unless $debug ;
    # Prints the file into HTML:
    $f->htmlprint("$DIRE","$DIRSR") ;
  }
  print STDOUT "\n" unless $debug ;
}
if (&fthinp::any()) {
  # Manage LaTeX inputs:
  my(@inps) = &fthinp::objectlist() ;
  print STDOUT "\tWriting input files index=" . ( $#inps + 1 ) .":\n" ;
  &ihtml::print_index("$DIRE","$DIRSR","input",@inps) ;
  print STDOUT "\tWriting each input files=" . ( $#inps + 1 ) .":\n" ;
  foreach $f (@inps) {
    print STDOUT "." unless $opt_v ;
    $f->htmlprint("$DIRE","$DIRSR") ;
  }
  print STDOUT "\n" unless $opt_v ;
  print"\t\t[OK] in ".&duree." seconds.\n";
}
if (&fthtype::any()) {
  my(@typs) = &fthtype::objectlist() ;
  unless ($mainstuff) {
    $mainstuff = $typs[0] ;
  }
  print STDOUT "\tWriting ftype files=" . ( $#typs + 1 ) ."\n" ;
  &ihtml::print_index("$DIRE","$DIRSR","type",@typs) ;
  $js->print_java("$DIRE","$DIRSR","type",@typs) if $js ;
}
if (&fthobj::any()) {
  my(@objs) = &fthobj::objectlist() ;
  print STDOUT "\tWriting all objects index=" . ( $#objs + 1 ) ."\n" ;
  &ihtml::print_index("$DIRE","$DIRSR","object",@objs) ;
  # Always write the following
  print STDOUT "\tWriting all objects files=" . ( $#objs + 1 ) ."\n" ;
  &fthobj::htmlprint("$DIRE","$DIRSR") ;
}
$nbbcs = 0 ;
if (&fthbc::any()) {
  my(@bcs) = &fthbc::objectlist() ;
  print STDOUT "\tWriting all bad calls=" . ( $#bcs + 1 ) ."\n" ;
  $nbbcs = &ihtml::print_bcorext("$DIRE","$DIRSR","badcall",@bcs) ;
}
if (&fthext::any()) {
  my(@exts) = &fthext::objectlist() ;
  print STDOUT "\tWriting all external calls=" . ( $#exts + 1 ) ."\n" ;
  &ihtml::print_bcorext("$DIRE","$DIRSR","external",@exts) ;
}
if ($js) {
  $js->close_java("$DIRE","$DIRSR", values %ofiles) ;
}
&ihtml::print_top("$DIRE", $mainstuff) ;
if ($opt_l2h && &fthlabel::any()) {
  # Prints labels for all the stuffs for further LaTeX2HTML procesing if required:
  print STDOUT "\tWriting LaTeX2HTML labels file:\n" ;
  &fthlabel::latex2html() ;
}
if ($opt_latexindex) {
  # Time to close the file:
  close($lat) ;
  print STDOUT "\tOn $DIRE,\n\tTex index file index.tex created.\n";
  print STDOUT "\t\tMaster documents are Sindex and Lindex.\n";
  if ( $opt_v >= 1 ) {
    print STDOUT "\t\tLaTeX Compilation:\n" ;
    print STDOUT "cd $DIRE; latex Sindex; latex Sindex\n";
    print STDOUT "dvips -f Sindex.dvi>Sindex.ps\n" ;
    print STDOUT "\t\tor:\n" ;
    print STDOUT "cd $DIRE; latex Lindex; latex Lindex\n";
    print STDOUT "dvips -f Lindex.dvi>Lindex.ps\n" ;
    print STDOUT "\t\tPDF creation: (assumes you installed pdflatex)\n" ;
    print STDOUT "pdflatex Lindex\n" ;
  }
}
#|########################################################################
print"\t\t[OK] in ".&duree." seconds.\n";
print STDOUT $level++ . ") Program tree (error 0, success 1 in sayCalls API):\n" ;
if ($opt_v) {
  print STDOUT "\tPrinting call dependencies starts\n" ;
  #foreach $file (sort alphabetic keys %ofiles) {
  foreach $file (@ARGV) {
    $f = $ofiles{$file} ;
    $f->sayCalls(0) ;
  }
  print STDOUT "\tPrinting call dependencies ends\n" ;
}
#|########################################################################
# if (0) {
#   print STDOUT $level++ . ") Flushing serialized objects.\n" ;
#   &flushdata() ;
# }
#|########################################################################
$fulldebug = $opt_debug ;
#$fulldebug = 1 ;
if ($fulldebug || $opt_v) {
  print STDOUT $level++ . ") Manual prints:\n" ;
}
# Able to decide upon the callers...
if ($fulldebug) {
  print STDOUT "\tDumping objects start\n" ;
  #foreach $file (sort alphabetic keys %ofiles) {
  foreach $file (@ARGV) {
    $f = $ofiles{$file} ;
    $f->datadump("\t") ;
  }
  print STDOUT "\tDumping objects end\n" ;
}
# A sample for printing all the routines...
if ($fulldebug) {
  print STDOUT "\tDumping procedures start\n" ;
  foreach $orout (&fthrout::objectlist()) {
    $orout->datadump("\t") ;
  }
  print STDOUT "\tDumping procedures end\n" ;
}
# At call level, forgot about the master ?
if ($fulldebug) {
  print STDOUT "\tDumping calls start\n" ;
  foreach $f (&fthcall::objectlist()) {
    $f->datadump("\t") ;
  }
  print STDOUT "\tDumping calls ends\n" ;
}
if ($fulldebug) {
  print STDOUT "\tDumping modules start\n" ;
  foreach $f (&fthmod::objectlist()) {
    $f->datadump("\t") ;
  }
  print STDOUT "\tDumping modules end\n" ;
}
if ($fulldebug) {
  print STDOUT "\tDumping types start\n" ;
  foreach $f (&fthtype::objectlist()) {
    $f->datadump("\t") ;
  }
  print STDOUT "\tDumping types end\n" ;
}
if ($fulldebug) {
  print STDOUT "\tDumping all objects start\n" ;
  foreach $f (&fthobj::objectlist()) {
    $f->datadump("\t") ;
  }
  print STDOUT "\tDumping objects end\n" ;
}
#|########################################################################
if (1) {
  # Used for restart in the future or used by third party programs:
  print STDOUT $level++ . ") Printing serialized objects.\n" ;
  &printdata() ;
}
#|########################################################################
print STDOUT "Total number of defined routines is " . &fthrout::getNbself() . "\n" ;
print STDOUT "Total number of recognized called is " . &fthcall::getNbself() . "\n" ;
print STDOUT "Total number of interfaces " . &fthinter::getNbself() . "\n" ;
print STDOUT "Total number of fortran sructures " . &fthtype::getNbself() . "\n" ;
print STDOUT "Total number of interface and procedures " . &fthobj::getNbself() . "\n" ;
print STDOUT "Total number of modules " . &fthmod::getNbself() . "\n" ;
print STDOUT "Total number of bad calls initially $nbbcs reduced down to " . &fthbc::getNbself() . "\n" ;
print STDOUT "Total number of externals " . &fthext::getNbself() . "\n" ;
print STDOUT "Reused level is $reuse\n" ;
$t1=time;
print STDOUT "\n\tOver in ",$t1-$t0," seconds.\n" ;
if ($opt_www) {
  if ($opt_conf) {
    print STDOUT "You must update Apache Path\n\t$opt_cgi/../lib/perl/getin/conf/$opt_conf.pm,\nprobably $ENV{FTAGSHTML_DIR}/lib/perl/getin/conf/$opt_conf.pm\n" ;
  }
  print STDOUT "netscape -remote 'openURL($opt_www)' \&\n";
} else {
  print STDOUT "netscape -remote 'openURL(file://$DIRE/index.html)' \&\n";
}
#|########################################################################
1;
