#!/usr/bin/perl -w
# -*- Mode: cperl -*-
#|########################################################################
# ftagshtml: transforms fortran 90 or below and C source code
#            into HTML or PostScript or PDF building calls indexes.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
BEGIN {
  unless (exists $ENV{FTAGSHTML_DIR} && -d "$ENV{FTAGSHTML_DIR}") {
    die "Environment variable FTAGSHTML_DIR unknown or not a directory" ;
  }
  (@INC)=("$ENV{FTAGSHTML_DIR}/lib/perl","$ENV{FTAGSHTML_DIR}/lib/perl/ftagshtml", @INC) ;
}
#|########################################################################
use File::Copy ;
use XML::Dumper ;
use fortran ;
use cfile ;
#|########################################################################
# Reading data:
$dump = new XML::Dumper;
my $perl ;
$perl = $dump->xml2pl( "my_perl_data.xml.gz" );
my ($oos, $ftypes, $fmods, $finters, $frouts, $fcalls, $fobjs) =  @{$perl} ;
(%ofiles) = (%{$oos}) ;
&ftype::shashlist(%{$ftypes}) ;
&fmod::shashlist(%{$fmods}) ;
&finter::shashlist(%{$finters}) ;
&frout::shashlist(%{$frouts}) ;
&fcall::shashlist(%{$fcalls}) ;
&fobj::shashlist(%{$fobjs}) ;
foreach $file (keys %ofiles) {
  print STDOUT "file=$file => $ofiles{$file}\n" ;
}
#|########################################################################
print STDOUT "2) Printing serialized objects.\n" ;
$fulldebug = 1 ;
# Able to decide upon the callers...
if ($fulldebug) {
  print STDOUT "Dumping objects start\n" ;
  foreach $file (keys %ofiles) {
    $f = $ofiles{$file} ;
    $f->datadump("\t") ;
  }
  print STDOUT "Dumping objects end\n" ;
}
# A sample for printing all the routines...
if ($fulldebug) {
  print STDOUT "Dumping procedures start\n" ;
  foreach $rout (&frout::objectlist()) {
    $rout->datadump("\t") ;
  }
  print STDOUT "Dumping procedures end\n" ;
}
# At call level, forgot about the master ?
if ($fulldebug) {
  print STDOUT "Dumping calls start\n" ;
  foreach $f (&fcall::objectlist()) {
    $f->datadump("\t") ;
  }
  print STDOUT "Dumping calls ends\n" ;
}
if ($fulldebug) {
  print STDOUT "Dumping modules start\n" ;
  foreach $f (&fmod::objectlist()) {
    $f->datadump("\t") ;
  }
  print STDOUT "Dumping modules end\n" ;
}
if ($fulldebug) {
  print STDOUT "Dumping types start\n" ;
  foreach $f (&ftype::objectlist()) {
    $f->datadump("\t") ;
  }
  print STDOUT "Dumping types end\n" ;
}
#|########################################################################
if (1) {
  print STDERR "Printing call dependencies starts\n" ;
  foreach $file (keys %ofiles) {
    $f = $ofiles{$file} ;
    $f->sayCalls(0) ;
  }
  print STDERR "Printing call dependencies ends\n" ;
}
#|########################################################################
