#!/bin/ksh
eval 'exec perl -x -S $0 ${1+"$@"}'
              if $running_under_some_shell;
#!/usr/bin/perl
# -*- Mode: cperl -*-
####################################################################
# Basic CEA tex file to Html proceedable file.
# Usage: perl ../src/tex2ht.pl sophiearchi.tex > sophiedoc.tex
# Copyright (C) 2006 CEA::Olivier Cessenat.
####################################################################
use File::Basename ;
$file = shift(@ARGV) ;
open(IN,"<$file") or die "No such file or access denied for '$file'" ;
# Getting Sophie ftagshtml.pl infos:
%labels = () ;
if ( -s "../src/HTML/fth/ftagshtml.info") {
  require("../src/HTML/fth/ftagshtml.info") ;
}
$ok = 0 ;
$alltt = 0 ;
while(<IN>) {
  # Replace accents, cr and small...
  &replaceAccents() ;
  if (/^\\documentclass\[(.*)\]\{rapportcea\}/) {
    print STDOUT "\\documentclass[12pt]{article}\n";
  } elsif (/^\\usepackage\{french\}/) {
    print STDOUT "\\usepackage[french]{babel}\n";
  } elsif (/^\\usepackage\{fancyheadings\}/) {
    print STDOUT "\\usepackage{fancyhdr}\n";
  } elsif (/^(.*?)\\(defmethodp|defmethod|method)\{(.*?)\}\{(.*?)\}(.*)/ || /^(.*?)\\(classe|program)\{(.*?)\}(.*)/) {
    while(/^(.*?)\\(defmethodp|defmethod|method|classe|program)\{(.*?)\}(.*)/) {
      $method = $2 ;
      if (($method eq 'classe' || $method eq 'program') && /^(.*?)\\(classe|program)\{(.*?)\}(.*)/) {
        # 4 is empty...
        $x1 = $1 ; $x2 = $3 ;
        $_ = $4 ;
        my $name = lc($3) ;
	unless (exists $names{"$name"}) {
	  print STDERR "$method for $name does not exist\n" ;
	}
	my $fic ;
        if (exists $names{"$name"}) {
	  my $number ;
	  my $refe ;
	  my $uname = $names{$name} ;
          if ($method eq 'classe') {
	    if (exists $fthmods{$uname}) {
	      $refe = $fthmods{$uname} ;
	    } else {
	      $refe = $fthtypes{$uname} ;
	    }
	    ($fic,$number) = split(/\:/, $refe) ;
	    #print STDOUT "Looking for classe $name on $names{$name} is $refe\n" ;
          } elsif ($method eq 'program') {
	    $refe = $fthrouts{$uname} ;
	    ($fic,$number) = split(/\:/, $refe) ;
	    #print STDOUT "Looking for program $name on $names{$name} is $refe\n" ;
          }
	}
	if ($fic) {
	  my $cible = 'R_' . $names{$name} ;
          if ($alltt) {
	    print STDOUT $x1 . "\\begin{rawhtml}<A Href=../../src/HTML/fth/" . &targetname($fic) . "_c.html#$cible>\\end{rawhtml}\\" . $method. "{$x2}\\begin{rawhtml}</A>\\end{rawhtml}" ;
          } else {
	    print STDOUT $x1 . "\n\\begin{rawhtml}\n<A Href=\"../../src/HTML/fth/" . &targetname($fic) . "_c.html#$cible\">\n\\end{rawhtml}\n\\" . $method. "{$x2}\n\\begin{rawhtml}\n</A>\n\\end{rawhtml}\n" ;
          }
        } else {
	  print STDOUT $x1 . "\\" . $method . "{$x2}" ;
        }
      } elsif ($method eq "defmethodp" && /^(.*?)\\(defmethodp)\{(.*?)\}\{(.*?)\}\{(.*?)\}(.*)/) {
        $x1 = $1 ; $x2 = $3 ; $x3 = $5 ; $prot = $4 ;
        $_ = $6 ;
        $classe = lc($x2) ;
        $routine = lc($x3) ;
	my $name = $classe . '::' . $routine ;
        unless (exists $names{"$name"}) {
	  if ($x3 =~ /^(set|get|print|say|debug|cmp|is|cal|alloc|push|del|read|create|fill|cast|nullify|free|add|init|reset|mul|solve|split|send)(.*)/i) {
            $routine = lc("$1$x2$2") ;
	    $name = $classe . '::' . $routine ;
  	  }
        }
	my $fic ;
        if (exists $names{"$name"}) {
	  my $number ;
	  my $module = $names{$classe} ;
	  my $subr =  $names{$name} ;
	  my $refe = $defmethod{$module}->{$subr} ;
	  ($fic,$number) = split(/\:/, $refe) ;
	  my $cible = 'R_' . $subr ;
	  #print STDOUT "Name=$name, Module $module routine $subr defined in $refe file $fic line $number\n" ;
	}
	if ($fic) {
          if ($alltt) {
	    print STDOUT $x1 . "\\begin{rawhtml}<A Href=../../src/HTML/fth/" . &targetname($fic) . "_c.html#$cible>\\end{rawhtml}\\" . $method. "{$x2}{$prot}{$x3}\\begin{rawhtml}</A><CODE>(fichier $fic)</CODE>\\end{rawhtml}" ;
          } else {
	    print STDOUT $x1 . "\n\\begin{rawhtml}\n<A Href=\"../../src/HTML/fth/" . &targetname($fic) . "_c.html#$cible\">\n\\end{rawhtml}\n\\" . $method. "{$x2}{$prot}{$x3}\n\\begin{rawhtml}\n</A><CODE>(fichier $fic)</CODE>\n\\end{rawhtml}\n" ;
          }
        } else {
	  print STDOUT $x1 . "\\" . $method . "{$x2}{$prot}{$x3}" ;
        }
      } elsif (/^(.*?)\\(defmethod|method)\{(.*?)\}\{(.*?)\}(.*)/) {
        $x1 = $1 ; $x2 = $3 ; $x3 = $4 ;
        $_ = $5 ;
        $classe = lc($x2) ;
        $routine = lc($x3) ;
	my $name = $classe . '::' . $routine ;
        unless (exists $names{"$name"}) {
	  if ($x3 =~ /^(set|get|print|say|debug|cmp|is|cal|alloc|push|del|read|create|fill|cast|nullify|free|add|init|reset|mul|solve|split|send)(.*)/i) {
            $routine = lc("$1$x2$2") ;
	    $name = $classe . '::' . $routine ;
  	  }
        }
	my $fic ;
        if (exists $names{"$name"}) {
	  my $number ;
	  my $module = $names{$classe} ;
	  my $subr =  $names{$name} ;
	  my $refe = $defmethod{$module}->{$subr} ;
	  ($fic,$number) = split(/\:/, $refe) ;
	  my $cible = 'R_' . $subr ;
	}
	if ($fic) {
	  #print STDOUT "Name=$name, Module $module routine $subr defined in $refe file $fic line $number\n" ;
          if ($alltt) {
  	    print STDOUT $x1 . "\\begin{rawhtml}<A Href=../../src/HTML/fth/" . &targetname($fic) . "_c.html#$cible>\\end{rawhtml}\\" . $method. "{$x2}{$x3}\\begin{rawhtml}</A><CODE>(fichier $fic)</CODE>\\end{rawhtml}" ;
          } else {
  	    print STDOUT $x1 . "\n\\begin{rawhtml}\n<A Href=\"../../src/HTML/fth/" . &targetname($fic) . "_c.html#$cible\">\n\\end{rawhtml}\n\\" . $method. "{$x2}{$x3}\n\\begin{rawhtml}\n</A><CODE>(fichier $fic)</CODE>\n\\end{rawhtml}\n" ;
          }
        } else {
	  print STDOUT $x1 . "\\" . $method . "{$x2}{$x3}" ;
        }
      }
    }
    print STDOUT $_ . "\n" ;
  } elsif (/^\\begin\{module\}\[(.*)\]\\label\{(.*)\}/) {
    $module = lc($2) ;
    #die "OK $module";
    if (exists $label{"R_$module"}) {
      $file = $label{"R_$module"} ;
      if ($file =~ /(.*)\#(.*)/) {
	$file = $1 ;
      }
      print STDOUT "\\begin{rawhtml}\n<HR><ul><li>Implmentation : <A Href=\"../../src/HTML/fth/" . &targetname($file) . "_c.html\" TARGET=_top>$file</A></li></ul>\n<HR>\\end{rawhtml}\n" ;
    }
    print STDOUT ;
  } elsif (/^\\(begin|end)\{french\}/) {
    # Comment illegal french
    print STDOUT "%%\\".$1."{french}\n";
  } elsif (/^\\(begin|end)\{rapportcea\}/) {
    print STDOUT "%%\\".$1."{rapportcea}\n";
  } elsif (/\\usepackage\{html(.*)\}/) {
    print STDOUT "\\usepackage{html$1}\n";
  } elsif (/\\include\{cover(.*)\}/) {
    print STDOUT "%%\\include{cover$1}\n";
  } elsif (/^\\(begin|end)\{alltt\}/) {
    print STDOUT "\\".$1."{alltt}\n";
    $alltt = !$alltt ;
  } elsif (/^\\renewcommand\{\\baselinestretch\}(.*)/) {
    print STDOUT "%%\\renewcommand{\\baselinestretch}$1\n";
  } elsif (/^%*\\(begin|end)\{rawhtml\}/) {
    print STDOUT "\\".$1."{rawhtml}\n";
    $ok = !$ok ;
  } elsif (/^\\(begin|end)\{abstract\}/) {
    # Abstract start: set up a section level ?
    if ($1 eq 'begin') {
      print "\\section{Introduction}\\label{top::introduction}\n" ;
      print "\\subsection{Abstract}\\label{abstract}\n" ;
      print STDOUT "% $_" ;
    } else {
      print STDOUT "% $_" ;
    }
  } elsif (/^\\(section)\{Introduction\}/i) {
      print "\\subsection{Introduction}\\label{introduction}\n" ;
  } else {
    if ($ok) {
      if (/^%*(.*)/) {
        $_ = $1 . "\n" ;
      }
    }
    print STDOUT ;
  }
}
close(IN) ;
####################################################################
sub replaceAccents {
  s/\\cr/\\\\/g if (/\\cr/) ;
  s//\\'e/g if (//) ;
  s//\\`e/g if (//) ;
  s//\\`a/g if (//) ;
}
###########################################################################
sub targetname {
  my $file = shift ;
  $file = basename($file) ;
  if ($file =~ /(.*)\.(.*)/) {
    $file = $1 . '_' . $2 ;
  }
  return($file) ;
}
####################################################################
