#%################################
# \section{Fonction de sauvegarde des donnes.}
# On sauve les donnes en incrmentant ensuite le compteur.
# La variable \verb+undolevel+ contient le prochain niveau de
# sauvegarde des donnes.
sub SaveData {
    $UndoArraySize = $UndoArraySize-$undolevel ;
    $fileissaved = 0 ;
    &SaveDataUndoArray(++$UndoArraySize) ;
# On ne sauve que lorsque l'application est dans un tat stable.
    $undolevel=0 ;
}
#%################################
# \section{Undo}
# undolevel est le nombre d'undos ralis.
sub Undo {
    if ($undolevel >= $UndoArraySize) {
	&PrintStdwar("Reached maximum undo level");
    } else {
	$undolevel++ ;
    }
# On rinitialise les donnes avec le dernier niveau
# sauvegard.
    &GetDataUndoArray($UndoArraySize-$undolevel);
    &PrintStdout("Undo accepted considering level $undolevel");
    &display_values ;
}
#%################################
# \section{Redo}
sub Redo {
# On va rechercher le dernier compteur sauvegard:
# il se trouve  \verb+undolevel+ c'est  dire avant 
# le dernier indice des donnes sauvagardes aprs un Undo,
# il se trouve en dessous sinon (aprs un \verb+SaveData+
# notamment).
    if ($undolevel == 0) {
# Le niveau en cours est correct mais on peut monter
	&PrintStdwar("No more redo level");
    } else {
	$undolevel-- ;
    }
# En sortie de \verb+Redo+, le compteur \verb+undolevel+ est incrment
# si des donnes existent dans le tableau de sauvegarde \verb+UndoArray+
    &GetDataUndoArray($UndoArraySize-$undolevel);
    &display_values ;
    &PrintStdout("Redo accepted at level $undolevel");
}
1;
