#%################################################################
# \section{Cr\'eation de macros}
#%################################
# \subsection{Boutons Reset et Clear}
sub ResetClear {
# Creates the reset and the clear buttons
# that call the "\verb+father_name+" reset and clear functions.
    my($function_name,$father_name) = @_ ;
    my($path) = "${father_name}_resetclear" ;
    my($w) = "" ;
    my($wn) = "" ;
# \begin{enumerate}
# \item Frame
    ${$path} = ${$father_name}->Frame(-relief => 'raised', -borderwidth => '4');
    ${$path}->pack(-side => 'top');
# \item Bouton reset
    $w = "${father_name}_reset" ;
    $wn = "${function_name}_reset" ;
    ${$w} = ${$path}->Button(
			-text    => 'Reset', 
			-command => \&${wn},
			);
    ${$w}->pack(-side => 'left', -expand => 'y');
# \item Bouton clear
    $w = "${father_name}_clear" ;
    $wn = "${function_name}_clear" ;
    ${$w} = ${$path}->Button(
			-text    => 'Clear', 
			-command => \&${wn},
			);
    ${$w}->pack(-side => 'left', -expand => 'y');
# \item Bouton cancel
    $w = "${father_name}_cancel" ;
    $wn = "${function_name}_cancel" ;
    ${$w} = ${$path}->Button(
			-text    => 'Cancel', 
			-command => [ \&${wn}, $father_name],
			);
    ${$w}->pack(-side => 'left', -expand => 'y');
# \end{enumerate}
}
#%################################
# \subsection{Boutons Reset, Clear et OK en plus de cancel}
sub ResetClearOk {
# Creates the reset and the clear buttons
# that call the "\verb+father_name+" reset and clear functions.
    my($function_name,$father_name) = @_ ;
    my($path) = "${father_name}_resetclear" ;
    my($w) = "" ;
    my($wn) = "" ;
# \begin{enumerate}
# \item Frame
    ${$path} = ${$father_name}->Frame(-relief => 'raised', -borderwidth => '4');
    ${$path}->pack(-side => 'top');
# \item Bouton reset
    $w = "${father_name}_reset" ;
    $wn = "${function_name}_reset" ;
    ${$w} = ${$path}->Button(
			-text    => 'Reset', 
			-command => \&${wn},
			);
    ${$w}->pack(-side => 'left', -expand => 'y');
# \item Bouton clear
    $w = "${father_name}_clear" ;
    $wn = "${function_name}_clear" ;
    ${$w} = ${$path}->Button(
			-text    => 'Clear', 
			-command => \&${wn},
			);
    ${$w}->pack(-side => 'left', -expand => 'y');
# \item Bouton cancel
    $w = "${father_name}_cancel" ;
    $wn = "${function_name}_cancel" ;
    ${$w} = ${$path}->Button(
			-text    => 'Cancel', 
			-command => [ \&${wn}, $father_name],
			);
    ${$w}->pack(-side => 'left', -expand => 'y');
# \item Bouton Ok
    $w = "${father_name}_ok" ;
    $wn = "${function_name}_ok" ;
    ${$w} = ${$path}->Button(
			-text    => 'OK', 
			-command => [ \&${wn}],
			);
    ${$w}->pack(-side => 'left', -expand => 'y');
# \end{enumerate}
}
#%################################
# \subsection{Bouton Ajout entier}
sub AddInteger {
    my($function_name,$father_name,$texte,$integer) = @_ ;
    my($path) = "${father_name}_add" ;
    my($w) = "" ;
    my($wn) = "" ;
# \begin{enumerate}
# \item Frame
    ${$path} = ${$father_name}->Frame(-relief => 'raised', -borderwidth => '4');
    ${$path}->pack(-side => 'top');
# \item Bouton add
    $w = "${father_name}_val" ;
    $wn = "${function_name}_val" ;
    ${$w} = ${$path}->Button(
			-text    => $texte, 
			     -command =>
			   [
    \&validate_button, ${$w}, \$texte, \$integer, \${$integer},
                           ],
			     );
    ${$w}->pack(-side => 'left', -expand => 'y');
# \item Texte add
    $w = "${father_name}_int" ;
    $wn = "${function_name}_int" ;
    ${$w} = ${$path}->Entry
	(
	 -textvariable  => \${$integer},
	 );
    ${$w}->pack(-side => 'left', -expand => 'y');
    ${$w}->bind('<Return>',
				 [
				  \&validate_button, \$texte, \$integer, \${$integer},
				  ] );
# \end{enumerate}
}
#%################################
# \subsection{Bouton de validation.}
sub validate_button {
    my($this,$texte,$variable,$valeur) = @_ ;
    local(@err) = () ;
    if (&IsIntegerSP(${$valeur})) {
        &PrintStdout("L'entier ${$texte} est correct et positionn  ${$valeur}") ;
    } else {
#      ${$boutton}->configure(-fg => 'red',);
	&PrintStderr(@err,"L'entier ${$texte} n'est pas correct.") ;
    }
}
#%################################
# \subsection{Liste des maillages}
sub ValeursListe {
    my($function_name,$father_name,$texte,$contexte) = @_ ;
    print "Hello\n";
    my($path) = "${father_name}_topvalues" ;
    ${$path}=${$father_name}->Frame(-relief => 'raised', -borderwidth => '4',);
    ${$path}->pack(-side => 'top', -expand => 'y');
    ${$path}->Label(-text => "$texte",)->pack();
    my($wv) = "${father_name}_values" ;
    my($ws) = "${father_name}_scroll" ;
    my($wf) = "${function_name}_action" ;
    my($wd) = "${function_name}_display" ;
    my($wc) = "${father_name}_contextuel" ;
    my($wa) = "${function_name}_selected" ;
    ${$wv} = ${$path}->Scrolled("Listbox", -width => 40, -height => 6, -scrollbars => 'osw',);
    ${$wv}->pack(-side => 'left',-fill => 'both', -expand => 1,);
# Ajout d'un menu contextuel sur la liste.
    ${$wc} = ${$path}->Menu
	(
	 -tearoff => 0,
	 );
    while (($f,$t) = each %$contexte) {
	${$wc}->command(-label => "$t", -command => [\&{$f}, ${$wv}]
, -underline => 0);
    }
    ${$wv}->bind("<Button-3>",
sub {
    ${$wc}->Popup(-popover => 'cursor');
}
) ;
#
    ${$ws} = ${$wv}->Subwidget("yscrollbar");
    ${$wv}->configure
	(
	 -yscrollcommand => ['set', ${$ws}],
	 -setgrid => 'yes',
	 );
    ${$ws}->configure(-command => ['yview', ${$wv}]);
    ${$wv}->bind('<Double-Button-1>' => [\&${wf}, ${$wv}]);
#    &${wd}($father_name) ;
}

1;

