
#%################################################################
# \section{Quitter.}
#%################################
# \subsection{Cr\'eation de l'interface.}
sub QuitMenu {
    if ($quitwm) {
	$quitwm->deiconify() ;
	$quitwm->raise() ;
    } else {
	$quitwm = $MW->Toplevel() ;
	$quitwm->raise() ;
	$quitmenu = $quitwm->Frame(-relief => 'raised', -borderwidth => '4')->pack(-side => 'top') ;
	$quithead = $quitmenu->Label(-text => "Confirmer quitter",)->pack(-side => 'top', -expand => 'y');
	$quitlabel = $quitmenu->Label(-text => "",)->pack(-side => 'bottom', -expand => 'y');
	$quitboutons = $quitwm->Frame(-relief => 'raised', -borderwidth => '4')->pack(-side => 'top') ;
	$quitok = $quitboutons->Button(-text => "Oui", -command => \&QuitAnyway,)->pack();
	$quitno = $quitboutons->Button(-text => "Non", -command => sub { $quitwm->withdraw ;},)->pack(-side => 'left', -expand => 'y');
    }
}
#%################################
# \subsection{Fonction quitter le programme.}
sub QuitAnyway {
    print STDERR "$0 exited without saving\n";
    exit(1);
}
#%################################
# \subsection{Fonction associe.}
sub Quit {
    if ($fileissaved) {
	&PrintStdwar(
		    "Fichier $datafile sauv",
		    "Exit demand par l'utilisateur",
		     );
	exit(0);
    } elsif ($datafile) {
	&QuitMenu ;
	$quitlabel->configure(-text => "Travail $datafile non sauv",-fg => 'red');
    } else {
	&QuitMenu ;
	$quitlabel->configure(-text => "Travail non sauv",-fg => 'pink');
    }
}
#%################################################################
# \chapter{Aide.}
sub Help {
    &PrintStdwar("Fonction non disponible pour le moment");
}
#%################################################################
# \section{Gestion des messages.}
#%################################
# \subsection{Informations}
sub PrintStdout {
# Cration du widget Text
    my(@message) = @_ ;
    my($ligne) = "" ;
    my($total) = "" ;
    foreach $ligne (@message) {
	print STDOUT "$ligne\n" if $debug;
	$montexte->insert("end","$ligne\n",'stdout_aspect');
    }
    $montexte->see("end");
}
#%################################
# \subsection{Erreurs}
sub PrintStderr {
    my(@message) = @_ ;
    my($ligne) = "" ;
    my($total) = "" ;
    foreach $ligne (@message) {
	print STDERR "$ligne\n" if $debug;
	$montexte->insert("end","$ligne\n",'stderr_aspect');
	$total .= $ligne."\n";
    }
    $montexte->see("end");
    $base_error->configure(-text => "$total",);
    $base_error->Show;
}
#%################################
# \subsection{Warning}
sub PrintStdwar {
    my(@message) = @_ ;
    my($ligne) = "" ;
    my($total) = "" ;
    foreach $ligne (@message) {
	print STDOUT "$ligne\n" if $debug;
	$montexte->insert("end","$ligne\n",'stdwar_aspect');
	$total .= $ligne."\n";
    }
    $montexte->see("end");
    $base_warn->configure(-text => "$total",);
    $base_warn->Show;
}

1;
