package viewhtml;
#|########################################################################
# view: views a file given its HTML source with a proper format (given by
#       ftagshtml) showing specific lines provided by getin.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
use File::Basename ;
#%###################################################
sub numerique { $a <=> $b; }
#%###################################################
sub get_html_file {
    my($rep,$fic) = @_ ;
    $fic = basename($fic) ;
    return("$rep/${fic}_c.html") ;
}
#%###################################################
sub View_Core {
    my($sourcedir,$sourcefile,$lines) = @_ ;
    $htmlfile = &get_html_file($sourcedir,$sourcefile) ;
    if (open(HTML,"<$htmlfile")) {
	(@numero) = sort numerique split(/:/, $lines);
	print STDOUT "<ul>\n";
	foreach $n (@numero) {
	    print STDOUT "<li><A Href=\"#$n\">$n</A>\n";
	}
	print STDOUT "</ul>\n";
	$first = 0 ;
	$taille = $#numero ;
	while (<HTML>) {
	    chop ;
	    if ((/IMG/) && (/<IMG\sSRC="(.*?)"/)) {
		$img = $1 ;
		if ($1 =~ /^\w+/) {
		    $_ =~ s#$img#file:$sourcedir/$img# ;
		}
	    } elsif ((/LINK/) && (/<LINK\sREL=STYLESHEET\s.*?\sHREF="(.*)">/)) {
		if ($1 eq "ftagshtml.css") {
		    $_ =~ s#$1#file:$sourcedir/ftagshtml.css# ;
		}
	    }
	    if ((/<A/) && (/<A\s+Href="(.*?)"/i)) {
		$img = $1 ;
		if ($1 =~ /^\w+/) {
		    $_ =~ s#$img#file:$sourcedir/$img# ;
		}
	    }
	    if (/<!LINE=(\d+)>/) {
		$n = $1 ;
		if ($n == ($numero[$first])) {
		    print STDOUT "<A Name=$n><A><I><U>$_<FONT COLOR=GREEN>&lt;line number $n&gt;</FONT></U></I>\n" ;
		    $first++ unless ($first >= $taille) ;
		} else {
		    print STDOUT $_."\n" ;
		}
	    } else {
		print STDOUT $_."\n" ;
	    }
	}
	close(HTML) ;
    } else {
	print STDOUT "<BR> Unable to open $htmlfile\n";
    }
}
#%###################################################
sub View_WEB_Core {
    my($cgisource,$sourcedir,$sourcefile,$lines) = @_ ;
    $htmlfile = &get_html_file($sourcedir,$sourcefile) ;
    if (open(HTML,"<$htmlfile")) {
	(@numero) = sort numerique split(/:/, $lines);
	print STDOUT "<ul>\n";
	foreach $n (@numero) {
	    print STDOUT "<li><A Href=\"#$n\">$n</A>\n";
	}
	print STDOUT "</ul>\n";
	$first = 0 ;
	$taille = $#numero ;
	while (<HTML>) {
	    chop ;
	    if ((/IMG/) && (/<IMG\sSRC="(.*?)"/)) {
		$img = $1 ;
		if ($1 =~ /^\w+/) {
		    $_ =~ s#$img#$cgisource/$img# ;
		}
	    } elsif ((/LINK/) && (/<LINK\sREL=STYLESHEET\s.*?\sHREF="(.*)">/)) {
		if ($1 eq "ftagshtml.css") {
		    $_ =~ s#$1#$cgisource/ftagshtml.css# ;
		}
	    }
	    if ((/<A/) && (/<A\s+Href="(.*?)"/i)) {
		$img = $1 ;
		if ($1 =~ /^\w+/) {
		    $_ =~ s#$img#$cgisource/$img# ;
		}
	    }
	    if (/<!LINE=(\d+)>/) {
		$n = $1 ;
		if ($n == ($numero[$first])) {
		    print STDOUT "<A Name=$n><A><I><U>$_<FONT COLOR=GREEN>&lt;line number $n&gt;</FONT></U></I>\n" ;
		    $first++ unless ($first >= $taille) ;
		} else {
		    print STDOUT $_."\n" ;
		}
	    } else {
		print STDOUT $_."\n" ;
	    }
	}
	close(HTML) ;
    } else {
	print STDOUT "<BR> Unable to open $htmlfile\n";
    }
}
#%###################################################
1;
